<?php

affiliate_pages_pro_use([
	'Core/Vue',
]);


class AffiliatePagesPro_AdminMenuController extends AffiliatePagesPro_Vue
{
	protected $dev_path = 'http://localhost:8081';

	protected $update_db = true;

	protected $brand_check = true;

	protected $menu_title = 'Affiliate Pages';

	protected $icon_url = 'dashicons-money';

	protected $position = 25;

	protected $vue_primary_color = '#ff9806';

	protected $use_quill = true;

	protected $app_addons = ['prem', 'watchlist', 'apisearch', 'dev', 'btnshow', 'agency'];


	public function preConstruct()
	{
		// set custom branding
		if(!empty(self::$options) && !empty(self::$options['brand_active'])) {

			if(!empty(self::$options['brand_slug'])) {
				$this->custom_menu_slug = self::$options['brand_slug'];
			}

			if(!empty(self::$options['brand_menu'])) {
				$this->menu_title = self::$options['brand_menu'];
			}
			elseif(!empty(self::$options['brand_title'])) {
				$this->menu_title = self::$options['brand_title'];
			}

			if(!empty(self::$options['brand_menu_icon'])) {
				$this->icon_url = 'dashicons-'.self::$options['brand_menu_icon'];
			}

			if(!empty(self::$options['brand_plugins'])) {
				$this->bPluginsPage();
			}



    }
	}

	private function bPluginsPage()
	{
		add_filter( 'plugin_row_meta', function($links, $file) {

			if ( strpos( $file, 'affiliate-pages-pro.php' ) !== false ) {

				$info = affiliate_pages_pro_info();
				$text = 'Version '.$info['version'];

				$options = self::$options;

				if(!empty($options['brand_business'])) {

					$business = $options['brand_business'];
					if(!empty($options['brand_website'])) {
						$business = "<a href=\"{$options['brand_website']}\" target=\"_blank\">{$business}</a>";
					}
					$text .= ' | Licensed by '.$business;
				}

				if(self::$options['brand_user_id'] == get_current_user_ID()) {

					if(isset($business)) {
						array_push($links, ' Licensed by '.$business);
					}

				} else {
					$links = ['text' => $text];
				}


				// wp_send_json(count($links));

				// array_push($links, ['text' => $text]);
				// $links = ['text' => $text];
			}

			return $links;

		}, 10, 2 );

		add_action( 'admin_head', function(){
			?>

			<style>

				/* Plugin Name */
				tr[data-slug="affiliate-pages-pro"] td.plugin-title strong {
					display: none;
				}
				tr[data-slug="affiliate-pages-pro"] td.plugin-title::before {
					content: "<?php echo self::$options['brand_title']; ?>";
					font-weight: 600;
					display: block;
					margin-bottom: .2em;
					font-size: 14px;
				}
			<?php if(self::$options['brand_user_id'] != get_current_user_ID()) { ?>
				tr[data-slug="affiliate-pages-pro"] td.plugin-title .deactivate {
					display: none;
				}
				<?php } ?>

				/* Description */
				tr[data-slug="affiliate-pages-pro"] .plugin-description p {
					display: none;
				}
				tr[data-slug="affiliate-pages-pro"] .plugin-description::before {
					 content: "<?php if(!empty(self::$options['brand_plugin_des'])) {
					 	echo self::$options['brand_plugin_des'];
					 } ?>";
					 font-size: 13px;
		     	line-height: 1.5em;
		 			padding: 0;
					color: #32373c;
					word-wrap: break-word;
					display: block;
					margin: 0 0 8px;

				}
			</style>
			<?php
		});
	}
}
