<?php

affiliate_pages_pro_use([
	'Controllers/Api/ApiController',
	'DataTables/BlockDataTable',
	'Models/Block',
	'Models/Split'
]);


class AffiliatePagesPro_ApiBlockSplitController extends AffiliatePagesPro_ApiController
{
	protected $copy_fields = [
		// 'identifier',
		'user_id',
		'page_id',

		'block_type',
		'type_id',
		'video_id',

		'content',

		'sort',

		'video',
		'is_video',
		'start',
		'end',
		'autoplay',
		'hide_controls', // 0: no, 1: yes, 2: muted
		'poster',// (0: autohide, 1: always, 2: never )
		'poster_pause',
		'poster_end',
		'duration',
		'trim_active',
		'product_placement',
		'muted',
		'product_img',
		'auto_redirect',
		'disable_fullscreen',
		'disable_mask',

		'url',
		'target',
		'is_dark',
		'color',
		'style',
		'item_style',
		'size',
		'item_link',

		'margin',
		'margin_x',
		'margin_y',
		'padding',
		'use_margin',
		'use_padding',
		'text_color',
		'shadow',
		'item_shadow',
		'bg_color',
		'bg_image',
		'source',

		'flex_xs',
		'flex_sm',
		'flex_md',
		'flex_lg',
		'align',

		'item_height',
		'item_width',
		'item_contain',
		'aspect_ratio',
		'custom_size',
	];

	public function index($request)
	{
		$splits = AffiliatePagesPro_Split::where('block_id', $request->id)->get();

		wp_send_json($splits); exit;
	}

	public function create($request)
	{
		$block = AffiliatePagesPro_Block::where('id', $request->block_id)->first();

		if(empty($block)) {
			wp_send_json_error('no_block id:'.$request->block_id); exit;
		}

		$split = new AffiliatePagesPro_Split;

		$split->block_id = $request->block_id;

		foreach($this->copy_fields as $i) {
			if(isset($block->{$i})) {
				$split->{$i} = $block->{$i};
			}
		}

		$split->save();


		wp_send_json_success($split); exit;
	}

	public function dublicate($request)
	{

		wp_send_json($request); exit;

		// dublicate by id,
		$create = new AffiliatePagesPro_BlockDataTable;
		$block = $create->dublicate($request, true);

		// reset fields, visits, clicks
		// more split
		if(empty($block->split_id)) {
			$block->split_id = $request->id;
			$block->save();
		}

		wp_send_json(compact('block')); exit;
		// update block id

	}
}
