<?php

affiliate_pages_pro_use([
	'Controllers/Api/ApiController',
	'Models/Block',
	'Models/Split',
	'Models/Stat'
]);


class AffiliatePagesPro_ApiBlockSplitResultsController extends AffiliatePagesPro_ApiController
{

	public function destroy($request)
	{
		$i = new AffiliatePagesPro_Stat;
    $i->wpDelete(['block_id' => $request->id]);
		wp_send_json_success(); exit;
	}

	public function index($request)
	{
		$block = AffiliatePagesPro_Block::find($request->id);
		$splits = AffiliatePagesPro_Split::where('block_id', $request->id)->get(['id']);

		if(empty($splits)) {
			wp_send_json_error('no_splits'); exit;
		}

		$data = [];

		$total_visits = 0;
		$total_clicks = 0;
		$total_units = 1;
		// primary
		$visits = AffiliatePagesPro_Stat::where('block_id', $request->id)
							->andWhereNull('split_id')
							->count();

		$clicks = AffiliatePagesPro_Stat::where('block_id', $request->id)->andWhereNull('split_id')->andWhere('is_click', 1)->count();

		array_push($data, $this->getResult($request->id, $visits, $clicks, true));

		$total_visits = $total_visits + $visits;
		$total_clicks = $total_clicks + $clicks;

		// splits

		foreach($splits as $i) {
			$visits = AffiliatePagesPro_Stat::where('split_id', $i->id)->count();
			$clicks = AffiliatePagesPro_Stat::where('split_id', $i->id)->andWhere('is_click', 1)->count();
			array_push($data, $this->getResult($i->id, $visits, $clicks));

			$total_visits = $total_visits + $visits;
			$total_clicks = $total_clicks + $clicks;
			$total_units++;
		}

		$winner_index = -1;
		$winner_id = '';
		$count = 0;
		$conversion = 0;
		$winner_primary = false;
		$winner_conversion = 0;

		foreach($data as $i) {
			if($i['conversion'] == $conversion) {
				// match
				$winner_index = -1;
				$winner_id = '';
				$winner_primary = false;
			}
			elseif($i['conversion'] > $conversion) {
				$conversion = $i['conversion'];
				$winner_index = $count;
				$winner_id = $i['id'];
				$winner_primary = !empty($i['is_primary']);
			}
			if($i['conversion'] > $winner_conversion) {
				$winner_conversion = $i['conversion'];
			}
			$count++;
		}

		wp_send_json(compact('total_visits', 'total_clicks', 'total_units', 'winner_index', 'winner_id', 'winner_primary', 'winner_conversion', 'data'));

	}

	private function getResult($id, $visits = 0, $clicks = 0, $isPrimary=false) {
		if($visits > 0 && $clicks > 0) {
			$conversion = round(($clicks / $visits) * 100, 2);
		} else {
			$conversion = 0;
		}
		return ['id' => $id, 'visits' => $visits, 'clicks' => $clicks, 'conversion' => $conversion, 'is_primary' => $isPrimary];
	}
}
