<?php

affiliate_pages_pro_use([
    'Controllers/Api/ApiController',
    'Helpers/Client',
    'Helpers/StrGen',
    'Helpers/Postman',
]);

class AffiliatePagesPro_ApiLicController extends AffiliatePagesPro_ApiController
{

    use AffiliatePagesPro_Client, AffiliatePagesPro_StrGen, AffiliatePagesPro_Postman;

    protected $client_access_key_length = 128;

    public function index($request)
    {

        $lic = $this->getOption('lic');

        $response = [
            'app' => [
                'title' => self::$plugin_app_name,
                'cl' => self::$plugin_app_cl,
            ],
            'success' => !empty($lic),
        ];

        if (empty($lic)) {
            $response['success'] = false;
            $response['data'] = 'To activate or update your license, please enter your registred email and password and click update.';
        } else {
            $response['success'] = true;
            $response['data'] = $lic;
        }

        // hide if branded
        $response['app']['brandable'] = $this->hasAddon('dev');

        $o = self::$options;

        if (!empty($response['app']['brandable']) && !empty(self::$options) && !empty(self::$options['b_active'])) {
            if (!empty(self::$options['b_title'])) {
                $response['app']['title'] = self::$options['b_title'];
            }
            if (!empty(self::$options['b_logo'])) {
                $response['app']['logo'] = self::$options['b_logo'];
            }
        }

        if (empty($o) || empty($o['hide_se']) || empty($o['master_user']) || $o['master_user'] == $request->user_id) {

        } else {
            $response['app']['hide_settings'] = true;
        }

        wp_send_json($response);exit;
    }

    public function update($request)
    {

        $client_access_key = $this->StrGen($this->client_access_key_length);

        $body = [
            'email' => $request->email,
            'password' => $request->password,
            'site_url' => get_site_url(),
            'app_id' => self::$plugin_app_id,
            'client_access_key' => $client_access_key,
        ];

        $url = self::$plugin_app_host . '/api/client/lic';

        // wp_send_json([$body, $url]);exit;

        $response = $this->notify($url, $body, true);

        wp_send_json($response);exit;
    }
}
