<?php

// All Clicks

affiliate_pages_pro_use([
  'Controllers/Api/ApiController',
  'Core/Time',
  'Models/Page',
  'Models/Visit'
]);


class AffiliatePagesPro_ApiPageVisitsAllController extends AffiliatePagesPro_ApiController
{



    public function onReset($request)
    {
      // $visits = new AffiliatePagesPro_Visit;
      // $visits->wpDelete(['page_id' => $request->id]);

        wp_send_json_success();
    }

    protected function getFirst($request)
    {
      $visits = new AffiliatePagesPro_Visit;
      return $visits->orderBy('id', 'asc')->first();

    }

    protected function getVisits($start_ts, $end_ts, $is_unique=null)
    {
      $q = AffiliatePagesPro_Visit::where('created_ts', '>', $start_ts)
                                      ->andWhere('created_ts', '<', $end_ts);
      if(!empty($is_unique)) {
        $q->andWhere('is_unique', 1);
      }

      return (int) $q->count();
    }

    public function index($request)
    {

      $t = new AffiliatePagesPro_Time();

      if(empty($request->range)) {
        // 7 days
        $days = $t->getPastDays(7);
      }
      elseif(is_numeric($request->range)) {
        // x days
        $days = $t->getPastDays($request->range);
      }
      elseif($request->range == 'current_week') {
        $days = $t->getCurrentWeek();
      }
      elseif($request->range == 'current_month') {
        $days = $t->getCurrentMonth();
      }
      else { // == 'all'
        // $first = AffiliatePagesPro_Visit::where('link_id', $request->id)
        //                                 ->orderBy('created_ts', 'asc')
        //                                 ->first(['id','created_ts']);
        $first = $this->getFirst($request);

        if(empty($first)) {
          wp_send_json([
            'visits' => 0,
            'unique_visits' => 0,
            'data' => []
          ]); exit;
        }

        $num = ceil(($t->ts - (int) $first->created_ts) / 86400);

        $days = $t->getPastDays($num);

      }


      $count = 0;
      $total = 0;
      $total_unique = 0;

      foreach($days as $i) {

        $days[$count]['visits'] = $this->getVisits($i['start_ts'], $i['end_ts']);

        $total += $days[$count]['visits'];

        $days[$count]['visits_unique'] = $this->getVisits($i['start_ts'], $i['end_ts'], 1);

        $total_unique += $days[$count]['visits_unique'];

        $count++;

      }

      wp_send_json(['data' => $days, 'days' => count($days), 'visits' => $total, 'unique_visits' => $total_unique]);
    }
}
