<?php

affiliate_pages_pro_use([
	'Controllers/Api/ApiController'
]);


class AffiliatePagesPro_ApiSettingsController extends AffiliatePagesPro_ApiController
{
		protected $fields = [
													'prefix',
													'favicon',

													// defaults
													'tracking_analytics',
													'tracking_fbpixel',
													'fb_app_id',

													'topbar_name',
													'topbar_avatar',
													'topbar_avatarlink',

													'social_fb',
													'social_tw',
													'social_li',
													'social_in',
													'social_yt',

													'cookies_notice',
													'cookies_thanks',
													'cookies_button',
													'cookies_placement'
												];

		public function index($request)
		{
			wp_send_json($this->getSettings());
		}

		// can be used by other settings
		public function getSettings()
		{

			$settings = [];

			if(!empty(self::$options)) {
				foreach($this->fields as $field) {
					if(isset(self::$options[$field])) {
						$settings[$field] = self::$options[$field];
					}

				}
			}

			return $settings;
		}

		public function update($request)
		{

			$settings = $this->getOption('settings');

			if(empty($settings)) {
				$settings = [];
			}

			foreach($this->fields as $field) {

				if(isset($request->{$field})) {
					$settings[$field] = $request->{$field};
				}
			}

			if(!empty($settings['prefix'])) {
				$settings['prefix'] = sanitize_title($settings['prefix']);
			}

			// set to hide // hide_se: '',
	    // hide_pl: ''
			if(!empty($request->hide_se) || !empty($request->hide_pl)) {
				$settings['master_user'] = $request->user_id;
			}

			if(!empty($settings['dash_slug'])) {
				$settings['dash_slug'] = sanitize_title($settings['dash_slug']);
			}
			$this->updateOption('settings', $settings);

			// amazon auth


			wp_send_json_success($settings);
		}

}
