<?php

affiliate_pages_pro_use([
	'Controllers/Api/ApiController'
]);


class AffiliatePagesPro_ApiSettingsBrandingController extends AffiliatePagesPro_ApiController
{
		protected $fields = [
													'brand_active',
													'brand_title',
													'brand_menu',
													'brand_color',
													'brand_logo_src',
													'brand_logo_href',
													'brand_business',
													'brand_website',
													'brand_premium',
													'brand_licensed_to',
													'brand_logo_src',
													'brand_logo_href',
													'brand_plugins',
													'brand_plugin_des',
													'brand_menu_icon'
													// 'brand_user_id',
												];

		public function update($request)
		{

			// wp_send_json($request); exit;

			$settings = $this->getOption('settings');

			$settings['brand_user_id'] = $request->user_id;

			if(empty($settings)) {
				$settings = [];
			}

			foreach($this->fields as $field) {

				if(isset($request->{$field})) {
					$settings[$field] = $request->{$field};
				}
			}

			// slug
			if(!empty($request->brand_title)) {
				$settings['brand_slug'] = sanitize_title($request->brand_title);
			}

			if(!empty($settings['brand_slug']) && strlen($settings['brand_slug']) < 7) {
				$settings['brand_slug'] += '-'.uniqid(true);
			}

			$this->updateOption('settings', $settings);

			$url = get_admin_url().'admin.php?page=';

			if(!empty($settings['brand_slug']) && !empty($settings['brand_active'])) {
				$url .= $settings['brand_slug'];
			} else {
				$url .= self::$plugin_app_cl;
			}
			$url .= '#/settings';

			wp_send_json_success(['admin_url' => $url]); exit;
		}

}
