<?php


trait AffiliatePagesPro_DashController_loadUserDash
{
  public function loadUserDash()
  {
    $options = AffiliatePagesPro::$options;

    if(empty($options['dash_active'])) {
      return;
    }

    $userId = get_current_user_ID();

    // echo 'load user dash '.$userId; exit;

		// if not logged in, login required
		if(empty($userId)) {
			if(!empty($options['login_url'])) {
				$url = $options['login_url'];
			} else {
				$url = wp_login_url($this->rootRoute($options['dash_slug']));
			}
			wp_redirect($url); exit;
		}

    $styles = [
      'https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900',
      'https://use.fontawesome.com/releases/v5.6.0/css/all.css',
      'https://fonts.googleapis.com/css?family=Material+Icons',
      '/client/css/chunk-vendors',
      '/client/css/chunk-vendors',
      '/client/css/app'
    ];

    $scripts = [
      '/client/js/chunk-vendors',
      '/client/js/app'
    ];

    $dataTags = [
      'api' => $this->route('/api').'/user/'.$userId,
      'siteurl' => get_site_url(),
      'token' => AffiliatePagesPro_Auth::userGet(),
			'user' => $userId,
    ];

		if(!empty($options['user_prem'])) {
			$dataTags['prem'] = 1;
		}

		// logout btn
		if(!empty($options['user_logout'])) {
			if(!empty($options['logout_url'])) {
				$dataTags['logout'] = $options['logout_url'];
			} else {
				$dataTags['logout'] = wp_logout_url();
			}
		}

		// wp_send_json($dataTags); exit;

    $this->view('dash.index', compact('styles', 'scripts', 'dataTags'));
		exit;
  }
}
