<?php

affiliate_pages_pro_use([
	'Controllers/Controller',
	'Core/VuePage',
]);

class AffiliatePagesPro_EmbedController extends AffiliatePagesPro_Controller
{
  public function index($request)
  {
    $video = AffiliatePagesPro_Video::where('identifier', $request->id)->first();

    if(empty($video)) {
      exit;
    }

		$data = [
			'embed' => $request->id,
			'sid' => $video->getEmbedId(3600)
		];

		if(!empty($video->banner_color)) {
			$data['color'] = $video->banner_color;
		}

		// default 1 hour

		$vue = new AffiliatePagesPro_VuePage($data);

		return $vue->view();

    return $this->view('embed.index', compact('video'));
  }

  public function snippet($request)
  {
		$part = explode('.js', $request->id);
		$id = $part[0];

		$video = AffiliatePagesPro_Video::where('identifier', $id)->first(['footer', 'footer_active', 'disable_banner', 'banner_color', 'style_pop']);

		$url = $this->route('embed/'.$id);

		$bannerHeight = 64;

		if(!empty($video->disable_banner)) {
			$bannerHeight = 0;
		}

		$open = '<div id="'.$id.'_w" style="width: 100%;max-width: 100%;min-width:300px;margin:auto;clear:both;margin-bottom:20px;margin-top:0px;';

		if(!empty($video->style_pop)) {
			$open .= '-webkit-box-shadow: 1px 1px 5px 0px rgba(0,0,0,0.5);-moz-box-shadow: 1px 1px 5px 0px rgba(0,0,0,0.5);box-shadow: 1px 1px 5px 0px rgba(0,0,0,0.5);';

      if($video->style_pop == 1) {
        $open .= 'border: solid 2px #fff;';
      }
      elseif($video->style_pop == 2) {
        $open .= 'border: solid 2px #1c1c1c;';
      }
      if($video->style_pop == 3 && !empty($video->banner_color)) {
        $open .= 'border: solid 2px '.$video->banner_color.';';
      }
		}


		$open .= '"><div id="'.$id.'_c" style="position: relative;padding-bottom: 56.25%;padding-top:0px;overflow: hidden;border:none;padding-top:'.$bannerHeight.'px"><iframe id="'.$id.'_i" src="'.$url.'" style="position: absolute;top: 0;left: 0;width: 100%;height: 100%; padding:0px; margin: 0px" frameborder="0" allowfullscreen="true" webkitallowfullscreen="true" mozallowfullscreen="true" allow="autoplay; fullscreen" scrolling="no"></iframe></div>';

		$footer = '';

		$close = '';

		if(!empty($video->footer_active)) {
			// $footer = str_replace('', '', $video->footer);
			$footer = str_replace('\\', '', $video->footer);//$video->footer;//str_replace("'", "\'", $footer);

			// $footer = $video->footer;
			$open .= '<div id="'.$id.'_f" style="padding:8px;color:#9e9e9e;font-size:14px;background:#000000;font-family:Roboto,sans-serif">';
			$close = '</div>';
		}

		$close .= '</div>';

		return $this->viewJS('embed.snippet', compact('open', 'close', 'id', 'footer'));
  }
}
