<?php

affiliate_pages_pro_use([
  'Controllers/Controller',
  'Models/Page',
  'Models/Click',
  'Models/Stat',
]);


class AffiliatePagesPro_PageClickController extends AffiliatePagesPro_Controller
{
  public function index($request)
  {

    $visit = AffiliatePagesPro_Visit::where('identifier', $request->visit)->first();

    if(!empty($visit)) {

      $page = AffiliatePagesPro_Page::find($visit->page_id, ['id', 'affiliate_link', 'title']);

    }
    // no more visitor, cleared stats
    else {
      $page = AffiliatePagesPro_Page::where('slug', $request->slug)->first(['id', 'affiliate_link', 'title']);
    }

    if(empty($page)) {
      return;
    }

    if(empty($page->affiliate_link)) {
      $page->message = 'Please add your affiliate link to your affiliate page.';
      $this->view('page.message', compact('page')); exit;
    }

    // save visit if found
    if(!empty($visit)) {

        $stat = AffiliatePagesPro_Stat::where('visit_id', $visit->id)->first(['id']);
        if(!empty($stat)) {
          $stat->is_click = 1;
          $stat->click_ts = current_time('U');
          $stat->save();
        }

    }

    $page->addClick($request->visit);

    $visit = AffiliatePagesPro_Visit::where('identifier', $request->visit)->first();

    if(!empty($visit)) {
      $stat = AffiliatePagesPro_Stat::where('visit_id', $visit->id)->first(['id']);
      if(!empty($stat)) {
        $stat->is_click = 1;
        $stat->click_ts = current_time('U');
        $stat->save();
      }
    }

    wp_redirect($page->affiliate_link);
    exit;
  }
}
