<?php

/*
18.9.18
Better: default getColumns

*/

affiliate_pages_pro_use([
    'Core/Inflector',
    'Core/DataTable/GetRecords',
    'Core/DataTable/Update',
    'Core/DataTable/Show',
    'Core/DataTable/Create',
    'Core/DataTable/Delete',
    'Core/DataTable/Unique',
    'Core/DataTable/Dublicate',
    'Core/DataTable/Slug',
    'Helpers/Parses/ParseNumbers'
]);

abstract class AffiliatePagesPro_DataTable extends AffiliatePagesPro
{
    use AffiliatePagesPro_DataTableGetRecords,
        AffiliatePagesPro_DataTableUpdate,
        AffiliatePagesPro_DataTableShow,
        AffiliatePagesPro_DataTableCreate,
        AffiliatePagesPro_DataTableDelete,
        AffiliatePagesPro_DataTableUnique,
        AffiliatePagesPro_DataTableDublicate,
        AffiliatePagesPro_ParseNumbers,
        AffiliatePagesPro_DataTableSlug;

    protected $builder;

    protected $primary_key = 'id';

    protected $default_limit = 50;

    protected $list_fields = '*';

    protected $search_fields = ['id', 'name'];

    protected $use_pagination = true;

    protected $sort_by = 'id';

    protected $strip_slashes = true;

    protected $query_filters;

    protected $format;

    // first field is key, second text
    protected $menu_format_fields = ['id', 'name'];

    protected $use_list_columns = false;

    protected $custom_list_columns;// = ['id' => ['numeric', ['width' => 40]]];

    protected $use_list_perpage = true;

    protected $belongs_to_many;

    protected $pivot_columns; // for update

    protected $parse_numbers = false;

    protected $parse_results = false;

    protected $remove_null_values = true;

    protected $use_db_user_id = false;

  	protected $user_id;

    protected $use_allow = false;

    protected $use_query_fields = false;

    protected $left_join;

    protected $create_default_values;

    protected $sort_append_on_create = false;

    protected $sort_append_on_create_match;

    protected $use_identifier = false;

    protected $unique_fields;

    protected $slug_on_create;

    // protected $use_no_sort = false;

    protected $dublicate_ignore_fields = ['id', 'identifier', 'sort', 'is_active', 'created', 'updated'];

    protected $ignore_fields_on_update = ['visits', 'visits_unique', 'clicks', 'clicks_unique'];

    protected $dublicate_copy_append_text = ' (COPY)';

    abstract public function builder();

    public function __construct()
    {
        $this->builder = $this->builder();
    }

    public function getListColumns()
    {
        $cols = [];
        foreach($this->list_fields as $key => $value) {
            $entry = ['field' => $key, 'label' => $value];
            if(!empty($this->custom_list_columns[$key])) {
                if(!is_array($this->custom_list_columns[$key])) {
                    $this->custom_list_columns[$key] = [$this->custom_list_columns[$key]];
                }
                foreach($this->custom_list_columns[$key] as $i) {
                    if(is_array($i)) {
                        foreach($i as $key3 => $value3) {
                            $entry[$key3] = $value3;
                        }
                    } else {
                         $entry[$i] = true;
                    }

                }
            }
            array_push($cols, $entry);
        }
        return $cols;
    }





    public function getUpdateFields() {


        if(!empty($this->update_fields)) {
            return $this->update_fields;
        }

        // second option
        elseif(!$this->builder->getUpdatables()) {
            return $this->builder->getUpdatables();
        }

        $cols = $this->builder->getFillables();
        $fields = [];
        foreach($cols as $col) {
            if(!in_array($col, ['id','identifier','created', 'updated'])) {
                array_push($fields, $col);
            }
        }

       return $fields;
    }

    public function getItemFields() {
        return $this->builder->getFillables();
        // return [
        //     'name', 'subject', 'html', 'text'
        // ];
    }


    public function getMenuFormat($results)
    {
        return $results;
    }

    /**
     * Format results for menu lists
     * @param  [type] $results [description]
     * @return [type]          [description]
     */
    public function formatResults($results)
    {
        $items = [];

        $fields = $this->menu_format_fields;

        $id = array_shift($fields);

        if($this->format == 'menu') {

            foreach($results as $item) {

                $t = '';

                foreach($fields as $f) {

                    if(!empty($item->{$f})) {
                        $t .= $item->{$f};
                    }

                }

                array_push($items, ['text' => $t, 'value' => $item->{$id}]);
            }

        }

        return $items;
    }

    /**
     * allows to use query filters
     * @param  [type] $request [description]
     * @param  [type] $filters [description]
     * @return [type]          [description]
     */
    public function queryFilters($request, $filters) {

        foreach($filters as $i) {

            if(!empty($request->{$i})) {
              // echo 'and with: '.ucfirst($i).' '.$request->{$i}; exit;
                $this->builder->andWith(ucfirst($i), $request->{$i});
            }

            $key = 'no_'.$i;

            if(!empty($request->{$key})) {
                $this->builder->andWithout(ucfirst($i), $request->{$key});
            }

        }
    }

    public function getListFields()
    {
        $fields = array_keys($this->list_fields);

        if(!in_array($this->primary_key, $this->list_fields)) {
            array_push($fields, $this->primary_key);
        }

        return $fields;
    }

    public function hasSearchQuery($request) {
        return count(array_filter($request->only(['column', 'operator', 'value']))) === 3;
    }

    public function getColumns()
    {
      $cols = $this->builder->getFillables();

      $columns = ['id' => 'ID'];

      foreach($cols as $i) {
        $columns[$i] = ucwords(str_replace('_',' ', $i));
      }

      return $columns;
    }



    protected function resolveQueryParts($operator, $value)
    {
        return array_get([
            'equals' => [
                'operator' => '=',
                'value' => $value
            ],
            'contains' => [
                'operator' => 'LIKE',
                'value' => "%{$value}%"
            ],
            'starts_with' => [
                'operator' => 'LIKE',
                'value' => "{$value}%"
            ],
            'ends_with' => [
                'operator' => 'LIKE',
                'value' => "%{$value}"
            ],
            'greater_than' => [
                'operator' => '>',
                'value' => $value
            ],
            'less_than' => [
                'operator' => '<',
                'value' => $value
            ],
            'greater_than_or_equal_to' => [
                'operator' => '>=',
                'value' => $value
            ],
            'less_than_or_equal_to' => [
                'operator' => '<=',
                'value' => $value
            ],
        ], $operator);
    }
}
