<?php

if(trait_exists('AffiliatePagesPro_DataTableCreate')) {
    return;
}

trait AffiliatePagesPro_DataTableCreate
{
    // run just before save new
    public function onCreate()
    {
    }

    // returns next sort, and moves all after one forward

    public function createSortAfter($id) {

      $query = $this->builder()->_where('id',$id);

      if(!empty($this->sort_append_on_create_match)) {
        $key = $this->sort_append_on_create_match;
        $query->andWhere($this->sort_append_on_create_match, $this->builder->{$key});
      }

      $item = $query->first(['id', 'sort']);

      if(empty($item) || empty($item->sort)) {
        return 1;
      }

      // get all blocks after sort
      $blocks = $this->builder()->_where('sort', '>', $item->sort)->orderBy('sort', 'asc', true)->get(['id', 'sort']);

      if(!empty($blocks)) {
        foreach($blocks as $block) {
          if(!empty($block->sort)) {
            $update = $this->builder()->_where('id',$block->id)->first(['id']);
            $update->sort = $block->sort + 1;
            $update->save();
          }
        }
      }

      return $item->sort+1;

    }

      public function onCreateRequestFilter($request)
      {
        return $request;
      }

      public function create($request, $returnItem=false, $useRequestGetFields=false)
      {
        $this->request = $request;

        $request = $this->onCreateRequestFilter($request);

          $fields = $this->getItemFields();

        if(!empty($useRequestGetFields)) {
          foreach($fields as $i) {
              if(!empty($request->{$i})) {
                  $this->builder->{$i} = $request->{$i};
              }
          }
        }
        else {
          foreach($fields as $i) {
              if(!empty($request->post_data[$i])) {
                  $this->builder->{$i} = $request->{$i};
              }
          }
        }


          if(!empty($this->use_db_user_id)) {
            $this->builder->user_id = $request->user_id;
          }

          // defaults
          if(!empty($this->create_default_values)) {
            foreach($this->create_default_values as $key => $value) {

              if(isset($this->builder->{$key}) == false) {
                $this->builder->{$key} = $value;
              }
            }
          }

          // sort
          if(in_array('sort', $fields)) {

            if(!empty($request->sort_after)) {
              $this->builder->sort = $this->createSortAfter($request->sort_after);
            }
            elseif($this->sort_append_on_create) {
              $query = $this->builder();
              if(!empty($this->sort_append_on_create_match)) {
                $key = $this->sort_append_on_create_match;
                $query->_where($this->sort_append_on_create_match, $this->builder->{$key});
              }

              $last = $query->orderBy('sort', 'desc', true)->first(['id', 'sort']);

              if(empty($last)) {
                $this->builder->sort = 1;
              }
              else {
                $this->builder->sort = $last->sort + 1;
              }

            }
          }


          if(in_array('slug', $fields)) {

            if($this->slug_on_create && empty($this->builder->slug)) {
              $key = $this->slug_on_create;
              if(!empty($this->builder->{$key})) {
                $this->builder->slug = sanitize_title($this->builder->{$key});
              }
              else {
                $this->builder->slug = uniqid(true);
              }

            }
          }

          // run just before save new
          $this->onCreate();

          if(!empty($this->unique_fields)) {
            $this->createValidateUniques();
          }

          $this->builder->save();


          if(!empty($this->belongs_to_many) && !empty($request->{$this->belongs_to_many[1]})) {

            $this->onCreatePivots($request, $this->belongs_to_many);

          }

          if(!empty($returnItem)) {
            return $this->builder;
          }

          if(!empty($request->return_object)) {
            wp_send_json($this->builder); exit;
          }

          $response = [
            'created_id' => $this->builder->id
          ];

          if(!empty($this->builder->sort)) {
            $response['sort'] = $this->builder->sort;
          }
          wp_send_json($response); exit;
      }

      private function createValidateUniques()
      {
        $fields = $this->unique_fields;

        if(!is_array($fields)) {
          $fields = [$fields];
        }

        foreach($fields as $field) {

          $value = $this->builder->{$field};

          $query = $this->builder();

          $exists = $query->_where($field, $value)->first(['id']);

          if(!empty($exists)) {
            $this->builder->{$field} = $this->getUniqueNext($field, $value);
          }
        }
      }




      /**

      **/
      private function onCreatePivots($request, $data) {

        $pivotCol = $this->builder->getPivotColumn();

        $relatedId = $request->{$data[1]};

        $relatedName = AffiliatePagesPro::getPrefix().$data[0];

        $related = new $relatedName();

        $relatedCol = $this->builder->getPivotColumn($related->getTable());

        $pivotTable = $this->builder->getPivotTableName($related->getTable());

        $entry = [
          $pivotCol => $this->builder->id,
          $relatedCol => $relatedId
        ];

        // Update Pivot Columns
        if(!empty($this->update_pivot) && is_array($this->update_pivot)
          && !empty($this->update_pivot['columns'])) {
          foreach($this->update_pivot['columns'] as $field) {
            if(!is_array($field) && isset($request->{$field})) {
              $entry[$field] = $request->{$field};
            }
          }
        }

        $this->builder->insertRow($pivotTable, $entry);
      }
}
