<?php

if(trait_exists('AffiliatePagesPro_DataTableGetRecords')) {
    return;
}

trait AffiliatePagesPro_DataTableGetRecords
{

    // Sample
    // public function indexx($request)
    // {
    //     $cols = $this->getColumns();

    //     $keys = $this->getColumnKeys();

    //     $columns = $this->getDisplayColumns();

    //     wp_send_json([$cols, $keys, $columns]);
    // }

    protected $allow_select = true;
    protected $allow_multiselect = false;
    protected $allow_create = true;
    protected $allow_edit = true;
    protected $allow_delete = true;
    protected $allow_dublicate = false;

    // CUSTOM OPTIONS

    public function recordsFilter($records) {
      return $records;
    }

    public function getQueryFields()
    {
        return $this->getColumnKeys();
    }

    public function getMenuFields()
    {
        return $this->getColumnKeys();
    }


    public function getSearchFields()
    {
        return ['title'];
    }

    // Search Filters Pivots
    public function getQueryFilters()
    {
    }


    public function index($request)
    {

      if(!empty($this->left_join)) {
        if(is_array($this->left_join[0])) {
          foreach($this->left_join as $leftJoin) {
            $this->builder->leftJoin($leftJoin[0], $leftJoin[1]);
          }
        } else {
          $this->builder->leftJoin($this->left_join[0], $this->left_join[1]);
        }
      }


      $this->request = $request;

      if(!empty($this->use_db_user_id)) {
        $this->builder->addQueryWhere(" user_id = ".$request->user_id);
      }

      if(!empty($this->belongs_to_many) && !empty($request->{$this->belongs_to_many[1]})) {
        $id = $request->{$this->belongs_to_many[1]};
        $this->builder->addBelongsToMany($this->belongs_to_many, $id);
      }


        // Defaults
        if(empty($request->limit)) {
            $request->limit = $this->default_limit;
        }

        // set page
        if(!empty($request->page)) {
            $this->builder->page($request->page);
        }

        if(!empty($request->q)) {

          $fields = $this->getSearchFields();

          // wp_send_json($fields); exit;

            $this->builder->newSearch($fields, $request->q);

        }

        // Tags
        if(!empty($request->tags)) {

          $args = [
            'model' => 'Tag',

          ];
          // $this->builder->addBelongsToMany($args, 1);
          $pivotTable = 'wp_mlalp219_tag_video';
          // $relatedTable = '';
          // $this->query_innerjoin = " INNER JOIN wp_mlalp219_tag_video ON {$relatedTable}.id = {$pivotTable}.{$b}";
          // echo 1; exit;
          // $this->builder->query_innerjoin = "{$pivotTable} ON wp_mlalp219_links.id = wp_mlalp219_tag_video.link_id WHERE wp_mlalp219_tag_video.tag_id = 1";

          // echo $this->builder->query_innerjoin; exit;

          // echo $this->query_innerjoin; exit;

          // foreach($request->tags as $tag) {
          //   $this->builder->leftJoin('tag', [['id' => 'tag_id'], 'tag']);
          // }
          //
          // $this->builder->addBelongsToMany($this->belongs_to_many, 1);

          /*
          $query .= " INNER JOIN {$pivotTable} ON {$relatedTable}.id = {$pivotTable}.{$b}";

           */
        }

        // Pagination and Limits
        if($this->use_pagination) {
         $this->builder->paginate($request->limit);
        }
        else {
            $this->builder->take($request->limit);
        }


        if(!empty($this->query_filters)) {
            $this->queryFilters($request, $this->query_filters);
        }

        // Get Records

        if(!empty($request->idlist)) {
            $records = $this->getIdListRecords($request);
        }
        elseif(!empty($request->menuformat)) {
            $records = $this->getMenuRecords($request);
        } else {
            $records = $this->getRecords($request);
        }

        // customise response

        wp_send_json($records); exit;
    }

    protected function parseResults($results)
    {
      $list = [];

      foreach($results as $result) {
        array_push($list,$this->parseResult($result));
      }

      return $list;
    }

    protected function parseResult($result)
    {
      $entry = [];
      foreach($result as $key => $value) {
          if(!is_null($value)) {
            if(is_float($value)) {
              $entry[$key] = (float) $value;
            }
            // elseif(is_numeric($value)) {
            //   $entry[$key] = (int) $value;
            // }
            elseif($value == 'false') {
              $entry[$key] = false;
            }
            elseif($value == 'true') {
              $entry[$key] = true;
            }
            else {
              $entry[$key] = $value;
            }

          }

          elseif(!$this->remove_null_values) {
            $entry[$key] = $value;
          }
        }
        return $entry;
    }

    public function getRecords($request)
    {
      // wp_send_json($this->getColumnKeys()); exit;
        $records = $this->builder->get($this->getColumnKeys());

        if($this->parse_results && !empty($records['results'])) {
          $records['results'] = $this->parseResults($records['results']);
        }

        $records = $this->recordsFilter($records);

        if(!empty($records['pagination'])) {
            $records['pagination']['perpage'] = $request->limit;
        }

        if(!empty($this->use_list_columns)) {
            $records['columns'] = $this->getDisplayColumns();
        }

        if($this->use_query_fields) {

          $query_fields = $this->getQueryFields();

          if(!empty($query_fields)) {
            $records['query_fields'] = $query_fields;
          }
        }

        if($this->use_allow) {
          $records['allow'] = [
              'select' => $this->allow_select,
              'multiselect' => $this->allow_multiselect,
              'create' => $this->allow_create,
              'edit' => $this->allow_edit,
              'delete' => $this->allow_delete,
              'dublicate' => $this->allow_dublicate
          ];
        }
        return $records;
    }

    public function getIdListRecords($request)
    {
        $records = $this->builder->get(['id']);
        $records['results'] = $this->getIdList($records['results']);
        return $records;
    }

    public function getMenuRecords($request) {
        echo 'get menu fields'; exit;
    }





    public function getDisplayColumns () {

        $cols = $this->getColumns();

        if(empty($cols)) {
            return [];
        }

        $columns = [];

        foreach($cols as $key => $value) {

          // if(is_numeric($key)) {
          //   echo 'number: '.$key; exit;
          // }

            $entry = ['field' => $key];

            if(is_array($value)) {
                foreach($value as $key2 => $value2) {
                    $entry[$key2] = $value2;
                }
            }
            else {
                $entry['label'] = $value;
            }

            array_push($columns, $entry);
        }

        return $columns;

    }

    public function getColumnKeys()
    {
        $keys = []; $cols = $this->getColumns();

        foreach($cols as $key => $value) {

          if(is_numeric($key)) {
            array_push($keys, $value);
          } else {
            array_push($keys, $key);
          }
        }

        return $keys;
    }




    public function getIdList($list, $key='id') {
        $ids = [];
        foreach($list as $item) {
            array_push($ids, $item->{$key});
        }
        return $ids;
    }

}
