<?php

if(trait_exists('AffiliatePagesPro_DataTableUpdate')) {
    return;
}

trait AffiliatePagesPro_DataTableUpdate
{

  public function updatePivotColumns($request)
  {
    $doUpdate = false;

    wp_send_json($request); exit;
  }

  public function updateGetItem($request, $fields=['id'])
  {
    if(!empty($this->use_db_user_id)) {

      $item = $this->builder->where('id', $request->id)
                            ->andWhere('user_id', $request->user_id)
                            ->first($fields);

    } else {
      $item = $this->builder->find($request->id, $fields);

    }

    if(empty($item)) {
      wp_send_json_error('not_found'); exit;
    }

    return $item;

  }

  // added v.1.0.4
  public function updateFilter($item, $request) {
    return $item;
  }

  public function update($request)
  {

    $this->request = $request;

    $item = $this->updateGetItem($request);


      if(!empty($request->sort_move)) {
        $this->onUpdateSort($request->id, $request->sort_move);
      }

      $updatables = $this->getUpdateFields();

      if(!empty($request->post_data)) {

        foreach($request->post_data as $key => $value) {
          if(in_array($key, $updatables) == true) {
            $item->{$key} = $value;
          }
        }


        if(!empty($this->unique_fields)) {
         $item = $this->updateValidateUniques($item);
        }

        $item = $this->updateFilter($item, $request);

        $item->save();
      }

      wp_send_json($item); exit;
  }

  // returns item
  private function updateValidateUniques($item)
  {
    $fields = $this->unique_fields;

    if(!is_array($fields)) {
      $fields = [$fields];
    }

    foreach($fields as $field) {

      if(isset($item->{$field})) {

        $value = $item->{$field};

        $query = $this->builder();

        $exists = $query->_where($field, $value)->andWhere('id', '!=', $item->id)->first(['id']);

        if(!empty($exists)) {
          $item->{$field} = $this->getUniqueNext($field, $value, $item->id);
        }

        }

    }

    return $item;
  }

  // Global DataTable move sort

  public function onUpdateSort($id, $sort='up')
  {
    // already verified user has this
    $item = $this->builder->find($id, ['id', 'sort']);

    if($sort == 'up') {

      $move = $this->builder->where('sort', '<', $item->sort)->orderBy('sort', 'desc', true)->first(['id', 'sort']);

      if(!empty($move)) {

        $move->sort = $item->sort;
        $move->save();
        $item->sort = $item->sort-1;
        $item->save();
      }
    }

    // move down
    else {

      $move = $this->builder->where('sort', '>', $item->sort)->orderBy('sort', 'asc', true)->first(['id', 'sort']);

      if(!empty($move)) {

        $move->sort = $item->sort;
        $move->save();
        $item->sort = $item->sort+1;
        $item->save();
      }

    }

    wp_send_json_success(); exit;

  }




  public function onSortUp($request)
	{
    return $this->onUpdateSort($request->id, 'up');
	}

  public function onSortDown($request)
	{
    return $this->onUpdateSort($request->id, 'down');
	}


}
