<?php

/**
 *
 * Include Required core in file using this class
 *
 * requires:
 * 
	'Core/Mail/Mailgun',
	'Core/Mail/WP'

 */


if(class_exists('AffiliatePagesPro_Mail')) {
    return;
}

affiliate_pages_pro_use([
	'Core/Mail/Mailgun',
    'Core/Mail/WP',
    'Core/Mail/TrackClicks'
]);

class AffiliatePagesPro_Mail// extends AffiliatePagesPro
{

	use AffiliatePagesPro_Mail_Mailgun, 
		AffiliatePagesPro_Mail_WP, 
		AffiliatePagesPro_Mail_TrackClicks;


	protected $provider = 'wp';

	protected $to;

	protected $subject;

	protected $html;

	protected $text;


	protected $customise_message = false;

	protected $domain;

	protected $api_key;

	// defaults to blog admin
	protected $from_email;
	
	// defaults to blog admin
	protected $from_name;

	protected $charset;

	// protected $email_field;
	// protected $mail_subject;
	// protected $mail_html;
	// protected $mail_text;
	// protected $mail_headers;
	// protected $mail_attachements;
	protected $customise_columns = ['subject', 'html', 'text'];

	protected $email_field = 'email'; // objects

	protected $name_field; // option when address to

	protected $custom_vars;

	public function __construct()
	{
		// defaults
		$this->from_email = get_bloginfo('admin_email');
		$this->from_name = get_bloginfo('name');
		$this->charset = get_bloginfo('charset');
	}

	/**
	 * [send description]
	 * @param  [type] $to           [description]
	 * @param  [type] $subject      [description]
	 * @param  [type] $html         [description]
	 * @param  [type] $text         [description]
	 * @param  [type] $headers      [description]
	 * @param  array  $attachements [description]
	 * @return [type]               [description]
	 */
	// public function send($to=null, $subject=null, $html=null, $text=null, $headers=null, $attachements=null)



	public static function contact($email, $recipient, $options=null)
	{
		return (new static)->send($email, $recipient, $options);
	}


	public function send($email, $recipient, $options=[]) {

		if(!empty($options)) {
			$this->config($options);
		}

		foreach(['subject', 'html', 'text'] as $i) {

			if(!empty($email->{$i})) {
				$this->{$i} = $email->{$i};
			}
		}

		if(!empty($this->html)) {
			$this->html = str_replace('\\','',$this->html);
		}


		// $this->trackClicks();
		// echo htmlspecialchars($this->html); exit;


		// BATCH BREAK OFF
		
		// check if multipe
		if(is_array($recipient)) {

			$batch = $this->provider.'Batch';
			return $this->{$batch}($recipient);
		}

		// SINGLE

		// customise 
		if($this->customise_message) {
			foreach($this->customise_columns as $i) {
				// if(!empty($email->{$i})) {
				// 	$email->{$i} = $this->customise($email->{$i}, $recipient);
				// }

				if(!empty($this->{$i})) {
					$this->{$i} = $this->customise($this->{$i}, $recipient);
				}

			}
		}

		$this->to = $this->getToField($recipient);
		
		// smart method
		// return $this->{$this->provider}($this->to, $email->subject, $email->html, $email->text);
		return $this->{$this->provider}();
	}

	private function getToField($recipient) 
	{
		// use email if not using name and email
		if(empty($this->name_field)) {
			return $recipient->{$this->email_field};
		}

		if(is_array($this->name_field)) {
			$to = '';
			foreach ($this->name_field as $field) {
				if(!empty($recipient->{$field})) {
					$to .= $recipient->{$field}.' ';
				}
			}
		} else {
			$to = $recipient->{$this->name_field}.' ';
		}

		return $to.'<'.$recipient->{$this->email_field}.'>';
	}

	public function config($options=[])
	{
		// wp_send_json($options); exit;

		foreach($options as $key => $value) {
			$this->{$key} = $value;
		}
		//wp_send_json([$options, $this->name_field]); exit;
	}

	private function customise($str, $item, $fields=null) {

		if(is_object($item)) {
			foreach($item as $key => $value) {
				$str = str_replace('{'.$key.'}', $value, $str);
			}
		}

		return $str;
	}

}