<?php

if(class_exists('WLRLicenseManager_MenuPage')) {
    return;
}

affiliate_pages_pro_use([
  'Controllers/Admin/AdminController',
	// 'Helpers/Routes',
	'Helpers/EnqueSimple2',
	// 'Helpers/View',
	'Helpers/StrGen',
	'Helpers/User/UserToken',
	'Helpers/Form',
	'Helpers/Nonce',
	'Packages/Auth/Auth',
  'Helpers/Client'
]);

class AffiliatePagesPro_MenuPage extends AffiliatePagesPro_AdminController
{
	use AffiliatePagesPro_Routes,
		AffiliatePagesPro_EnqueSimple2,
		AffiliatePagesPro_StrGen,
		AffiliatePagesPro_UserToken,
		AffiliatePagesPro_View,
    AffiliatePagesPro_Nonce,
    AffiliatePagesPro_Form,
    AffiliatePagesPro_Client;

	protected $id;

	protected $parent_slug = null; // for submenu pages

	protected $page_title;

	protected $menu_title;

  protected $brand_check = false;

	protected $capability = 'manage_options';

	protected $menu_slug;

  protected $custom_menu_slug;

	protected $callable = 'onLoadPage';

	protected $vue_pack;

	protected $view_name = 'admin.index';

	protected $icon_url = '';

	protected $position = null;

	protected $use_client_token = false;

  protected $enque_styles;

  protected $enque_scripts;

  protected $enque_footer_scripts;

  protected $use_form = false; // auto save using id and nonce validation

  protected $class_wrapper; // e.g. = 'ml-css';

  protected $custom_wrapper; //  e.g. = ['<div id="custom_wrapper">', '</div>'];

  protected $hide_admin_menus = false;

  protected $no_menu = false;

  protected $update_db = false;

  public function preConstruct() {

  }

	public function __construct()
	{
    $this->preConstruct();

    if($this->brand_check && !empty(self::$options) && !empty(self::$options['b_menu_text'])) {
      $this->menu_title = str_replace('\\', '', self::$options['b_menu_text']);
    }

		if(empty($this->page_title)) {
			$this->page_title = self::$plugin_app_name;
		}

		if(empty($this->menu_title)) {
			$this->menu_title = self::$plugin_app_name;
		}

    if(!empty($this->custom_menu_slug)) {
      $this->menu_slug = $this->custom_menu_slug;
    }
		elseif(!empty($this->menu_slug)) {
			$this->menu_slug = self::$plugin_app_cl.'-'.$this->menu_slug;
		} else {
			$this->menu_slug = self::$plugin_app_cl;
		}

		if(!empty($this->parent_slug) || $this->no_menu) {

			add_submenu_page(
				$this->parent_slug,
		        $this->page_title,
		        $this->menu_title,
		        $this->capability,
		        $this->menu_slug,
		        [$this, $this->callable]
	        );
		}

		else {
      // echo $this->menu_slug; exit;
			add_menu_page(
		        $this->page_title,
		        '<span>'.$this->menu_title.'</span>',
		        $this->capability,
		        $this->menu_slug,
		        [$this, $this->callable],
		        $this->icon_url,
		        $this->position
	        );
		}

    // echo $_GET['page'].'<br />'.$this->menu_slug; exit;

		if(!empty($_GET['page']) && $_GET['page'] == $this->menu_slug) {
			$this->enqueScripts();
      add_action( 'admin_head', [$this, 'adminHead'] );

      if($this->update_db) {
        affiliate_pages_pro_use('Controllers/Database/DatabaseController');

        // $update = new AffiliatePagesPro_DatabaseController;
        // $update->update();

        $dbVersion = $this->getOption('app_dbv');

        if(empty($dbVersion) || $dbVersion != self::$plugin_app_dbv)
        {
    			$update = new AffiliatePagesPro_DatabaseController;
    			$update->update();

          $this->updateOption('app_dbv', self::$plugin_app_dbv);
        }

      }
		}

    if(!empty($this->use_form)) {
      $this->formHead();
    }



    $this->onHeader();

	}

  public function adminHead()
	{

    // valid age admin head



    if($this->hide_admin_menus) {
      ?><style>
      body
      {
        background: transparent;
      }

      #adminmenumain,
      #wpadminbar,
      .notice,
      #screen-meta,
      #contextual-help-wrap,
      .update-nag,
      #wpfooter {
        display: none
      },

      .notice {
        display: none
      }

      #wpbody-content,
      #wpwrap
      #wpcontent,
      html,
      body.wp-admin,
      html.wp-toolbar
      {
        margin-left: 0px;padding: 0px;
      }
    </style><?php
    }
	}

  public function onHeader() {}

  private function formHead() {


    // settings or custom id
    if(!empty($_POST) && !empty($_POST[self::$plugin_app_id.'_'.$this->id]) && $this->nonceValid()) {

      $this->updateOption($this->id, $_POST[self::$plugin_app_id.'_'.$this->id]);
      $data = $_POST[self::$plugin_app_id.'_'.$this->id];
    }
    else {
      $data = $this->getOption($this->id);
    }


    if(!empty($data) && is_array($data)) {
      foreach($data as $key =>  $value) {
        $this->{$this->id}[$key] = $value;
      }
    }
  }

	public function enqueScripts()
	{
  // echo 'enque'; exit;

		if(!empty($this->vue_pack)) {

      wp_deregister_style('buttons');
      wp_enqueue_style('dashicons');
  		wp_enqueue_style('admin-menu');
  		wp_enqueue_style('common');
  		wp_enqueue_style('dashboard');
  		// wp_enqueue_style('list-tables');
  		// wp_enqueue_style('edit');
  		// wp_enqueue_style('media');
  		wp_enqueue_style('themes');
  		// wp_enqueue_style('wp-auth-check');
  		// wp_enqueue_style('buttons');
  		wp_enqueue_style('nav-menus');
  		wp_enqueue_style('wp-pointer');
  		wp_enqueue_style('widgets');
  		wp_enqueue_style('site-icon');


			$a = '/'.$this->vue_pack.'/css/app';

			$this->enqueSimpleStyles($a);


			$this->enqueFooterScripts(['https://use.fontawesome.com/releases/v5.1.0/js/all.js'], 1, false);

			$scripts = [
				// 'https://use.fontawesome.com/releases/v5.1.0/js/all.js',
				// '/'.$this->vue_pack.'/js/manifest',
				'/'.$this->vue_pack.'/js/chunk-vendors',
				'/'.$this->vue_pack.'/js/app'
			];

			$this->enqueFooterScripts($scripts, 2);
		}

    if(!empty($this->enque_styles)) {
      $this->enqueSimpleStyles($this->enque_styles);
    }

    if(!empty($this->enque_scripts)) {
      $this->enqueSimpleScripts($this->enque_scripts);
    }

    if(!empty($this->enque_footer_scripts)) {
      $this->enqueFooterScripts($this->enque_footer_scripts);
    }
	}

	public function onLoadPage()
	{
		if(!empty($this->use_client_token)) {

			$this->user_token = $this->getOrCreateUserToken();
			$this->api_endpoint = $this->route('/api');
			$this->user_id = get_current_user_id();

		}


		$this->onPage();

    if(!empty($this->view_name)) {
      $this->viewTemplate($this->view_name, [], false);
    }

	}

	public function onPage()
	{

	}

}
