<?php

affiliate_pages_pro_use([
	'Helpers/Admin',
	'Helpers/EnqueSimple',
	'Helpers/Form',
	'Helpers/Options',
	'Helpers/PostMeta',
	'Helpers/Routes',
	'Helpers/Sessions',
	'Helpers/View',
	'Helpers/Client'
]);

if(class_exists('AffiliatePagesPro_MetaBox')) {
    return;
}

abstract class AffiliatePagesPro_MetaBox extends AffiliatePagesPro
{
	use AffiliatePagesPro_Admin,
		AffiliatePagesPro_EnqueSimple,
		AffiliatePagesPro_Form,
		AffiliatePagesPro_Options,
		AffiliatePagesPro_PostMeta,
		AffiliatePagesPro_Routes,
		AffiliatePagesPro_Sessions,
		AffiliatePagesPro_View,
		AffiliatePagesPro_Client;


	protected $id; // = 'metabox' must be set by metabox

	protected $view;

	protected $is_module; // set for modules

	protected $title = 'MetaBox Title';

	protected $callback = 'metabox';

	protected $screen = ['post', 'page'];

	protected $context = 'advanced'; // 'normal', 'side', and 'advanced'.

	protected $priority = 'default'; // set for: high or low

	protected $callback_args = [];

	protected $success;

	protected $error;

	protected $editors; // form editors to save

	protected $styles = ['admin'];//['admin', 'air-datepicker'];

	protected $scripts = ['admin'];

	protected $js_libs;

	protected $wrapper_class = 'ml-css';

	protected $check_lic = false;

	protected $use_ajax = false;

	protected $use_active = false;

	public function __construct()
	{

		add_action('add_meta_boxes', [$this, 'addMetaBox'], 10, 2);
		add_action('save_post', [$this, 'saveMetaBox']);
		add_action('wp', [$this, 'wp']);
		add_action('template_redirect', [$this, 'templateRedirect']);

		if(!empty($this->use_ajax)) {
			$action = 'wp_ajax_'.$this->getAjaxAction();
			add_action($action, [$this, 'onAjaxPrep']);
		}

		// if(!empty($this->use_active)) {

		// 	$this->is_active = $this->getOption($this->id.'_active');

		// }


	}

	public function onAjaxPrep() {

		// preset actions

		$request = new stdClass();
		foreach($_POST['data'] as $key => $value) {
			$request->{$key} = $value;
		}
		if(!empty($_GET)) {
			foreach($_POST as $key => $value) {
				$request->{$key} = $value;
			}
		}
		return $this->onAjax($request);
	}

	public function onAjax($request) {}

	public function getAjaxAction() {
		return self::$plugin_app_id.'_'.$this->id;
	}

	public function wp() {}


	public function templateRedirect() {
	}

	public function getMeta() {
		global $post;
		$this->{$this->id} = $this->getPostMeta($post->ID, $this->id);
		return $this->{$this->id};
	}

	public function metaboxIsActive() {

		global $post;
		if(!is_singular() || empty($post) || empty($post->ID)) {
			return;
		}

		$meta = $this->getMeta();

		if(empty($meta['active']) || $meta['active'] == 'off' || $meta['active'] == 'none' || $meta['active'] == '' || $meta['active'] == '0') {
			return false;
		}

		return true;
	}

	public function metabox()
	{



		if(!empty($this->use_active)) {
			$isActive = $this->getOption($this->id.'_active');
			$this->is_active = !empty($isActive);

		}

		// if($this->check_lic) {

		// 	$this->lic = $this->getOption('lic');

		// 	if(!$this->clientValid()) {
		// 		$this->invalid_lic = true;
		// 		$this->view('metaboxes.lic');
		// 		return;
		// 	}
		// }

		// saves even empty fields
		$this->formUpdated();

		// wp_send_json($this);
		if($this->view) {
			$this->view('metaboxes.'.$this->view);
		} else {
			$this->view('metaboxes.'.$this->id);
		}
	}

	public function saveMetaBox()
	{
		global $post;

		$postKey = self::$plugin_app_id.'_'.$this->id;

		if(!empty($_POST) && !empty($_POST[$postKey])) {

			$update = $_POST[$postKey];
		}

		if(isset($update)) {
			$this->updatePostMeta($post->ID, $this->id, $update);
			// setcookie('affiliate_pages_pro_success', 'Here is my success message');
		}
	}

	public function addMetaBox()
	{
		global $post;

		$this->enqueSimple();

		// integrate form elements

		$this->{$this->id} = $this->getPostMeta($post->ID, $this->id);

		add_meta_box(
	        $this->id,
	        __( $this->title ),
	        [$this, $this->callback],
	        $this->screen,
	        $this->context,
	        $this->priority
	    );

	 //    if(isset($_COOKIE['affiliate_pages_pro_success'])) {
	 // 	$this->success = $_COOKIE['affiliate_pages_pro_success'];
		//   unset( $_COOKIE['affiliate_pages_pro_success'] );
		//   setcookie( 'affiliate_pages_pro_success', '', time() - ( 15 * 60 ) );
		// }

	}

}
