<?php

/**

* 19.9.18 change updated to return fillable if not set
 * group prefix fixed: June 5, 2018
 */


affiliate_pages_pro_use([
	'Core/Inflector',
	'Core/Model/QueryBuilder',
	'Core/Model/NewQuery',
	'Core/Model/BelongsToMany',
	'Core/Model/HasMany',
	'Core/Model/BelongsTo',
	'Core/Model/Attach',
	'Core/Model/FirstOrCreate',
	'Core/Model/Find',
	'Core/Model/LeftJoinAppend',
	'Core/Model/InnerJoinAppend',
	'Core/Model/NewQueryV2',
	'Helpers/RemoveNull'
]);



if(class_exists('AffiliatePagesPro_Migration')) {
    return;
}

class AffiliatePagesPro_Model extends AffiliatePagesPro
{
	use AffiliatePagesPro_ModelQueryBuilder,
		AffiliatePagesPro_ModelNewQuery,
		AffiliatePagesPro_ModelBelongsToMany,
		AffiliatePagesPro_ModelHasMany,
		AffiliatePagesPro_ModelBelongsTo,
		AffiliatePagesPro_ModelAttach,
		AffiliatePagesPro_ModelFirstOrCreate,
		AffiliatePagesPro_ModelFind,
		AffiliatePagesPro_ModelLeftJoinAppend,
		AffiliatePagesPro_ModelInnerJoinAppend,
		AffiliatePagesPro_ModelNewQueryV2;

	protected $table;

	// overrides all others
	// protected $no_table_prefix = false;
	//

	// Custom Database
	// protected $use_custom_db = false;

	// custom database connection
	// protected $dbcon = 'wpinstantleads';
	// protected $custom_prefix = 'wpwn_affiliate_pages_pro_';

	protected $belongs_to_many_filter; // for DataTables Support (required)

	protected $dbcon = ''; //'master'; sandbox
	protected $custom_prefix = '';

	protected $use_app_id = false;

	protected $primary_key = 'id';

	protected $use_datetime = true; // default

	protected $use_only_created = false; // default

	protected $use_created_ts = false;

	protected $use_updated_ts = false;

	protected $use_created_both = false; // timestamp and mysqltime

	protected $use_ts = false;

	protected $append_columns = []; // append aditional columns as array

    private $db;

    public function __construct() {

		if(empty(self::$plugin_app_db)) {

			if(!empty($this->use_group_id)) {
				global $wpdb;
				$this->custom_prefix = $wpdb->prefix.self::$plugin_app_group_id.'_';
			}

			return;
		}

    	// Custom Datbase
    	$this->dbcon = self::$plugin_app_db;

    	if($this->dbcon) {

    		global $affiliate_pages_pro_dbcons;

    		if(empty($affiliate_pages_pro_dbcons) || isset($affiliate_pages_pro_dbcons[$this->dbcon]) == false)
    		{

    			$dbcon = affiliate_pages_pro_config('database.connections.'.$this->dbcon);
    			$affiliate_pages_pro_dbcons[$this->dbcon] = new wpdb($dbcon['username'], $dbcon['password'], $dbcon['database'], $dbcon['host']);

    			if($dbcon['prefix']) {
    				$affiliate_pages_pro_dbcons[$this->dbcon]->prefix = $dbcon['prefix'];
    			}
    		}

    	}
    }

    public function getFillables() {
    	return $this->filleble;
    }

    public function getUpdatables() {
    	if(!empty($this->updatable)) {
    		return $this->updatable;
    	}
    	return $this->getFillables();
    }

    public function getTable() {
    	return $this->table;
    }


		public function getIdKey()
		{
			if(empty($this->identifier)) {
				return false;
			}
			if(strstr($this->identifier,'_') == false) {
				return $this->identifier;
			}
			$part = explode('_', $this->identifier);
			return $part[1];
		}

	// Model classes

	public function onCreate() {
	}


	public function getSingle($key='', $def=null)
	{
		if(!empty($this->{$key})) {
			return $this->{$key};
		}
		return $def;
	}
}
