<?php

if(trait_exists('AffiliatePagesPro_ModelAttach')) {
    return;
}

trait AffiliatePagesPro_ModelAttach
{


	public function attach($ids, $data=[])
	{

		if(!is_array($ids)) {
			$ids = [$ids];
		}

		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		foreach($ids as $i)
		{
			$entry = [
				$pivotCol => $i,
				$relatedCol => (int)$this->related_id
			];

      $exists = $this->getRow($this->query_pivot_table, $entry, ['id']);

      if(empty($exists)) {

        if(!empty($data)) {
          foreach($data as $key => $value) {
            $entry[$key] = $value;
          }
        }
  			$this->insertRow($this->query_pivot_table, $entry);

      }

		}

	}


  // Used in DataTable
  public function onCreatedAttach($ids)
	{

		if(!is_array($ids)) {
			$ids = [$ids];
		}

		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		foreach($ids as $i)
		{
			$entry = [
				$pivotCol => $i,
				$relatedCol => (int)$this->related_id
			];

			$this->insertRow($this->query_pivot_table, $entry);

		}

	}




  public function updatePivots($id, $data=[]) {

    foreach($data as $key => $value) {
      $this->updatePivot($id, $key, $value);
    }
  }

	/**
	 * update single pivot value
	 * @param  int $id  id of the matching pivot item
	 * @param  string, array $col column name, or update arrays
	 * @param  string $val new column value
	 * @return [type]      [description]
	 */
	public function updatePivot($id, $col, $val='') {

		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		$where = [
			$pivotCol => $id,
			$relatedCol => (int)$this->related_id
		];

		if(!empty($pivotData)) {
			$where = array_merge($where, $pivotData);
		}

		if(is_array($col)) {
			foreach($col as $key => $value) {
				$update[$key] = $value;
			}
		} else {
			$update = [$col => $val];
		}

    // wp_send_json($where); exit;

		return $this->updateRow($this->query_pivot_table, $update, $where);
	}

	public function updatePivotToNull($id, $col)
	{
		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		$where = [
			$pivotCol => $id,
			$relatedCol => (int)$this->related_id
		];

		if(!empty($pivotData)) {
			$where = array_merge($where, $pivotData);
		}


		return $this->updateRowToNull($this->query_pivot_table, $col, $where);

	}


	public function getPivot($id, $fields='*') {

		// if(!is_array($ids)) {
		// 	$ids = [$ids];
		// }

		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		$entry = [
			$pivotCol => $id,
			$relatedCol => (int)$this->related_id
		];

		if(!empty($pivotData)) {
			$entry = array_merge($entry, $pivotData);
		}

		return $this->getRow($this->query_pivot_table, $entry, $fields);
	}

	/**
	 * has any pivot
	 * @param  [type]  $ids [description]
	 * @return boolean      [description]
	 */
	public function hasPivot($ids) {

		if(!is_array($ids)) {
			$ids = [$ids];
		}

		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		foreach($ids as $i)
		{
			$entry = [
				$pivotCol => $i,
				$relatedCol => (int)$this->related_id
			];

			if(!empty($pivotData)) {
				$entry = array_merge($entry, $pivotData);
			}

			$exists = $this->rowExists($this->query_pivot_table, $entry);

			if(!empty($exists)) {
				return true;
			}
		}

		return false;
	}

	/**
	 * [attach description]
	 * @param  string, array $ids [description]
	 * @return [nothing]      [description]
	 */

	public function detach($ids)
	{
		if(!is_array($ids)) {
			$ids = [$ids];
		}

		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		foreach($ids as $i)
		{
			$entry = [
				$pivotCol => $i,
				$relatedCol => (int)$this->related_id
			];

			$this->deleteRow($this->query_pivot_table, $entry);

		}
	}

	public function attachV1($ids)
	{

		if(!is_array($ids)) {
			$ids = [$ids];
		}

		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		foreach($ids as $i)
		{
			$entry = [
				$pivotCol => $i,
				$relatedCol => (int)$this->related_id
			];

			$this->insertRow($this->query_pivot_table, $entry);

		}

	}


	public function attachNew($ids, $pivotData=[])
	{
		if(!is_array($ids)) {
			$ids = [$ids];
		}

		$pivotCol = $this->getPivotColumn();

		$relatedCol = $this->related_pivot_column;

		foreach($ids as $i)
		{
			$entry = [
				$pivotCol => $i,
				$relatedCol => (int)$this->related_id
			];

			if(!empty($pivotData)) {
				$entry = array_merge($entry, $pivotData);
			}

			// wp_send_json($entry); exit;

			$this->insertRowIfNew($this->query_pivot_table, $entry);

		}
	}
}
