<?php

trait AffiliatePagesPro_ModelInnerJoinAppend
{
  protected function innerJoinAppend()
  {
    $table = $this->getTableFullName();
    $joinTable = $this->getTableFullName($this->innerjoin['table']);
    $idCol = $this->innerjoin['id'];

    if(strstr($this->query_columns,'*') == true) {
      $query = "SELECT {$table}.{$this->query_columns}";
    } else {
      $query = "SELECT {$this->query_columns}";
    }

    if(empty($this->innerjoin['cols'])) {
      $query .= ", {$joinTable}.*";
    }
    else {
      // custom cols with prefix
      $prefix = '';
      if(!empty($this->innerjoin['prefix'])) {
        $prefix = $this->innerjoin['prefix'];
      }
      foreach($this->innerjoin['cols'] as $col) {
        if(is_array($col)) {
          $query .= ", {$joinTable}.".key($col)." as ".$col[key($col)];
        } else {
          $query .= ", {$joinTable}.{$col} as {$prefix}{$col}";
        }
      }
    }

    $query .= " FROM {$table} LEFT JOIN {$joinTable} ON {$table}.{$idCol} = {$joinTable}.id";

    return $query;
  }

  public function innerJoin($args, $cols=null, $prefix='') // MATCHID
  {
    if(is_array($args)) {
      $this->innerjoin = $args;
    }
    else {
      $this->innerjoin = [
        'table' => $args.'s',
        'id' => $args.'_id'
      ];
      if(!empty($prefix) && $prefix == 'MATCHID') {
        $this->innerjoin['prefix'] = $args.'_';
      }
    }

    if(!empty($cols)) {
      $this->innerjoin['cols'] = $cols;
    }

    if(!empty($prefix) && empty($this->innerjoin['prefix'])) {
      if($prefix == 'MATCHID') {
        $part = explode('_', $this->innerjoin['id']);
        array_pop($part);
        $this->innerjoin['prefix'] = implode('_',$part).'_';
      } else {
        $this->innerjoin['prefix'] = $prefix;
      }
    }

    return $this;
  }

}
