<?php

/*
Updated 19.9.18

 */
if (trait_exists('AffiliatePagesPro_ModelNewQuery')) {
    return;
}

trait AffiliatePagesPro_ModelNewQuery
{

    public function wherePivot($a, $b = null, $c = null)
    {
        $q = $this->query_pivot_table . '.' . $a;

        if ($b === null) {
            $q .= ' IS NULL';
        } elseif (strtolower($b) == 'not null') {
            $q .= ' IS NOT NULL';
        } elseif (empty($b)) {
            $q .= ' = ""';
            // $q .= ' IS NOT NULL';
        } elseif (empty($c)) {
            $q .= " = '{$b}'";
        } else {
            $q .= " {$b} '{$c}'";
        }

        array_push($this->query_wheres, $q);

        return $this;
    }

    private function newQuery($columns = null, $args = [])
    {
        // echo 'private function newQuery'; exit;

        if (!empty($_GET) && !empty($_GET['tags'])) {
            return $this->newQueryV2($columns, $args);
        }
        // echo 'new query'; exit;
        // var_dump($this->db)
        // global $wpdb;
        // echo $this->query; exit;
        $table = $this->getTableFullName();

        // NEW MOVED FROM DOWN
        if (!empty($this->query_wheres)) {

            foreach ($this->query_wheres as $q) {

                if (strstr($this->query, 'WHERE ') == true) {
                    $this->query .= ' AND ';
                } else {
                    $this->query .= ' WHERE ';
                }
                $this->query .= ' ' . $q;
            }
            // echo $query; exit;
        }

        if (!empty($args['orderBy'])) {
            $this->query_orderby = $args['orderBy'] . ' ';
            if (!empty($args['order'])) {
                $this->query_orderby .= $args['order'];
            } else {
                $this->query_orderby .= 'asc';
            }
        } elseif (!empty($_GET) && !empty($_GET['orderby'])) {
            $this->query_orderby = $_GET['orderby'] . ' ' . (!empty($_GET['order']) ? $_GET['order'] : 'desc');
        }

        if (!empty($columns)) {
            $this->query_columns = $columns;
        }

        // prepend table name to columns that are not prepended
        if (!empty($this->query_columns) && is_array($this->query_columns)) {
            $count = 0;

            foreach ($this->query_columns as $col) {

                // echo $col.', '; //exit;

                if (strstr($col, '.') == false) {
                    $this->query_columns[$count] = $table . '.' . $col;
                }
                $count++;
            }
        }

        // echo $this->query_columns; exit;
        if (is_array($this->query_columns) && !empty($this->append_columns)) {
            $this->query_columns = array_merge($this->query_columns, $this->append_columns);
        }

        if (is_array($this->query_columns)) {
            $this->query_columns = implode(',', $this->query_columns);
        }

        // inner join
        if (!empty($this->query_innerjoin)) {
            $this->query .= " INNER JOIN " . $this->query_innerjoin;
        }

        // outer join
        if (!empty($this->query_outerjoin)) {
            if (strstr($this->query, ' WHERE ') == true) {
                $this->query .= ' AND';
            } else {
                $this->query .= ' WHERE';
            }
            $this->query .= $this->query_outerjoin;
        }

        if (!empty($this->get_count_only)) {
            return $this->getRowsCount();
        }

        if (!empty($this->innerjoin)) {
            $query = $this->innerJoinAppend();
        } elseif (!empty($this->query_leftjoin)) {

            // append left join columns
            $query = $this->leftJoinAppend();

        } else {
            $query = "SELECT {$this->query_columns} FROM {$this->getTableFullName()}";
        }

        $query .= ' ' . $this->query;

        // echo $query; exit;

        if (!empty($this->query_and_where_append)) {
            $query .= ' ' . $this->query_and_where_append;
        }

        if ($this->query_limit == -1 || !empty($_GET['limit']) && $_GET['limit'] < 0) {
            $this->query_limit = (10 * 1000);
        }

        if ($this->query_paginate) {
            $pagination = $this->getPagination();
        }

        $query .= $this->getQueryOrderBy(true);

        if ($this->query_limit) {
            $query .= $this->getQueryLimit();
        }

        $results = AffiliatePagesPro_RemoveNull::parse($this->getDB()->get_results($query));

        if ($this->query_paginate) {
            // was results
            return ['results' => $results, 'pagination' => $pagination];
        }

        return $results;
    }
}
