<?php

if (trait_exists('AffiliatePagesPro_ModelNewQueryV2')) {
    return;
}

trait AffiliatePagesPro_ModelNewQueryV2
{

    private function newQueryV2($columns = null, $args = [])
    {
        // setup
        $this->table_full = $this->getTableFullName();
        $this->tags_table = 'tags';
        $this->tags_table_full = $this->getPivotTableName($this->tags_table);
        $this->pivot_column = $this->getPivotColumn();

        // Start Query
        $query = 'SELECT ';

        // cols
        $cols = $this->getCols() . " FROM {$this->table_full}";
        $query .= $cols;

        // INNER JOIN
        $tags = $this->getTagsJoin(explode(',', $_GET['tags']));
        $query .= ' ' . $tags;

        $countQuery = $tags;

        // link tags to query (inner to keyword)

        // echo $countQuery; exit;
        // $countQuery = "{$tags} AND {$search}";
        // SEARCH QUERY
        if (!empty($this->search_queries_V2)) {

            $search = $this->getSearchQueries();
            $query .= ' AND ' . $search;
            $countQuery .= " AND {$search}";
        }
        // else {
        //   echo 'no keyword'; exit;
        // }

        // GROUP BY (required for inner join)
        // $group = "GROUP BY {$this->table_full}.id";
        // $query .= ' '.$group;

        $order = $this->getQueryOrderBy();
        $query .= ' ' . $order;

        // LIMIT
        $limit = $this->getOrderBy();
        $query .= ' ' . $limit;

        // echo $query; exit;
        $results = AffiliatePagesPro_RemoveNull::parse($this->getDB()->get_results($query));

        // get total count
        $this->total = $this->getCountV2($countQuery);

        $pagination = $this->getPaginV2();

        wp_send_json(compact('results', 'pagination'));
    }

    private function getPaginV2()
    {

        return [
            'total' => (int) $this->total,
            'pages' => ceil($this->total / $this->query_paginate),
            'page' => (int) $this->query_page,
        ];

    }

    public function getCountV2($q)
    {
        //echo "SELECT COUNT(*) FROM {$this->table_full} {$q}"; exit;
        return $this->getDB()->get_var("SELECT COUNT(*) FROM {$this->table_full} {$q}");
    }

    private function getOrderBy()
    {

        $query = '';

        if (!empty($_GET['orderby'])) {
            $query .= $_GET['orderby'];
            if (!empty($_GET['order'])) {
                $query .= ' ' . $_GET['order'];
            } else {
                $query .= ' asc';
            }
        }

        if (!empty($query)) {
            $query = ' ORDER BY ' . $this->table_full . '.' . $query;
        }

        return $query;
    }

    private function getSearchQueries($match = 'OR')
    {
        $query = '';

        if (count($this->search_queries_V2) > 1) {
            $query .= '(';
        }

        $query .= implode(' ' . $match . ' ', $this->search_queries_V2);

        if (count($this->search_queries_V2) > 1) {
            $query .= ')';
        }

        return $query;
    }

    // get tags
    private function getTagsJoin($tags = [], $match = 'OR')
    {
        $query = "INNER JOIN {$this->tags_table_full}
      ON {$this->table_full}.id = {$this->tags_table_full}.{$this->pivot_column}";

        $query .= ' WHERE ';

        if (count($tags) > 1) {
            $query .= '(';
        }

        $count = 0;
        foreach ($tags as $tag) {
            if (!empty($tag)) {
                if ($count > 0) {
                    $query .= " {$match} ";
                }
                $query .= "{$this->tags_table_full}.tag_id = {$tag}";
                $count++;
            }
        }

        if (count($tags) > 1) {
            $query .= ')';
        }

        return $query;
    }

    // Get Cols
    private function getCols()
    {

        $cols = '';
        // Columns
        if (!empty($this->query_columns) && is_array($this->query_columns)) {

            $count = 0;

            foreach ($this->query_columns as $col) {

                if ($count > 0) {
                    $cols .= ',';
                }

                if (strstr($col, '.') == false) {
                    $cols .= $this->table_full . '.' . $col;
                    $this->query_columns[$count] = $this->table_full . '.' . $col;
                } else {
                    $colos .= $col;
                }
                $count++;
            }
        }
        return $cols;
    }

}
