<?php

if(trait_exists('AffiliatePagesPro_ModelQueryBuilder')) {
    return;
}

trait AffiliatePagesPro_ModelQueryBuilder
{

	private $query_columns = '*';

	private $query_limit;

	private $query_page = 1;

	private $query_paginate;

	private $query_orderby;

	private $query_innerjoin;

	private $query_outerjoin;

	private $query = '';

	private $query_columns_set;

	private $query_pivot_table;

	private $query_relation_id;

	private $query_and_where_append = '';

	protected $query_wheres = [];

	private $custom_query_override; /// mainly for testing

  protected $query_leftjoin; // ['table', 'cols', '']
  protected $innerjoin; // version 2

  protected $remove_null;

	private $get_param_options = [
		'limit' => 'query_limit'
	];

  protected $query_where_arr = []; // append where arrays

  protected $db_user_id; // for user match query (change to protected from public)

  protected $query_leftjoin_group;

  protected $search_queries_V2 = [];

  // newer
  public function pivotSearch($table, $cols, $q='', $not=false, $type='OR') // OR AND, NOT
	{
    $table = $this->getTableFullName($table);

		if(empty($q)) {
			// return $this;
		}

		if(!is_array($cols)) {
			$cols = [$cols];
		}

		if(!empty($q)) {
			$q = '%'.trim($q).'%';
		}

		$count = 0;

		if(!empty($not)) {
			$not = ' NOT';
		}

    $query = '';

		foreach($cols as $col) {
			// if($count > 0) {
			// 	$query .= ' '.$type;
			// } else {
			// 	$query .= ' WHERE';
			// }

			if(!empty($q)) {
        $query .= " {$table}.{$col}{$not} LIKE '{$q}'";
				// $query .= ' '.$col.$not.' LIKE '."'{$q}'";
			} else {
        $query .= " {$table}.{$not} IS{$not} NULL";
				//$query .= ' '.$col.' IS'.$not.' NULL';
			}

      array_push($this->query_where_arr, $query);

			$count++;
		}

		// echo $query; exit;
		return $this;
	}

  // older
  public function addQueryWhere($str)
  {
    array_push($this->query_wheres, $str);
  }

	public function getParams() {

		// allows for order by
		$this->use_get_params = true;

		foreach ($this->get_param_options as $key => $value) {
			if(!empty($_GET[$key])) {
				$this->{$value} = $_GET[$key];
			}
		}

		return $this;
	}

	public static function all($columns = '*', $args = []) {
		return (new static)->newQuery($columns, $args);
	}

	public function _all($columns = null, $args = []) {
		return $this->newQuery($columns, $args);
	}

	public static function where($a, $b=null, $c = null)
	{
		return (new static)->newWhere($a, $b, $c);
	}

	public function _where($a, $b=null, $c = null)
	{
		return $this->newWhere($a, $b, $c);
	}

	public static function query()
	{
		return (new static)->aQuery();
	}

	public function aQuery()
	{
		return $this;
	}

	public static function destroy($ids)
	{
		(new static)->destroyQuery($ids);
	}

	public function first($columns='*')
	{
		$this->query_columns = $columns;

		$results = $this->newRowQuery($columns);

		if(!empty($results)) {
			// $this->id = $request['id'];
			foreach ($results as $key => $value) {
				// echo "\n".$key.' '.$value;// exit;
				$this->{$key} = $value;
			}
			return $this;
		}
		return null; // if no find
	}



  public function wpDelete($where=[], $tableName=null) {
    if(empty($tableName)) {
      $tableName = $this->getTableFullName();
    }
    return $this->getDB()->delete( $tableName, $where);

  }

	public function delete() {

		global $wpdb;

		$key = $this->primary_key;
		$value = $this->{$key};

		return $this->getDB()->delete( $this->getTableFullName(), [$key => $value]);
	}

	public function paginate($num=50) {
		$this->query_paginate = $num;
		$this->query_limit = $num;
		return $this;
	}

	// custom outer join
	public function andWithout($related, $value)
	{
		// echo 'without'; exit;
		$table = $this->getTableFullName();

		$relatedName = AffiliatePagesPro::getPrefix().$related;

		$related = new $relatedName();

		$relatedTable = $related->getTableFullName();

		$pivotTable = $this->getPivotTableName($related->table);

		$a = $this->getPivotColumn(); // contact_id
		$b = $this->getPivotColumn($related->table, $related->primary_key);

		// Query 1
		$q = "SELECT {$pivotTable}.{$a}
				FROM {$pivotTable}
				WHERE {$pivotTable}.{$b} = {$value}";

		$results = $this->getDB()->get_results($q);

		$idList = '';
		foreach($results as $key => $value) {
			$idList .= $value->{$a}.',';
		}

		// Phase 2, get contacts that don't have this id
		// $q = "SELECT {$table}.id, {$table}.email
		// 	FROM {$table} WHERE id NOT IN(".trim($idList,',').")";

		// works with just one argument
		// $this->query = " WHERE id NOT IN(".trim($idList,',').")";
		$this->query_outerjoin = " {$table}.id NOT IN(".trim($idList,',').")";

		// echo $this->query_outerjoin; exit;
	}

	/**
	 * [
	 * @param  Model shortname $related [description]
	 * @param  [type] $value   [description]
	 * @return [type]          [description]
	 */
	public function andWith($related, $value=null, $outerJoin=false)
	{

		if(empty($value)) {
			$key = strtolower($related);
			if(!empty($_GET[$key])) {
				$value = $_GET[$key];
			} else {
				return;
			}
		}

		$table = $this->getTableFullName();

		$relatedName = AffiliatePagesPro::getPrefix().$related;

		$related = new $relatedName();

		$relatedTable = $related->getTableFullName();

		$pivotTable = $this->getPivotTableName($related->table);

		$a = $this->getPivotColumn();
		$b = $this->getPivotColumn($related->table, $related->primary_key);


		if(!empty($outerJoin)) {
			$this->query_outerjoin = "{$pivotTable} ON {$table}.id = {$pivotTable}.{$a} WHERE {$pivotTable}.{$b} = ".$value;
		} else {
			$this->query_innerjoin = "{$pivotTable} ON {$table}.id = {$pivotTable}.{$a} WHERE {$pivotTable}.{$b} = ".$value;
		}


	}

	public function page($num) {
		$this->query_page = $num;
		return $this;
	}

	public function andWhere($a, $b, $c=null)
	{
		if($this->query_pivot_table) {
			$this->query_and_where_append = '';
			$appendTo = 'query_and_where_append';
		} else {
			$appendTo = 'query';
		}
    $a = $this->getTableFullName().'.'.$a;

		$this->{$appendTo} .= ' AND '.$a;
		if(!$c) {
			$this->{$appendTo} .= " = '{$b}'";
		}
    // elseif(is_null($c)) {
    //   $this->{$appendTo} .= " IS NULL";
    // }
    else {
			$this->{$appendTo} .= " {$b} '{$c}'";
		}


		return $this;
	}

  public function andWhereNull($a) {
    if($this->query_pivot_table) {
			$this->query_and_where_append = '';
			$appendTo = 'query_and_where_append';
		} else {
			$appendTo = 'query';
		}

    $a = $this->getTableFullName().'.'.$a;

    $this->{$appendTo} .= " AND .{$a} IS NULL";

    return $this;
  }

  public function andWhereNotNull($a) {
    if($this->query_pivot_table) {
			$this->query_and_where_append = '';
			$appendTo = 'query_and_where_append';
		} else {
			$appendTo = 'query';
		}

    $a = $this->getTableFullName().'.'.$a;

    $this->{$appendTo} .= " AND .{$a} IS NOT NULL";

    return $this;
  }

	public function orWhere($a, $b, $c=null)
	{
		$this->query .= ' OR '.$a;
		if(!$c) {
			$this->query .= " = '{$b}'";
		} else {
			$this->query .= " {$b} '{$c}'";
		}
    // echo 'OR WHERE: '.$this->query; exit;
		return $this;
	}

	public function get($cols='*')
	{
		if(!$this->query_columns_set) {
			$this->query_columns = $cols;
		}

		return $this->newQuery();
	}

  public function deleteAll()
  {
    $ids = $this->getIds();

    if(!empty($ids)) {
      $this->destroyQuery($ids);
    }
  }

	public function getIds()
	{
	  $this->query_columns = ['id'];

		$response = $this->newQuery();

    if(empty($response)) {
      return [];
    }

    $ids = [];

    foreach($response as $i) {
      array_push($ids, $i->id);
    }

    return $ids;
	}


	public function count()
	{
		$this->get_count_only = true;
		return $this->newQuery();
	}

	public function orderBy($col, $order='asc', $appendToQuery=false) {

    if($appendToQuery) {
      $this->query .= " ORDER BY {$col} {$order}";
    } else {
      $this->query_orderby = "{$col} {$order}";
    }

		// $this->query_orderby = "{$col} {$order}";
		return $this;
	}

	// public function setOrder($request) {
	// 	elseif(!empty($_GET) && !empty($request['oderby'])) {
	// 		// $order = (!empty($_GET['oder']) ? $_GET['oder'] : 'asc');
	// 		$this->query_orderby = $_GET['oderby'].' '.(!empty($_GET['oder']) ? $_GET['oder'] : 'asc');
	// 	}
	// }

	public function take($num)
	{
		$this->query_limit = $num;
		return $this;
	}

	// create or update

	public function save() {

		// if not existing item
		if(empty($this->{$this->primary_key})) {
			$this->onCreate();
		}

		$data = [];

		foreach ($this->filleble as $i) {

			if(isset($this->{$i})) {// echo $i.', '; exit;
				$data[$i] = $this->{$i};
			}
		}

    // support seeder
    if(!empty($this->updated)) {
      $data['updated'] = $this->updated;
    }
		elseif($this->use_datetime && !$this->use_only_created) {
      if($this->use_ts || $this->use_updated_ts) {
        $data['updated'] = current_time( 'U' );
      } else {
        $data['updated'] = current_time( 'mysql' );
      }

		}

		// if not existing item
		if(empty($this->{$this->primary_key})) {



      if($this->use_created_both) {

        // seeder support
        if(!empty($this->created)) {
          $data['created'] = $this->created;
        } else {
          $data['created'] = current_time( 'mysql' );
        }

        // seeder support
        if(!empty($this->created_ts)) {
          $data['created_ts'] = $this->created_ts;
        } else {
          $data['created_ts'] = current_time( 'U' );
        }

      }

      elseif($this->use_created_ts || ($this->use_datetime && $this->use_ts)) {

        // seeder support
        if(!empty($this->created)) {
          $data['created'] = $this->created;
        } else {
          $data['created'] = current_time( 'U' );
        }
      }

			elseif($this->use_datetime || $this->use_only_created) {

        // seeder support
        if(!empty($this->created)) {
          $data['created'] = $this->created;
        } else {
          $data['created'] = current_time( 'mysql' );
        }

			}

			// returns primary
			$this->{$this->primary_key} = $this->queryInsert($data);

			foreach ($data as $key => $value) {
				$this->{$key} = $value;
			}

			// create new done
		}

		else {
			$this->queryUpdate($data);

		}
	}

	public function insertRow($table, $data, $timestamps=true) {
		global $wpdb;
		if($timestamps) {
			$data['created'] = current_time( 'mysql' );

      if(!$this->use_only_created) {
        if($this->use_ts || $this->use_updated_ts) {
          $data['updated'] = current_time( 'U' );
        } else {
          $data['updated'] = current_time( 'mysql' );
        }
        // $data['updated'] = current_time( 'mysql' );
      }

		}

		return $this->getDB()->insert( $table, $data); // , $format
	}

	public function insertRowIfNew($table, $data, $timestamps=true) {

		$exists = $this->rowExists($table, $data);

		if(empty($exists)) {
			return $this->insertRow($table, $data, $timestamps);
		}
	}

	private function rowExists($table, $data) {

		global $wpdb;

		$query = "SELECT {$this->primary_key} FROM {$table} WHERE";
		foreach($data as $key => $value) {
			$query .= " {$key}='$value' AND";
		}
		$query = rtrim($query, 'AND').' LIMIT 1';

		return $this->getDB()->get_row($query);
	}

	private function getRow($table, $data, $fields='*') {

		global $wpdb;

		if(is_array($fields)) {
			$fields = implode(',', $fields);
		}

		$query = "SELECT $fields FROM {$table} WHERE";
		foreach($data as $key => $value) {
			$query .= " {$key}='$value' AND";
		}
		$query = rtrim($query, 'AND').' LIMIT 1';
		// echo $query; exit;
		return $this->getDB()->get_row($query);
	}

	private function updateRow($table, $update, $where, $limit=1) {

		$query = "UPDATE {$table} SET";

		foreach($update as $key => $value) {
			$query .= " {$key}='$value' AND";
		}
		$query = rtrim($query, 'AND').'';

		foreach($where as $key => $value) {
			if(strstr($query,' WHERE') == false) {
				$query .= ' WHERE';
			} else {
				$query .= ' AND';
			}
			$query .= " {$key}='{$value}'";
		}

		if(!empty($limit)) {
			$query .= ' LIMIT '.$limit;
		}

		return $this->getDB()->get_results($query);
	}

	private function updateRowToNull($table, $col, $where, $limit=1) {

		$query = "UPDATE {$table} SET {$col} = NULL";

		foreach($where as $key => $value) {
			if(strstr($query,' WHERE') == false) {
				$query .= ' WHERE';
			} else {
				$query .= ' AND';
			}
			$query .= " {$key}='{$value}'";
		}

		if(!empty($limit)) {
			$query .= ' LIMIT '.$limit;
		}

		// echo $query; exit;

		return $this->getDB()->get_results($query);
	}

	private function deleteRow($table, $data)
	{
		global $wpdb;
		$this->getDB()->delete( $table, $data );
	}



	private function destroyQuery($ids)
	{
		global $wpdb;

		if(!is_array($ids)) {
			$ids = [$ids];
		}

		$table = $this->getTableFullName();

		$key = $this->primary_key;

		foreach ($ids as $id) {
			$this->getDB()->delete( $table, [$key => $id]);
		}
	}

	// public function __destruct()
	// {
	// 	// echo 'destruct!'; exit;
	// }

	public static function quickFind($ids, $columns='*')
	{
		return (new static)->quickFindNew($ids, $columns);
	}
	public function quickFindNew($ids, $columns='*')
	{
		if(is_array($columns)) {
			$columns = implode($columns,',');
		}
		if(is_array($ids)) {
			$q = "SELECT $columns FROM {$this->getTableFullName()} WHERE id IN (".implode(',',$ids).")";
			// echo $q; exit;
			return $this->getDB()->get_results($q);

		} else {
			echo 'quickFindNew() get row'; exit;
		}
		echo 'quickFindNew'; exit;
	}
	public function formatColumns($cols)
	{

	}

	private function newWhere($a, $b, $c)
	{
		// $this->query .= ' WHERE '.$a;
    $this->query .= ' WHERE '.$this->getTableFullName().'.'.$a;

		if(!$b) {
			$this->query .= ' != ""';
		}
		elseif(!$c) {
			$this->query .= " = '{$b}'";
		} else {
			$this->query .= " {$b} '{$c}'";
		}
    // echo $this->query; exit;
		return $this;
	}

  public function newSearch($cols, $q='', $not=false, $type='OR') // OR AND, NOT

  {

    if(strstr($q,' ') == true) {
      $keywords = explode(' ',$q);
    } else {
      $keywords = [$q];
    }

    if(!empty($not)) {
      $not = ' NOT';
    }

    $queries = [];

    foreach($keywords as $q) {

      $query = '';

      if(!empty($q)) {
        $q = '%'.trim($q).'%';
      }

      $count = 0;
      foreach($cols as $col) {

        if($count > 0) {
          $query .= ' OR';
        }

        $where_arr = '';

        if($col == 'identifier') {
          $count--;
        }
        elseif($col == 'id' && !is_numeric($q)) {
          $count--;
        }
        elseif(!empty($q)) {

          $where_arr = $col.$not.' LIKE '."'{$q}'";
          $query .= ' '.$col.$not.' LIKE '."'{$q}'";
        } else {
          $query .= ' '.$col.' IS'.$not.' NULL';
          $where_arr = $col.' IS'.$not.' NULL';
        }
        $count++;

        if(!empty($where_arr)) {
          array_push($this->search_queries_V2, $where_arr);
        }

      }

      array_push($queries, $query);

    }


    $this->query .= ' WHERE';

    if(count($queries) < 2) {
      $this->query .= ' '.$queries[0];
      return $this;
    }


    $count = 0;
    foreach($queries as $query) {

      if($count > 0) {
        $this->query .= ' AND';
      }

      $this->query .= " ({$query})";
      $count++;
    }


    return $this;
  }




	private function getQueryOrderBy($returnData=false) {

		if(!empty($this->use_get_params)) {
			if(!empty($_GET['orderby'])) {
				$this->query_orderby = $_GET['orderby'];
				if(!empty($_GET['order'])) {
					$this->query_orderby .= ' '.$_GET['order'];
				}
				else {
					$this->query_orderby .= ' asc';
				}
			}
		}

		if($this->query_orderby) {
			$this->query .= ' ORDER BY '.$this->query_orderby;
      if($returnData) {
        return ' ORDER BY '.$this->query_orderby;
      }
		}

    if($returnData) {
      return '';
    }

	}

	private function getQueryLimit()
	{
		if(!empty($this->use_get_params)) {

			if(!empty($_GET['page'])) {
				$this->query_page = $_GET['page'];
			}
			if(!empty($_GET['limit'])) {
				$this->query_limit = $_GET['limit'];
			}
		}

		if($this->query_page < 2) {
			return " LIMIT {$this->query_limit}";
		}

		$from = ($this->query_limit * $this->query_page) - $this->query_limit;
		return " LIMIT {$from},{$this->query_limit}";

	}

	public function getRowsCount() {

		return $this->getDB()->get_var( "SELECT COUNT(*) FROM {$this->getTableFullName()}".$this->query );
	}

	private function getPagination() {

		$total = $this->getRowsCount();

		return [
			'total' => (int) $total,
			'pages' => ceil($total / $this->query_paginate),
			'page' => (int) $this->query_page
			];
	}

	private function queryUpdate($data, $where=null)
	{

		if(!$where) {
			$key = $this->primary_key;
			$where = [$key => $this->{$key}];
		}

		$this->getDB()->update($this->getTableFullName(),$data, $where);

	}

	private function queryInsert($entry)
	{
		$table = $this->getTableFullName();
		$this->getDB()->insert($table, $entry);
		return $this->getInsertId();
	}

	private function newRowQuery($columns=null)
	{

		if($columns) {
			$this->query_columns = $columns;
		}

		if(is_array($this->query_columns)) {
			$this->query_columns = implode(',',$this->query_columns);
		}

  //  echo $this->query_columns; exit;

		$query = "SELECT {$this->query_columns} FROM {$this->getTableFullName()}";


    // NEW
    if(!empty($this->innerjoin)) {
      $query = $this->innerJoinAppend();
    }
    elseif(!empty($this->query_leftjoin)) {

      // append left join columns
      $query = $this->leftJoinAppend();

    }
    else {
      $query = "SELECT {$this->query_columns} FROM {$this->getTableFullName()}";
    }


    $query .= $this->query;






    if($this->query_orderby) {
      if(strstr($this->query_orderby, 'ORDER BY') == false) {
        $query .= ' ORDER BY';
      }
      $query .= ' '.$this->query_orderby;
    }

    return $this->getDB()->get_row($query);
	}

	public function getTableFullName($table=null) {

		if(!$table) {
			$table = $this->table;
		}

		// custom prefix (override all other settings)
		if(!empty($this->custom_prefix)) {
    		return $this->custom_prefix.$table;
    	}

    	if(!empty($this->use_app_id)) {
			$table = self::$plugin_app_id.'_'.$table;
		}



    	if(!empty($this->dbcon)) {

    		// check for prefix
    		$dbcon = $this->dbcon;
    		if(!empty($affiliate_pages_pro_dbcons[$dbcon]->prefix)) {
    			$table = $affiliate_pages_pro_dbcons[$dbcon]->prefix.$table;
    		}
    		return $table;

    	} else {
    		// always is
    		global $wpdb;
    		return $wpdb->prefix.$table;
    	}
	}

	private function getInsertId()
	{
		if(!empty($this->dbcon)) {
			global $affiliate_pages_pro_dbcons;
			return $affiliate_pages_pro_dbcons[$this->dbcon]->insert_id;
		} else {
			global $wpdb;
			return $wpdb->insert_id;
		}
	}

	private function getDB() {
		if(!empty($this->dbcon)) {
			global $affiliate_pages_pro_dbcons;
			return $affiliate_pages_pro_dbcons[$this->dbcon];
		} else {
			global $wpdb;
			return $wpdb;
		}
	}
}
