<?php

/**

* 18th 10th. added home route support

* 9th / 10th Require api in route
 * August 8, 2018 (8.8.18)
 * fixed middleware request
 *
 * June 12, 2018
 * Added support to shorthand DataTabes
 *
 * May 17 2018
 * now supports modular routes
 * now supports verables in router
 * module class prepend default ML_Mod_
 */



if(class_exists('AffiliatePagesPro_PageRoute')) {
    return;
}

class AffiliatePagesPro_PageRoute extends AffiliatePagesPro
{

	protected static $verables=null;

  protected static $page;

	private static function middleware($middleware, $request)
	{
		include_once(plugin_dir_path(__FILE__).'../Middleware/'.$middleware.'.php');

		$name = self::getPrefix($middleware);
		if(!(new $name())->handle($request)) {
			return false;
		}

		return true;
	}

  public static function getDataTable($path, $cont='', $meth='index', $middleware=null, $mod=null)
  {

    if(strpos($path, '/') !== 0) {
			$path = '/'.$path;
		}
		if(empty($cont)) {
			$cont = ucfirst(ltrim(rtrim($path,'s'),'/'));
		}
		if(strstr($cont, 'DataTable') == false) {
			$cont .= 'DataTable';
		}

    echo $cont; exit;

    self::get($path, 'DataTables/'.$cont.'@'.$meth, $middleware, $mod);
  }

	/**
	 * add databables to routes api. Shorthand,
	 * @param  string $path       router path to datatabe
	 * @param  string $cont       optional, datatable model name used to find DataTable.php file
	 * @param  [type] $middleware [description]
	 * @param  [type] $mod        [description]
	 * @return [type]             [description]
	 */
	public static function dataTable($path, $cont='', $middleware=null, $mod=null)
	{


		if(strpos($path, '/') !== 0) {
			$path = '/'.$path;
		}

    // cont
    if(empty($cont)) {
			$cont = ucfirst(ltrim(rtrim($path,'s'),'/'));
		}
		if(strstr($cont, 'DataTable') == false) {
			$cont .= 'DataTable';
		}

    // prepend api
    if(strpos($path, '/api/') !== 0) {
      $path = '/api'.$path;
    }

    self::get($path, 'DataTables/'.$cont.'@index', $middleware, $mod);
    self::post($path, 'DataTables/'.$cont.'@create', $middleware, $mod);
    self::get($path.'/{id}', 'DataTables/'.$cont.'@show', $middleware, $mod);
    self::post($path.'/{id}', 'DataTables/'.$cont.'@update', $middleware, $mod);
    self::post($path.'/{id}/delete', 'DataTables/'.$cont.'@destroy', $middleware, $mod);
	}

	public static function user($path, $cont='', $middleware=null, $mod=null)
	{
		if(strpos($path, '/') !== 0) {
			$path = '/'.$path;
		}
		if(empty($cont)) {
			$part = explode('/',trim($path,'/'));
			// $last = array_pop($part);
			$cont = ucfirst(ltrim(rtrim(array_pop($part),'s'),'/'));
		}

		self::get($path, 'Users/'.$cont.'@index', $middleware, $mod);
		self::post($path, 'Users/'.$cont.'@create', $middleware, $mod);
		self::get($path.'/{id}', 'Users/'.$cont.'@show', $middleware, $mod);
		self::post($path.'/{id}', 'Users/'.$cont.'@update', $middleware, $mod);
		self::post($path.'/{id}/delete', 'Users/'.$cont.'@destroy', $middleware, $mod);

	}

	public static function postType($path, $cont='', $middleware=null, $mod=null)
	{
		if(strpos($path, '/') !== 0) {
			$path = '/'.$path;
		}
		if(empty($cont)) {
			$cont = ucfirst(ltrim(rtrim($path,'s'),'/'));
		}

		self::get($path, 'PostTypes/'.$cont.'@index', $middleware, $mod);
		self::post($path, 'PostTypes/'.$cont.'@create', $middleware, $mod);
		self::get($path.'/{id}', 'PostTypes/'.$cont.'@show', $middleware, $mod);
		self::post($path.'/{id}', 'PostTypes/'.$cont.'@update', $middleware, $mod);
		self::post($path.'/{id}/delete', 'PostTypes/'.$cont.'@destroy', $middleware, $mod);
		self::post($path.'/{id}/sort/{sort}', 'PostTypes/'.$cont.'@onSort', $middleware, $mod);

	}

	public static function head($path, $cont, $middleware=null, $mod=null)
	{
		if($_SERVER['REQUEST_METHOD'] != 'HEAD' || !self::validate($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod);
	}

	public static function get($path, $cont, $middleware=null, $mod=null)
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET' || !self::validate($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod);
	}

	public static function post($path, $cont, $middleware=null, $mod=null)
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST' || !self::validate($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod);
	}

	public static function put($path, $cont, $middleware=null, $mod=null)
	{
		if($_SERVER['REQUEST_METHOD'] != 'PUT' || !self::validate($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod);
	}

	private static function ok($cont, $middleware=null, $mod=null) {



		$re = self::getPrefix('Request');
		$request = new $re(self::$verables);

		if(!empty($middleware)) {
			$pass = self::middleware($middleware, $request);
			if(!$pass) {
				return; // faield middleware
			}
		}

		$p = explode('@', $cont);
		$n = explode('/',$p[0]);

		$path = '../';

		if(!empty($mod)) {
			$path .= '../modules/'.$mod.'/app/';
		}

		$name = array_pop($n);

		if(strstr($name, 'Controller') == true) {
			$path .= 'Controllers/';
		}
		$name = self::getPrefix($name);

    // echo plugin_dir_path(__FILE__).$path.$p[0].'.php'; exit;
		// echo $cont.' '.$p[0]; exit;

		include_once(plugin_dir_path(__FILE__).$path.$p[0].'.php');

		$meth = $p[1];

		(new $name())->$meth(self::$page, $request);

		exit;

	}








	private static function validate($path) {


		global $wp;


		if(!empty($wp->request)) {
			$request = $wp->request;
		} else {
			$request = $_SERVER['REQUEST_URI'];
		}

		if(strstr($request,'?') == true) {
			$p = explode('?', $request);
			$request = $p[0];
		}
		$request = trim($request,'/');

		$p = explode('/',$request);

    // does not have root

    self::$page = AffiliatePagesPro_Page::where('slug', $p[0])->first();

    return !empty(self::$page);
	}

	private static function getVerable($str) {
		return str_replace('{','',str_replace('}','',$str));
	}

	private static function apiCors() {
		header("Access-Control-Allow-Origin: *");
		header("Access-Control-Allow-Headers: *");
		header("Access-Control-Allow-Methods: GET, POST, PUT, PATCH, DELETE, HEAD, OPTIONS");
	}

}
