<?php

/*
30.12.2018
Add post data for better support to update and create (otherwise always goes for user_id)
 */

if(class_exists('AffiliatePagesPro_Request')) {
    return;
}

class AffiliatePagesPro_Request extends AffiliatePagesPro
{

	protected $request_vars = [];

	public function __construct($vars=null, $onlyVars=false)
	{

    if(!$onlyVars) {
      if(!empty($_GET)) {
  			$this->loadGetRequestVars($_GET);
        $this->get_data = $_POST;
  		}
  		if(!empty($_POST)) {
  			$this->loadGetRequestVars($_POST);
        $this->post_data = $_POST;
  		}
    }

		if(!empty($vars)) {
			$this->loadGetRequestVars($vars);
		}
	}

  public function ifExists($key, $def=null) {

    // secondary support for arrays
    if(is_array($key)) {
      $value = $this->only($key);
      if(!empty($value)) {
        return $value;
      } else {
        return $def;
      }
    }

    // single
    if(!empty($this->{$key})) {
      return $this->{$key};
    }
    return $def;
  }

	public function only($arr)
	{

		if(empty($arr)) {
			return [];
		}

		if(!is_array($arr)) {
			$arr = [$arr];
		}

		$re = [];

		foreach ($arr as $i) {
			if(isset($this->{$i})) {
				$re[$i] = $this->{$i};
			}
		}
		return $re;
	}

	public function validate($args)
	{
		foreach ($args as $i) {
			if(empty($this->{$i})) {
				return false;
			}
		}
		return true;
	}

	public function getRequestUrl($includeGet=false, $args=null)
	{

		global $wp;

		$url = get_site_url(null, $wp->request);

		if(!empty($includeGet) && !empty($_GET)) {
			$appendArgs = $_GET;
		} else {
			$appendArgs = [];
		}

		// override gets if same
		if(!empty($args)) {
			$appendArgs = array_merge($appendArgs, $args);
		}

		if(!empty($appendArgs)) {
			$url = $this->appendToUrl($url, $appendArgs);
		}
		return $url;
	}

	private function appendToUrl($url, $args) {

		if(!strstr($url, '?')) { $url .= '?'; }
		else { $url = rtrim($url, '&').'&';}

		foreach ($args as $key => $value) {
			$url .= $key.'='.urlencode($value).'&';
		}
		return rtrim($url, '&');
	}

	private function loadGetRequestVars($varrs)
	{
		foreach ($varrs as $key => $value) {
			$this->{$key} = $this->parseValue($value);
		}
	}

	private function parseValue($v)
	{
		// number format
		if(is_numeric($v)) {
			if(!strstr($v,'.')) {
				$v = (int) $v;
			} else {
				$v = (float) $v;
			}
		}

		elseif($v === 'true') {
			$v = true;
		}
		elseif($v === 'false') {
			$v = false;
		}
		return $v;
	}
}
