<?php

/**
 *
 * 04.12.2018
 * Added no exit to get route
 *
 * 14.11.18 updated middleware to support Packages/

* 18th 10th. added home route support

* 9th / 10th Require api in route
 * August 8, 2018 (8.8.18)
 * fixed middleware request
 *
 * June 12, 2018
 * Added support to shorthand DataTabes
 *
 * May 17 2018
 * now supports modular routes
 * now supports verables in router
 * module class prepend default ML_Mod_
 */



if(class_exists('AffiliatePagesPro_Route')) {
    return;
}

class AffiliatePagesPro_Route extends AffiliatePagesPro
{

	protected static $verables=null;

  protected static $custom_prefix = null;

  protected static $constructor_request = false;

  public static function setConstructorRequest($set = false) {
    self::$constructor_request = $set;
  }

  private static function validatePath($path)
  {
    self::$custom_prefix = null;

    if(strstr($path,':') == true) {

      $dirs = explode('/',$path);
      $count = 0;
      foreach($dirs as $dir) {
        if(strstr($dir,':') == true) {

          // tidy dir
          $dir = trim($dir,':');

          // option is set
          if(!empty(self::$options) && !empty(self::$options[$dir])) {

            if(self::$options[$dir] == '/') {
              echo 'set direct'; exit;
            } else {
              $dirs[$count] = self::$options[$dir];

              if(!self::$custom_prefix) {
                self::$custom_prefix = self::$options[$dir];
              }
            }

          }

        }
        $count++;
      }
      $path = implode('/',$dirs);
    }

    // echo "path: {$path}"; exit;

    return $path;
  }

  public static function head($path, $cont, $middleware=null, $mod=null)
	{
		if($_SERVER['REQUEST_METHOD'] != 'HEAD' || !self::validate($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod);
	}

	public static function get($path, $cont, $middleware=null, $mod=null, $no_exit=false)
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET' || !self::validate($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod, $no_exit);
	}

	public static function post($path, $cont, $middleware=null, $mod=null)
	{
		if($_SERVER['REQUEST_METHOD'] != 'POST' || !self::validate($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod);
	}

	public static function put($path, $cont, $middleware=null, $mod=null)
	{
		if($_SERVER['REQUEST_METHOD'] != 'PUT' || !self::validate($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod);
	}

	private static function ok($cont, $middleware=null, $mod=null, $no_exit=false) {

		$re = self::getPrefix('Request');
		$request = new $re(self::$verables);

		if(!empty($middleware)) {
			$pass = self::middleware($middleware, $request);
			if(!$pass) {
				return; // faield middleware
			}
		}

		$p = explode('@', $cont);
		$n = explode('/',$p[0]);

		$path = '../';

		if(!empty($mod)) {
			$path .= '../modules/'.$mod.'/app/';
		}

		$name = array_pop($n);

		if(strstr($name, 'Controller') == true) {
			$path .= 'Controllers/';
		}
		$name = self::getPrefix($name);

		// echo $cont.' '.$p[0]; exit;

		include_once(plugin_dir_path(__FILE__).$path.$p[0].'.php');

		$meth = $p[1];

    if(self::$constructor_request) {
      (new $name($request))->$meth($request);
    }
    else {
      (new $name())->$meth($request);
    }



    if(!$no_exit) {
      exit;
    }


	}

  public static function getAll($path, $cont, $middleware=null, $mod=null, $no_exit=false)
  {
    if($_SERVER['REQUEST_METHOD'] != 'GET') {
      return;
    }
    self::ok($cont, $middleware, $mod, $no_exit);
  }



	public static function getRoot($path, $cont, $middleware=null, $mod=null, $no_exit=false)
	{
		if($_SERVER['REQUEST_METHOD'] != 'GET' || !self::validateRoot($path)) {
			return;
		}

		self::ok($cont, $middleware, $mod, $no_exit);
	}



  private static function validateRoot($path) {


		global $wp;


		if(!empty($wp->request)) {
			$request = $wp->request;
		} else {
			$request = $_SERVER['REQUEST_URI'];
		}

		if(strstr($request,'?') == true) {
			$p = explode('?', $request);
			$request = $p[0];
		}
		$request = trim($request,'/');

		$p = explode('/',$request);


    // home
    if($path === '/' && empty($p[0])) {
      return true;
    }


    $paths = explode('/', trim($path, '/'));

    if(count($p) != count($paths)) {
      return false;
    }

    // validate
    $count = 0;

    foreach($paths as $i) {

      if(strstr($i,'}') == false && $i != $p[$count]) {
        return false;
      }
      elseif(strstr($i,'}') == true) {
        $key = trim(trim($i,'}'),'{');
          // echo $key; exit;
        self::$verables[$key] = $p[$count];
      }
      $count++;
    }

    if(!empty($p[0]) && $p[0] == 'api') {
      self::apiCors();
    }

    // add cors tracking for first route

    return true;
		}







	private static function middleware($middleware, $request)
	{
    if(strstr($middleware,'/') == false) {
      $middleware = 'Middleware/'.$middleware;
      $name = self::getPrefix($middleware);
    } else {
      $part = explode('/', $middleware);
      $name = self::getPrefix(array_pop($part));
    }

		include_once(plugin_dir_path(__FILE__).'../'.$middleware.'.php');

		if(!(new $name())->handle($request)) {
			return false;
		}

		return true;
	}

  public static function getDataTable($path, $cont='', $meth='index', $middleware=null, $mod=null)
  {

    if(strpos($path, '/') !== 0) {
			$path = '/'.$path;
		}
		if(empty($cont)) {
			$cont = ucfirst(ltrim(rtrim($path,'s'),'/'));
		}
		if(strstr($cont, 'DataTable') == false) {
			$cont .= 'DataTable';
		}

    echo $cont; exit;

    self::get($path, 'DataTables/'.$cont.'@'.$meth, $middleware, $mod);
  }

	/**
	 * add databables to routes api. Shorthand,
	 * @param  string $path       router path to datatabe
	 * @param  string $cont       optional, datatable model name used to find DataTable.php file
	 * @param  [type] $middleware [description]
	 * @param  [type] $mod        [description]
	 * @return [type]             [description]
	 */
	public static function dataTable($path, $cont='', $middleware=null, $mod=null)
	{
		if(strpos($path, '/') !== 0) {
			$path = '/'.$path;
		}

    // cont
    if(empty($cont)) {
			$cont = ucfirst(ltrim(rtrim($path,'s'),'/'));
		}
		if(strstr($cont, 'DataTable') == false) {
			$cont .= 'DataTable';
		}

    // echo $cont; exit;

    // prepend api
    if(strpos($path, '/api/') !== 0) {
      $path = '/api'.$path;
    }

    // echo $path; exit;

    // slug


    self::get($path, 'DataTables/'.$cont.'@index', $middleware, $mod);
    self::post($path, 'DataTables/'.$cont.'@create', $middleware, $mod);
    self::get($path.'/{id}', 'DataTables/'.$cont.'@show', $middleware, $mod);
    self::post($path.'/{id}', 'DataTables/'.$cont.'@update', $middleware, $mod);
    self::post($path.'/{id}/delete', 'DataTables/'.$cont.'@destroy', $middleware, $mod);
    self::post($path.'/{id}/dublicate', 'DataTables/'.$cont.'@dublicate', $middleware, $mod);

    self::post($path.'/{id}/sort-move-up', 'DataTables/'.$cont.'@onSortUp', $middleware, $mod);
    self::post($path.'/{id}/sort-move-down', 'DataTables/'.$cont.'@onSortDown', $middleware, $mod);

    self::post($path.'/{id}/check-slug', 'DataTables/'.$cont.'@checkSlug', $middleware, $mod);
    self::post($path.'/query/check-slug', 'DataTables/'.$cont.'@checkSlug', $middleware, $mod);
	}

	public static function user($path, $cont='', $middleware=null, $mod=null)
	{
		if(strpos($path, '/') !== 0) {
			$path = '/'.$path;
		}
		if(empty($cont)) {
			$part = explode('/',trim($path,'/'));
			// $last = array_pop($part);
			$cont = ucfirst(ltrim(rtrim(array_pop($part),'s'),'/'));
		}

		self::get($path, 'Users/'.$cont.'@index', $middleware, $mod);
		self::post($path, 'Users/'.$cont.'@create', $middleware, $mod);
		self::get($path.'/{id}', 'Users/'.$cont.'@show', $middleware, $mod);
		self::post($path.'/{id}', 'Users/'.$cont.'@update', $middleware, $mod);
		self::post($path.'/{id}/delete', 'Users/'.$cont.'@destroy', $middleware, $mod);
		// self::post($path.'/{id}/sort/{sort}', 'Users/'.$cont.'@onSort', $middleware, $mod);

	}

	public static function postType($path, $cont='', $middleware=null, $mod=null)
	{
		if(strpos($path, '/') !== 0) {
			$path = '/'.$path;
		}
		if(empty($cont)) {
			$cont = ucfirst(ltrim(rtrim($path,'s'),'/'));
		}

		self::get($path, 'PostTypes/'.$cont.'@index', $middleware, $mod);
		self::post($path, 'PostTypes/'.$cont.'@create', $middleware, $mod);
		self::get($path.'/{id}', 'PostTypes/'.$cont.'@show', $middleware, $mod);
		self::post($path.'/{id}', 'PostTypes/'.$cont.'@update', $middleware, $mod);
		self::post($path.'/{id}/delete', 'PostTypes/'.$cont.'@destroy', $middleware, $mod);
		self::post($path.'/{id}/sort/{sort}', 'PostTypes/'.$cont.'@onSort', $middleware, $mod);

	}

	private static function validate($path) {

    // echo $path;
    $path = self::validatePath($path);

    // echo '<br />'.$path; exit;


		global $wp;


		if(!empty($wp->request)) {
			$request = $wp->request;
		} else {
			$request = $_SERVER['REQUEST_URI'];
		}

		if(strstr($request,'?') == true) {
			$p = explode('?', $request);
			$request = $p[0];
		}
		$request = trim($request,'/');

		$p = explode('/',$request);

    // does not have root
		if($p[0] != self::$plugin_app_cl && !self::$custom_prefix) {
			return;
		}



    // home
    if($path === '/' && empty($p[1])) {
      return true;
    }

    if(self::$custom_prefix) {
      $path = trim($path,'/');
      $fullPath = $path;
    } else {
      $fullPath = self::$plugin_app_cl.$path;
    }

		if(strstr($fullPath,'{') == true) {
			//
			$fullPathMatch = $fullPath;

			$routePart = explode('/', $fullPath);
			$requestPart = explode('/', $request);

			$count = 0;

			foreach($routePart as $i) {

				if(strstr($i, '{') == true) {

					if(empty($requestPart[$count])) {
						return false;
					}

					$id = self::getVerable($i);

					// set verables
					self::$verables[$id] = $requestPart[$count];

					$fullPathMatch = str_replace('{'.$id.'}', $requestPart[$count], $fullPathMatch);

				}
				$count++;
			}

			if($fullPathMatch != $request) {
				return false;
			}

			// ok
			if(!empty($p[1]) && $p[1] === 'api') {
				self::apiCors();
			}

			return true;
		}


		// check plain route

		if((!self::$custom_prefix && self::$plugin_app_cl.$path == $request) || (self::$custom_prefix && $request == $path)) {

			if(!empty($p[1]) && $p[1] === 'api') {
				self::apiCors();
			}

			return true;
		}

		return;
	}

	private static function getVerable($str) {
		return str_replace('{','',str_replace('}','',$str));
	}

	private static function apiCors() {
    
		header("Access-Control-Allow-Origin: *");
		header("Access-Control-Allow-Methods: GET, POST, PUT, PATCH, DELETE, HEAD, OPTIONS");
	}

}
