<?php

if(class_exists('AffiliatePagesPro_Shortcode')) {
    return;
}

class AffiliatePagesPro_Shortcode extends AffiliatePagesPro
{

	protected $id;

	protected $require_args;

	protected $default_args = ['id' => ''];

	public function __construct()
	{

		add_shortcode( $this->id, [$this, 'validate']);
	}

	public function validate($args, $content = null)
	{
		// validate
		if(!empty($this->require_args)) {
			if(!is_array($this->require_args)) {
				if(empty($args[$this->require_args])) {
					return;
				}
			}

			elseif(!empty($this->require_args)) {
				foreach($this->require_args as $i) {
					if(empty($args[$i])) {
						return;
					}
				}
			}
		}

		// do defaults
		if(!empty($this->default_args)) {
			$args = shortcode_atts( $this->default_args, $args );
		}

		return $this->doShortcode($args, $content);
	}


	// Helper Functions

	public function argsArrays($args, $sep=',')
	{
		if(empty($args)) {
			return $args;
		}

		$args = explode($sep, $args);

		$list = [];

		foreach($args as $i) {
			array_push($list, trim($i));
		}

		return $list;
	}
}
