<?php

class AffiliatePagesPro_Time
{
	protected $args = [
									'year' => 'Y',
									'year_short' => 'y',
									'month' => 'n',
									'week' => 'W',
									'day' => 'z',
									'hour' => 'G',
									'minute' => 'i',
									'seconds' => 's',
									'weekday' => 'w', // 0 - 6
									'weekday_short' => 'D',
									'weekday_text' => 'l',
									'month_short' => 'M',
									'month_text' => 'F',
									'month_day' => 'j',
									'hour_12' => 'g',
									'a' => 'a',
									'U' => 'U',
									'ts' => 'U',
								];

	public $year;
	public $year_short;
	public $month;
	public $week;
	public $day;
	public $hour;
	public $minute;
	public $seconds;
	public $weekday;
	public $weekday_short;
	public $weekday_text;
	public $month_short;
	public $month_text;
	public $month_day;
	public $hour_12;
	public $a;
	public $U;
	public $ts;

	protected $current_time = [];

  protected $weekdays_text = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];

  protected $weekdays_short = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];

  protected $days_in_month = [
                            31, // Jan
                            28, // Feb, 29 days during leap years (2000,2004,2008,2012, etc.)
                            31, // March
                            30, // April
                            31, // May
                            30, // June
                            31, // July
                            31, // Aug
                            30, // Sep
                            31, // Oct
                            30, // Nov
                            31 // Dec
                          ];

	protected $month_names = [
														'January',
														'February',
														'March',
														'April',
														'May',
														'June',
														'July',
														'August',
														'September',
														'October',
														'November',
														'December'
													];

protected $month_names_short = [
													'Jan',
													'Feb',
													'Mar',
													'Apr',
													'May',
													'Jun',
													'Jul',
													'Aug',
													'Sep',
													'Oct',
													'Nov',
													'Dec'
											];
  public $gmt;

	public function __construct($gmt=0)
	{

    $this->gmt = $gmt;

		$this->current_time = $this->currentTime($gmt);

    // set days in feb (leap year)
    $year = 2016; // start
    while($year <= $this->current_time['year']) {

      if($year == $this->current_time['year']) {
        $this->days_in_month[1] = 29; // feb = 29
        break;
      }

      $year = $year + 4;
    }

		// wp_send_json($this->days_in_month); exit;

	}

  // quick static option
	public static function get($gmt=0)
	{
		return (new static)->getTime($gmt);
	}

  // normal get item
  public function getValue($value, $gmt=0)
  {
    if($gmt != 0) {
      $current = $this->currentTime($gmt);
      return $current[$value];
    }
    return $this->current_time[$value];
  }

  public function getTodayElapsedSeconds()
  {
    $cur = $this->current_time;
    return (($cur['seconds']) + ($cur['minute']*60) + ($cur['hour'] * 3600));
  }

  public function getTodayStartTimeU($adjust=0)
  {
    return ($this->current_time['U'] - $this->getTodayElapsedSeconds() + $adjust);
  }

  public function getCurrentMonth($includeToday=true, $inverse=false)
  {
    return $this->getPastDays($this->current_time['month_day'], $includeToday, $inverse);
  }

  public function getCurrentWeek($includeToday=true, $inverse=false)
  {
    return $this->getPastDays($this->current_time['weekday'], $includeToday, $inverse);
  }

  public function getYesterday()
  {
    return $this->getPastDays(1, false);
  }

  public function getPastWeek($includeToday=true, $inverse=false)
  {
    return $this->getPastDays(7, $includeToday, $inverse);
  }

  public function getPastDays($days=7, $includeToday=true, $inverse=false)
  {

    if(!$includeToday) {
      $days++;
    }

		// echo $days; exit;

    $data = [];

    $c = $this->current_time;

    $month = $c['month'];
    $day = $c['month_day'];
    $year = $c['year'];
    $weekday = $c['weekday'];

    $todayU = $this->getTodayStartTimeU();

		// wp_send_json($todayU); exit;
		// wp_send_json($c); exit;

    if($includeToday) {
      $entry = [
        'start_ts' => $todayU,
        'end_ts' => $todayU + 86400,
        'days_ago' => 0,
        // 'hours_since_today' => 0,
        'year' => $year,
				'year_short' => (int) substr($year,2),
        'month' => $month,
        // 'day' => $day,
        'day' => $day
      ];

      foreach(['weekday_text', 'weekday_short', 'month_text', 'month_short'] as $i) {
        $entry[$i] = $c[$i];
      }

      array_push($data, $entry);

    }

    $count = 1;

    while($count < $days) {

      $daysAgo = $count;
      $U = $todayU - ($count*86400);

			// echo $day; exit;

      // change month
      if($day == 1) {

				// if month move back one month
        if($month == 1) {
          $month = 12;
          $year = $year - 1; // dec
        } else {
          $month = $month - 1;
        }

        $day = $this->days_in_month[($month-1)]; // index -1

      } else {
        $day = $day-1;
				// echo $day."\n";
      }

			// weekday
			if($weekday == 0) {
				$weekday = 6;
			} else {
				$weekday--;
			}
			// echo $weekday; exit;


      $entry = [
				'weekday' => $weekday,
        'weekday_text' => $this->weekdays_text[$weekday],
        'weekday_short' => $this->weekdays_short[$weekday],
        'days_ago' => $daysAgo,
        // 'U' => $U,
        'start_ts' => $U,
        'end_ts' => $U + 86400,
        // 'hours_since_today' => ((($todayU - $U) / 60) / 60),
        'year' => $year,
				'year_short' => (int) substr($year,2),
        'month' => $month,
        'day' => $day,
				'month_text' => $this->getMonthName($month),
				'month_short' => $this->getMonthNameShort($month),
      ];

      array_push($data, $entry);

      $count++;

    }

    if(!$inverse) {
      $data = array_reverse($data);
    }

    return $data;
  }

  public function getPastDaysCountUp($days=7, $includeToday=true)
  {
    $data = [];

    $c = $this->current_time;

    if($c['weekday'] < 6) {
      $weekdayCount = $c['weekday']+1;
    } else {
      $weekdayCount = 0;
    }

    $todayU = $this->getTodayStartTimeU();

    while($days > 0) {

      $U = $todayU - (($days-1)*86400);

      $daysAgo = ($days - 1);

      $entry = [
        'weekday_text' => $this->weekdays_text[$weekdayCount],
        'weekday_short' => $this->weekdays_short[$weekdayCount],
        'days_ago' => $daysAgo,
        'start_ts' => $U,
        'end_ts' => $U + 86400,
        // 'hours_since_today' => ((($todayU - $U) / 60) / 60)
      ];

      array_push($data, $entry);
      $days--;

      if($weekdayCount > 5) {
        $weekdayCount = 0;
      } else {
        $weekdayCount++;
      }
    }

    if(!$includeToday) {
      array_pop($data);
    }

    return $data;
  }



  // coming soon
  public function getRange($from, $to=null, $inverse=false)
  {

    $c = $this->current_time;

    if(empty($to)) {
      $to = $c['U'];
    }

    $from++;
    $to++;

    $U = $this->getTodayStartTimeU();
    $todayStartU = $U;

    // Test
    // $from = $U - (3*86400)+1;
    // $to = $from + (2*86400);

    $days = ($to - $from) / 86400;

    $month = $c['month'];
    $day = $c['month_day'];
    $year = $c['year'];
    $weekday = $c['weekday'];

    $rewindDays = ($c['U'] - $to) / 86400;
    $rewindDays = floor($rewindDays);

  //  echo "<br />rewind days: $rewindDays, $weekday";

    $count = 0;

    while($count < $rewindDays) {

      if($day == 1) {

        if($month == 1) {
          $month = 12;
          $year = $year - 1; // dec
        } else {
          $month = $month - 1;
        }

        $day = $this->days_in_month[($month-1)]; // index -1

      } else {
        $day = $day-1;
      }

      $U = $U - 86400;

      // weekday
      if($weekday < 1) {
        $weekday = 6;
      } else {
        $weekday--;
      }

      $count++;
    }

    // echo "<br />done, $weekday"; exit;
    // add rewind

    // Start Build
    $data = [];

    $count = 0;

    $daysAgo = $rewindDays;

    while($count < $days) {


    $entry = [
      'weekday' => $weekday,
      'weekday_text' => $this->weekdays_text[$weekday],
      'weekday_short' => $this->weekdays_short[$weekday],
      'days_ago' => $daysAgo,
      // 'U' => $U,
      'start_ts' => $U,
      'end_ts' => $U + 86400,
      'hours_since_today' => ((($todayStartU - $U) / 60) / 60),
      'year' => $year,
      'month' => $month,
			'month_text' => $this->getMonthName($month),
			'month_short' => $this->getMonthNameShort($month),
      'day' => $day,
      // 'today_day' => $c['day'],
      // 'u_diff' => ($todayStartU - $U)
    ];

    array_push($data, $entry);

      $daysAgo++;
      $U = $U - 86400;

      // change month
      if($day == 1) {

        if($month == 1) {
          $month = 12;
          $year = $year - 1; // dec
        } else {
          $month = $month - 1;
        }
        $day = $this->days_in_month[($month-1)]; // index -1

      } else {
        $day = $day-1;
      }

      if($weekday < 1) {
        $weekday = 6;
      } else {
        $weekday--;
      }

      $count++;

    }

    if($inverse) {
      $data = array_reverse($data);
    }

    // wp_send_json($data); exit;
    return $data;
  }


















	public function getTime($gmt=0)
	{
    if($gmt != 0) {
      return $this->currentTime($gmt);
    }
		return $this->current_time;
	}

  private function currentTime($gmt=0)
  {
    $keys = array_keys($this->args);

		$values = array_values($this->args);

		$str = implode(' ', $values);

		$values = explode(' ',current_time(implode(' ', $values), $gmt));

		$data = [];

		$count = 0;

		foreach($keys as $key) {

			if(is_numeric($values[$count])) {
				$data[$key] = (int) $values[$count];
			} else {
				$data[$key] = $values[$count];
			}

			$count++;
		}

		if($data['a'] == 'am') {
			$data['am'] = true;
			$data['pm'] = false;
		} else {
			$data['am'] = false;
			$data['pm'] = true;
		}

		foreach($data as $key => $value) {
			$this->{$key} = $value;
		}

		return $data;
  }

	// private function getYearShort($year)
	// {
	// 	return $this->month_names[($month-1)];
	// }

	private function getMonthName($month)
	{
		return $this->month_names[($month-1)];
	}

	private function getMonthNameShort($month)
	{
		return $this->month_names_short[($month-1)];
	}
}
