<?php

// New lighting fast with app.json config options version for 2019



class AffiliatePagesPro_Uploads extends AffiliatePagesPro
{


  // get uconfig (lighting fast)

  protected static $cache=[];

  public static function getConfig($field=null, $default=null, $file = 'app.json')
  {
    if(!is_null($field)) {

      if(isset(self::$cache['_config_value_set_'.$field])) {
        return self::$cache['_config_value_'.$field];
      }

      $value = self::getJsonValue($file, $field);

      self::$cache['_config_value_'.$field] = $value; // support empty values
      self::$cache['_config_value_set_'.$field] = true;

    } else {

      if(isset(self::$cache['_config_set'])) {
        return self::$cache['_config'];
      }

      $value = self::getJson($file);
      self::$cache['_config'] = $value;
      self::$cache['_config_set'] = true;

    }


    if(empty($value)) {
      return $default;
    }

    return $value;

  }


  // update config

  public static function updateConfig($dataOrField, $value='', $file = 'app.json')
  {
    if(is_object($dataOrField) || is_array($dataOrField)) {
      return self::update($file, $dataOrField);
    }
    // update
    return self::updateValue($file, $dataOrField, $value);
  }



  // Uploads

  public static function updateValue($file, $field, $value)
  {
    $data = self::getJson($file);

    if(empty($data)) {
      return null;
    }

    $data->{$field} = $value;

    return self::update($file, $data);

  }

  public static function updateJson($file, $data)
  {
		$file = trim($file,'.json').'.json';
		return self::update($file, $data);
	}

  public static function update($file, $data)
  {
    // format json or object
    if(is_array($data) || is_object($data)) {
      $data = json_encode($data);
    }

    return self::put($file, $data);
  }

  // raw file put, no format
  public static function put($file='', $data)
  {

    $file = self::getDir().'/'.trim($file,'/');

    if(is_array($data) || is_object($data)) {
      $data = json_encode($data);
    }

    return file_put_contents($file, $data);
  }

  // returns file data
  public static function get($file='', $jsonOrArray=false, $value=null, $array=false)
  {

    $file = self::getDir().'/'.trim($file,'/');

    if(!file_exists($file)) {
      return null;
    }

    return file_get_contents($file);
  }

  public static function getJson($file='', $array=false)
  {
		$file = trim($file,'.json').'.json';
    return json_decode(self::get($file), $array);
  }

  public static function getJsonValue($file='', $value)
  {
    $data = self::getJson($file);
    if(!empty($data) && isset($data->{$value})) {
      return  $data->{$value};
    }
    return null;
  }

  public static function getDir($target='', $create=true, $createIndex=false) {

    $dir = wp_upload_dir();

    $path = $dir['basedir'].'/'.self::$plugin_app_id;

    wp_mkdir_p($path);

    if(!empty($createIndex)) {
      file_put_contents($path.'/index.php', '<?php // Silence is golden.');
    }

    if(!empty($target)) {
      $dirs = explode('/', trim($target,'/'));
      foreach($dirs as $i) {
        $path .= '/'.$i;
        wp_mkdir_p($path);
        if(!empty($createIndex)) {
          file_put_contents($path.'/index.php', '<?php // Silence is golden.');
        }
      }
    }

    return $path;
  }

}
