<?php
// https://codex.wordpress.org/Class_Reference/WP_User_Query

affiliate_pages_pro_use([
	'Core/User/Index',
	'Core/User/Create',
	'Core/User/Show',
	'Core/User/Update',
	'Core/User/Destroy',
    'Helpers/StrGen',
    'Helpers/User/UserToken'
]);

if(class_exists('AffiliatePagesPro_User')) {
    return;
}

class AffiliatePagesPro_User extends AffiliatePagesPro
{

	use AffiliatePagesPro_UserIndex,
        AffiliatePagesPro_UserCreate,
        AffiliatePagesPro_UserShow,
		AffiliatePagesPro_UserUpdate,
		AffiliatePagesPro_UserDestroy,
        AffiliatePagesPro_StrGen,
        AffiliatePagesPro_UserToken;

    protected $query_allow_not_exists = false;

	protected $query_orderby = 'id';

	protected $query_order = 'ASC';

    protected $query_limit = 25; // default limit

    protected $query_page = 1;

    protected $query_meta_key;

    protected $query_meta_value;

    protected $query_meta_compare;

    protected $query_search_columns;
    
    protected $user_fields = [
                        'ID' => 'id', 
                        // 'user_login', 
                        // 'user_pass', 
                        // 'user_nicename', 
                        'user_email'=> 'email', 
                        // 'user_url', 
                        'user_registered' => 'created', 
                        // 'user_activation_key', 
                        // 'user_status', 
                        // 'display_name'
                    ];

    protected $meta_fields = [
                        'first_name',
                        'last_name'
    ];

    // // get
    protected $query_vars = [
				    	'order',
				    	'orderby',
    					'limit', 
    					'page', 
                        'q',
    					// 'post_status', 
    					'meta_key', 
    					'meta_value', 
    					'meta_compare',
    					'search_columns'
    				];

    protected $query_wp_keys = [
    					'page' => 'paged', 
    					'limit' => 'number',
    					'q' => 'search'
					];

	protected $user_info_fields = ['first_name', 'last_name'];

    protected $fillable = [
    					'first_name',
    					'last_name',
                        'user_email',
                        'user_login'
    ];

    protected $query_fields = ['id', 'first_name', 'last_name', 'user_email'];

    protected $allow_select = false;

    protected $allow_multiselect = false;

    protected $allow_create = false;

    protected $allow_edit = false;

    protected $allow_delete = false;

    protected $allow_dublicate = false;
    
    // should be user??
    public function getPostMetaKey($id, $post_meta_key=null) {
        if(empty($post_meta_key)) {
            $post_meta_key = $this->$post_meta_key;
        }
        return self::$plugin_app_id.'_'.$post_meta_key.'_'.$id;
    }
}