<?php

affiliate_pages_pro_use('Core/MenuPage');

class AffiliatePagesPro_Vue extends AffiliatePagesPro_MenuPage
{
    protected $dev_path;
    // add vue functionality
    protected $vue_public_dir = 'client';

    protected $vue_primary_color = '#0173aa';

    protected $vue_use_prem = true;

    protected $package = 'vuetify';

    protected $view_name;

    protected $vue_pub_url;

    protected $app_addons = [];

    protected $use_quill;

    protected $header_print_includes_css = [
        // 'admin-bar-rtl',
        // 'admin-bar',
        // 'buttons-rtl',
        'buttons',
        // 'customize-preview-rtl',
        // 'customize-preview',
        // 'dashicons',
        // 'editor-rtl', 'editor',
        // 'jquery-ui-dialog-rtl',
        // 'jquery-ui-dialog',
        // 'media-views-rtl',
        'media-views',
        // 'wp-auth-check-rtl',
        // 'wp-auth-check',
        // 'wp-embed-template-ie',
        // 'wp-embed-template',
        // 'wp-pointer-rtl',
        // 'wp-pointer'
    ];

    public function getVersionExt()
    {
        return '?version=' . AffiliatePagesPro::getInfo('version');

    }

    public function vueHeader()
    {

        $versionExt = $this->getVersionExt();

        if (!empty($this->header_print_includes_css)) {

            $url = includes_url('css/');
            foreach ($this->header_print_includes_css as $i) {
                echo '  <link href="' . $url . $i . '.css" rel="stylesheet">' . "\n";
            }
        }

        // enque headers
        $this->vue_pub_url = affiliate_pages_pro_public_url($this->vue_public_dir);

        //
        echo '<link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.6.0/css/all.css" />
      <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900">
      <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Material+Icons">';

        if (empty(self::$debug) || empty($this->dev_path)) {

            echo
            '
      <link href="' . $this->vue_pub_url . '/css/app.css' . $versionExt . '" rel="preload" as="style">
      <link href="' . $this->vue_pub_url . '/css/chunk-vendors.css' . $versionExt . '" rel="preload" as="style">

      <link href="' . $this->vue_pub_url . '/js/app.js' . $versionExt . '" rel="preload" as="script">
      <link href="' . $this->vue_pub_url . '/js/chunk-vendors.js' . $versionExt . '" rel="preload" as="script">

      <link href="' . $this->vue_pub_url . '/css/chunk-vendors.css' . $versionExt . '" rel="stylesheet">
      <link href="' . $this->vue_pub_url . '/css/app.css' . $versionExt . '" rel="stylesheet">
      ';
        }

        echo '<style>
      #adminmenu li.current a.menu-top {
          background: ' . $this->vue_primary_color . ';
        }
        .v-toolbar__items a {
          font-weight: 400;
          font-family: -apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,Oxygen-Sans,Ubuntu,Cantarell,"Helvetica Neue",sans-serif
        }
        .notice, #screen-meta, #contextual-help-wrap, .update-nag, #wpfooter {
          display: none;
        }
        button .v-btn__content {
          font-weight: 400;
        }
        #wpbody-content .wrap {
          margin: 0px;
        }';

        echo '#adminmenuback { background: #22272d;
        }
        ul#adminmenu a.wp-has-current-submenu:after, ul#adminmenu>li.current>a.current:after {
              right: 0;
              border: solid 8px transparent;
              content: " ";
              height: 0;
              width: 0;
              position: absolute;
              pointer-events: none;
              border-right-color: ' . $this->vue_primary_color . ';
              top: 50%;
              margin-top: -8px;
          }
          p, h1, h2, h3, h4, h5, h6 {
            color: inherit;
          }
       ';

        $o = self::$options;

        if (!empty($o) && !empty($o['b_active'])) {

            if (!empty($o['b_color'])) {
                echo 'body .primary {' .
                    'background-color: ' . $o['b_color'] . '!important;' .
                    'border-color:' . $o['b_color'] . '!important;' .
                    '}';
            }

            // light body
            if (empty($o['b_light'])) {

                echo
                    'body .primary--text, ' .
                    'body #wpbody-content .theme--light a, ' .
                    'body #wpbody-content .primary--text,' .
                    'body #wpbody-content a.v-breadcrumbs__item' .
                    '{' .
                    'color:' . $o['b_color'] . ';' .
                    'caret-color:' . $o['b_color'] . ';' .
                    '' .
                    '' .
                    '}';

                ?>
            body #wpbody-content .v-toolbar__content a {
              color: #fff;
            }
          <?php

            } else {
                echo '.v-btn__content {color: #000;}' .
                    'body #wpbody-content a {' . $o['b_color'] . '} ';

            }

        } // / b_active

        echo '</style>';

        echo '<link rel="stylesheet" href="https://cdn.plyr.io/3.5.2/plyr.css" />';
        echo '<script src="https://cdn.plyr.io/3.4.7/plyr.polyfilled.js"></script>';

        if (!empty($this->use_quill)) {
            echo '<link rel="stylesheet" href="//cdn.quilljs.com/1.3.6/quill.bubble.css" />';
        }

    }

    public function enqueScripts()
    {
        wp_enqueue_media();

        // remove styles
        wp_deregister_style('buttons');
        wp_enqueue_style('nav-menus');
        wp_enqueue_style('wp-pointer');
        wp_enqueue_style('widgets');
        wp_enqueue_style('site-icon');
        wp_enqueue_style('dashicons');
        wp_enqueue_style('admin-menu');
        wp_enqueue_style('common');
        wp_enqueue_style('dashboard');
        wp_enqueue_style('themes');

        // wp_enqueue_style('list-tables');
        // wp_enqueue_style('edit');
        // wp_enqueue_style('media');
        // wp_enqueue_style('wp-auth-check');
        // wp_enqueue_style('buttons');

        // remove unused styles
        add_action('admin_print_scripts', [$this, 'vueHeader']);

    }

    public function onPage()
    {
        ?>
        <style>
        .ml-css-loading-spinner-ring {
  display: inline-block;
  position: relative;
  width: 64px;
  height: 64px;
}
.ml-css-loading-spinner-ring div {
  box-sizing: border-box;
  display: block;
  position: absolute;
  width: 102px;
  height: 102px;
  margin: 12px;
  border: 5px solid #333;
  border-radius: 50%;
  animation: ml-css-loading-spinner-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;
  border-color: #ccc transparent transparent transparent;
}
.ml-css-loading-spinner-ring div:nth-child(1) {
  animation-delay: -0.45s;
}
.ml-css-loading-spinner-ring div:nth-child(2) {
  animation-delay: -0.3s;
}
.ml-css-loading-spinner-ring div:nth-child(3) {
  animation-delay: -0.15s;
}


@keyframes ml-css-loading-spinner-ring {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}

.aligncenter {
text-align: center;
width: initial;
margin: auto;
}
img.aligncenter {
text-align: center;
width: initial;
height: initial;
margin: auto;
}
</style>
<div id="ml_css_loading_spinner_wrapper" class="vue-loader-wrapper" align="center">
<div class="ml-css-loading-spinner-ring"><div></div><div></div><div></div><div></div></div>
</div>
<script>
document.getElementById('ml_css_loading_spinner_wrapper').style.paddingTop = Math.floor(window.innerHeight/2)-51+'px';
document.getElementById('ml_css_loading_spinner_wrapper').style.display = 'block'
// setTimeout(function(){
// // document.getElementById('ml_css_loading_spinner_wrapper').style.display = 'none'
// }, 3000);
</script>
      <?php

        $data = [
            'api'     => $this->route('api'),
            // 'prem' => 1,
            'token'   => AffiliatePagesPro_Auth::userGet(),
            // 'siteurl' => get_site_url(),
            'siteurl' => get_bloginfo('wpurl'),
            //'editor' => $this->getAdminUrl('editor')
        ];

        ?><div class="vue-loader-wrapper">
        <?php
echo '<div id="' . self::$plugin_app_id . '"';
        foreach ($data as $key => $value) {
            echo ' data-' . $key . '="' . $value . '"';
        }

        if (!empty($this->app_addons)) {
            foreach ($this->app_addons as $i) {
                if ($this->hasAddon($i)) {
                    echo ' data-' . $i;
                }
            }
        }

        if (!empty(self::$options) && !empty(self::$options['b_active'])) {
            if (!empty(self::$options['brand_title'])) {
                echo ' data-blogo=""';
            }

        }

        echo '></div>';
        echo '</div>';

        $versionExt = $this->getVersionExt();

        if (empty(self::$debug) || empty($this->dev_path)) {
            echo '<script src="' . $this->vue_pub_url . '/js/chunk-vendors.js' . $versionExt . '"></script>';
            echo '<script src="' . $this->vue_pub_url . '/js/app.js' . $versionExt . '"> </script>';
        } else {
            echo '<script src="' . $this->dev_path . '/app.js' . $versionExt . '"></script>';
        }

    }
}
