<?php

affiliate_pages_pro_use([
  'Helpers/Routes'
]);

class AffiliatePagesPro_VuePage extends AffiliatePagesPro
{
  use AffiliatePagesPro_Routes;

  protected $id;

  protected $public = 'client';

  protected $iconset = 'material';

  protected $public_url;

  protected $styles = [
    'chunk-vendors',
    'app'
  ];

  protected $scripts = [
    'chunk-vendors',
    'app'
  ];


  protected $title = '';

  protected $atts = [];

  public function __construct($atts=[])
  {
    if(empty($this->id)) {
      $this->id = self::$plugin_app_id;
    }

    $this->public_url = affiliate_pages_pro_public_url($this->public);
    // echo $this->public_url;

    // $dataAtts['siteurl'] = get_site_url();

    if(!empty($atts)) {
      $this->atts = $atts;
    }

    $this->atts['api'] = $this->route('api');

  }

  public function view()
  {
    // echo 'view page';

    echo '<html lang="en"><head>';
    echo '<meta charset="utf-8"><meta http-equiv=X-UA-Compatible content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1">';

    // font
    echo '<link rel=stylesheet href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900">';

    // icons
    if(!empty($this->iconset) && $this->iconset === 'material') {
      echo '<link rel=stylesheet href="https://fonts.googleapis.com/css?family=Material+Icons">';
    }
    elseif(!empty($this->iconset) && $this->iconset === 'fa') {
      // echo '<link rel=stylesheet href="https://fonts.googleapis.com/css?family=Material+Icons">';
    }

    echo '<link rel="stylesheet" href="https://cdn.plyr.io/3.5.2/plyr.css" />';
    echo '<script src=https://cdn.plyr.io/3.4.7/plyr.polyfilled.js></script>';

    // preload styles
    foreach($this->styles as $i) {
      echo '<link href="'.$this->public_url.'/css/'.$i.'.css" rel="preload" as="style">';
    }

    // preload scripts
    foreach($this->scripts as $i) {
      echo '<link href="'.$this->public_url.'/js/'.$i.'.js" rel="preload" as="script">';
    }

    // styles
    foreach($this->styles as $i) {
      echo '<link href="'.$this->public_url.'/css/'.$i.'.css" rel="stylesheet">';
    }

    echo '<style>html,body, body div.application.theme--light {border: 0px;padding:0px;background:#000;}</style>';

    echo '</head><body>';

    echo '<div id="'.$this->id.'"';
    // data atts
    if(!empty($this->atts)) {
      foreach($this->atts as $key => $value) {
        echo ' data-'.$key.'="'.$value.'"';
      }
    }
    echo '></div>';

    // footer scripts
    foreach($this->scripts as $i) {
      echo '<script src="'.$this->public_url.'/js/'.$i.'.js"></script>';
    }


    echo '</body></html>';


    exit;
  }
}
