<?php

affiliate_pages_pro_use([
	'Core/Request',
	'Controllers/Controller'
]);

class AffiliatePagesPro_WPPage extends AffiliatePagesPro_Controller
{

	// array or string
	protected $post_type = 'page';

	protected $match_setting_key = 'settings';

	protected $match_setting_id;

	protected $require_login = false;

	protected $use_exit = false;

	protected $post_id; // is set during construct

	public function __construct()
	{

		global $post;

		if(is_singular() &&  !empty($post) && !empty($post->post_type)) {

			// array or singlar
			if(!is_array($this->post_type)) {
				$this->post_type = [$this->post_type];
			}

			foreach($this->post_type as $postType) {

				if($postType == $post->post_type) {

					$this->post_id = $post->ID;

					return $this->isPostTypeMatch();

				}
			}
		}
	}


	public function index($request) {}


	// validate 2
	public function isPostTypeMatch()
	{
		global $post;

		if(!empty($this->match_setting_id)) {
			$match = $this->getOptionValue($this->match_setting_key, $this->match_setting_id);
			if(empty($match) || $match != $post->ID) {
				return; // fail match
			}
		}

		if(!empty($this->require_login) && get_current_user_ID() < 1) {
			return $this->onLoginRedirect();
		}

		// valid page
		$request = new AffiliatePagesPro_Request();
		$this->index($request);
		if($this->use_exit) {
			exit;
		}

	}


	// if require_login active, send user to login page
	public function onLoginRedirect()
	{

		$url = get_permalink();

		wp_redirect(wp_login_url($url));
		exit;
	}

}
