<?php

affiliate_pages_pro_use([
	'Core/DataTable',
	'Core/Uploads',
	'Models/Block',
  'Models/Page',
	'Models/Split'
]);


class AffiliatePagesPro_BlockDataTable extends AffiliatePagesPro_DataTable
{
	// protected $unique_fields = ['slug'];
	protected $use_sort = true;

	protected $sort_by = 'sort';

	protected $sort_append_on_create = true;

	protected $sort_append_on_create_match = 'page_id';

  public function builder()
  {
      return AffiliatePagesPro_Block::query();
  }

	public function getColumns()
	{
		return ['*'];
	}



	public function onDestroy($item, $request)
  {

		// remove splits
		$i = new AffiliatePagesPro_Split;
    $i->wpDelete(['block_id' => $item->id]);

  }


	public function updateFilter($item, $request)
	{

		// schedule start

		if(!empty($item->schedule_start) && !empty($item->schedule_startdate) && !empty($item->schedule_starttime)) {
			date_default_timezone_set($item->schedule_timezone);
			$item->schedule_startu = strtotime($item->schedule_startdate.' '.$item->schedule_starttime.':00');
		} else {
			$item->schedule_startu = 0;
			$item->schedule_start = 0;
		}

		// scheduled end
		if(!empty($item->schedule_end) && !empty($item->schedule_enddate) && !empty($item->schedule_endtime)) {
			date_default_timezone_set($item->schedule_timezone);
			$item->schedule_endu = strtotime($item->schedule_enddate.' '.$item->schedule_endtime.':00');
		} else {
			$item->schedule_endu = 0;
			$item->schedule_end = 0;
		}

		// item_startdate
		if(!empty($item->item_startdate) && !empty($item->item_starttime)) {

			// set timezone
			if(!empty($item->item_timezone)) {
				date_default_timezone_set($item->item_timezone);
			}

			$item->item_startu = strtotime($item->item_startdate.' '.$item->item_starttime.':00');
		} else {
			$item->item_startu = 0;
		}
		// echo $item->item_startu; exit;
		// wp_send_json([$item, $request]); exit;

		return $item;

	}

}
