<?php

affiliate_pages_pro_use([
	'Core/DataTable',
	'Core/Uploads',
  'Models/Page',
	'Models/Block',
	'Models/Split',
	'Models/Visit',
	'Models/Click',
	'Models/Stat',
	// 'Models/Stat',
	// 'Models/Play',
	// 'Models/Load',
	// 'Models/Conversion'
]);


class AffiliatePagesPro_PageDataTable extends AffiliatePagesPro_DataTable
{
	protected $unique_fields = ['slug'];

	protected $slug_on_create = 'title';

	protected $dublicate_block_fields = [
		// 'id',
		'identifier',
		'user_id',
		'page_id',

		'block_type',
		'type_id',
		'video_id',

		'title',
		'des',
		'content',

		// 'clicks',

		'sort',

		'video',
		'is_video',
		'start',
		'end',
		'autoplay',
		'hide_controls', // 0: no, 1: yes, 2: muted
		'poster',// (0: autohide, 1: always, 2: never )
		'poster_pause',
		'poster_end',
		'duration',
		'trim_active',
		'product_placement',
		'muted',
		'product_img',
		'auto_redirect',
		'disable_fullscreen',
		'disable_mask',

		'url',
		'target',
		'is_dark',
		'color',
		'style',
		'item_style',
		'size',
		'item_link',

		'margin',
		'margin_x',
		'margin_y',
		'padding',
		'use_margin',
		'use_padding',
		'text_color',
		'shadow',
		'item_shadow',
		'bg_color',
		'bg_image',
		'source',

		'flex_xs',
		'flex_sm',
		'flex_md',
		'flex_lg',
		'align',

		'item_height',
		'item_width',
		'item_contain',
		'aspect_ratio',
		'custom_size',

		// 'is_split',
		// 'split_id',
		// 'split_index',

		// v1.0.4
		'schedule_timezone',
		'schedule_start',
    'schedule_startdate',
    'schedule_starttime',
    'schedule_startu',
    'schedule_end',
    'schedule_enddate',
    'schedule_endtime',
    'schedule_endu',

		'item_timezone',
		'item_start',
		'item_startdate',
		'item_starttime',
		'item_startu',

		'border_radius',
		'title_color',
		'color2',
		'spacing_x',
		'spacing_y',

		'item_end',
		'item_enddate',
		'item_endtime',
		'item_endu',
		'hide_ended',
		'item_borderradius',
		'expanded',
		'show_more',
		'left_icon',
		'left_iconcolor',
		'right_icon',
		'right_iconcolor',

		// v1.0.10
		'item_block'
	];



	public function showFilter($item)
	{

		$data['data'] = $item;

		if(!empty($item->footer_menu)) {
			$data['footer_links'] = $this->getMenu($item->footer_menu);
		}
		$data['blocks'] = AffiliatePagesPro_Block::where('page_id', $item->id)

		->orderBy('sort')->get();

		if(!empty($data['blocks'])) {
			$count = 0;
			foreach($data['blocks'] as $i) {

				if(empty($i->is_split)) {
					$data['blocks']{$count}->is_split = '0';
				}

				// set item_starts_in in
				if(!empty($i->item_startu)) {
					$data['blocks']{$count}->item_starts_in = (int) $i->item_startu - current_time('U');
				}

				$count++;
			}
		}

		// prem
		$data['splits'] = AffiliatePagesPro_Split::where('page_id', $item->id)->get();

		// get split ids
		$data['split_ids'] = [];

		if(!empty($data['splits'])) {
			foreach($data['splits'] as $i) {
				array_push($data['split_ids'], $i->id);
			}
		}

		return $data;
	}


  public function builder()
  {
      return AffiliatePagesPro_Page::query();
  }

	public function onDestroy($item, $request)
  {
		// remove blocks
		$block = new AffiliatePagesPro_Block;
    $block->wpDelete(['page_id' => $item->id]);

		// remove stats
		$visits = new AffiliatePagesPro_Visit;
    $visits->wpDelete(['page_id' => $item->id]);

		// remove clicks
		$clicks = new AffiliatePagesPro_Click;
    $clicks->wpDelete(['page_id' => $item->id]);

		// remove splits
		$i = new AffiliatePagesPro_Split;
    $i->wpDelete(['page_id' => $item->id]);

		// remove stats
		$i = new AffiliatePagesPro_Stat;
    $i->wpDelete(['page_id' => $item->id]);

  }


		public function dublicatedFilter($item, $orig)
		{
		  $blocks = AffiliatePagesPro_Block::where('page_id', $orig->id)->get($this->dublicate_block_fields);

		  if(!empty($blocks)) {

		    foreach($blocks as $block) {
		      $create = new AffiliatePagesPro_Block;

					foreach($block as $key => $value) {
						$create->{$key} = $value;
					}
					$create->page_id = $item->id;

					$create->slug = 'custom-set-slug';

					$create->save();

		    }
		  }
		}


	public function getUpdateFields()
	{
		return [
		// 'identifier',
		// 'user_id',
		'page_type',
		'title',
		'des',
		'image',
		'favicon',
		'theme_base',
		'affiliate_link',
		'affiliate_dash',
		'theme_color',
		'text_color',
		'is_dark',
		'bg_color',
		'bg_image',
		'bg_imagefx',
		'bg_imageblur',

		'spacing_x',
		'spacing_y',

		'og_title',
		'og_des',
		'og_keywords',
		'og_img',
		'og_imgw',
		'og_imgh',
		'slug',

		// 'clicks',
		// 'visits',
		// 'visits_unique',

		'tracking_active',
		'tracking_header',
		'tracking_footer',
		'tracking_analytics',
		'tracking_fbpixel',

		// video fields
		'is_active',

		'padding_x',
		'padding_y',
		'margin',
		'margin_x',
		'margin_y',

		'padding',
		'shadow',

		'content_bg',

		'footer_active',
		'footer_color',
		'footer_menu',
		'footer_facebook',
		'footer_twitter',
		'footer_linkedin',
		'footer_instagram',
		'footer_youtube',
		'footer_content',
		'cookies_notice',

		'topbar_active',
		'topbar_color',
		'topbar_textcolor',
		'topbar_title',
		'topbar_logo',
		'topbar_name',
		'topbar_avatar',
		'topbar_shadow',
		'topbar_namelink',
		'topbar_avatarlink',
		'topbar_social',

		'topbar_linktitle',
		'topbar_logolink',
		'topbar_flat',
		'max_width',
		'use_width',

		// advanced
		'epc',

		// v1.0.4
		'schedule_timezone',
		'schedule_start',
		'schedule_startdate',
		'schedule_starttime',
		'schedule_startu',
		'schedule_end',
		'schedule_enddate',
		'schedule_endtime',
		'schedule_endu',
		'redirect_start',
		'redirect_end',
		'border_radius',
		'no_index',

			// v.1.0.11
			'bg_video',
			'bg_mask'
		];

	}

	private function getMenu($slug)
	{
		$links = wp_get_nav_menu_items($slug);

		$menu = [];

		if(!empty($links)) {
			foreach($links as $link) {

				array_push($menu, [
					'url' => $link->url,
					'title' => $link->title,
					'target' => $link->target
				]);
			}
		}

		return $menu;
	}


	public function getColumns()
	{
		return ['*'];
	}

}
