<?php

if(trait_exists('AffiliatePagesPro_Admin')) {
    return;
}

trait AffiliatePagesPro_Admin
{
	/**
	 * Setup to save create or update data from admin pages
	 * @param  [type] $id      [description]
	 * @param  string $meth    [description]
	 * @param  [type] $editors [description]
	 * @return [array]          [description]
	 */
	public function adminPost($id, $meth='update', $editors=null) {
		if(!empty($_POST)) {
			if(!empty($_POST[self::$plugin_app_id.'_'.$id])) {
				$post = $_POST[self::$plugin_app_id.'_'.$id];

				if(!empty($editors)) {
					if(!is_array($editors)) {
						$editors = [$editors];
					}
					foreach($editors as $editor) {
						$key = self::$plugin_app_id.'_'.$id.'_'.$editor;
						if(isset($_POST[$key])) {
							$post[$editor] = $_POST[$key];
						}
					}
				}

				$this->$meth($post);
			}
		}
	}
	
	public function getCurrentAdminUrl()
	{
		$screen = get_current_screen();

		$url = get_admin_url();

		// option page
		if(strpos($screen->base, 'settings_page_') === 0) {
			$url .= 'options-general.php?page='.$_GET['page'];
		}
		
		// menu and submenu page
		elseif(!empty($_GET['page'])) {
			$url .= 'admin.php?page='.$_GET['page'];
		}
		
		return $url;
	}

	public function addMenuPage($id, $name, $icon='video', $meth='menuPage') {

		add_menu_page(
	        $name,
	        $name,
	        $this->access_level,
	        self::$plugin_app_cl.'-'.$id,
	        [$this, $meth],
	        'dashicons-'.$icon,
	        1
        );

		$this->id = $id;

        $this->current_url = $this->getAdminPageUrl();

	}

	public function addSubMenuPage($parent, $id, $name, $meth='subMenuPage') {

		if(strstr($parent,'.') == false) {
			$parent = self::$plugin_app_cl.'-'.$parent;
		}
		add_submenu_page(
	        $parent,
	        $name,
	        $name,
	        $this->access_level,
	        $parent.'-'.$id,
	        [$this, $meth]
        );

		$this->id = $id;
		
        $this->current_url = $this->getAdminPageUrl();

	}

	public function addOptionsPage($id='settings', $name='', $page='optionsPage') {


		if($name == '') {
			$name = self::$plugin_app_name;
		}
		add_options_page(
	        $name,
	        $name,
	        $this->access_level,
	        self::$plugin_app_cl.'-'.$id,
	        [$this, $page]
        );

		$this->id = $id;
		
        $this->current_url = $this->getOptionsPageUrl();

	}
}