<?php

/*

Requires:
Helpers/Options

*/

trait AffiliatePagesPro_Client
{
	public function getClientHasAddonText($addon='prem', $isTrue='true', $isFalse='false')
	{
		$wl_hide = affiliate_pages_pro_get_settings('wl_hide_'.$addon);

		// echo 'WL HIDE: '.$wl_hide; exit;

		if(empty($wl_hide) && $this->hasAddon($addon)) {
		    return $isTrue;
		}
		else {
			return $isFalse;
		}
	}

	public function clientHasAddonText($addon='prem', $isTrue='true', $isFalse='false')
		{
			echo $this->getClientHasAddonText($addon, $isTrue, $isFalse);

		// $wl_hide = affiliate_pages_pro_get_settings('wl_hide_'.$addon);
		//
		// // echo 'WL HIDE: '.$wl_hide; exit;
		//
		// if(empty($wl_hide) && $this->hasAddon($addon)) {
		//     echo $isTrue;
		// }
		// else {
		// 	echo $isFalse;
		// }
	}

	public function getClientToken()
	{

		$args = $this->getOptionAsObject('lic', false);

		$args['site_url'] = get_site_url();
		$args['site_name'] = get_bloginfo('name');

		return base64_encode(json_encode($args));
	}
	/**
	 * requires lic setup
	 * @return [type] [description]
	 */
	public function clientValid()
	{
		$lic = $this->getOptionAsObject('lic');

		// check setup
		if(empty($lic) || empty($lic->product) || empty($lic->product->access)) {
			return false;
		}

		return $this->accessValid($lic->product->access);

	}

	public function getClientTokenExpireColor() {
		$client_token = $this->getOption('client_token');

      if(empty($client_token)) {
        return '#a5aaae';
      }
      else {
        $part = explode('|', $client_token);

        if(!empty($part[2])) {
          $expire = $part[0]+$part[2];
          $timeleft = $expire = current_time('U');
          if($timeleft < 0) {
            return '#d73f35';
          }
          elseif($timeleft < (3*86400)) {
            return '#e85100';
          }
          else {
            return '#1b9957';
          }
        }

      }
	}

	public function hasAddon($addons)
	{
		$lic = $this->getOptionAsObject('lic');

		if(empty($lic) || empty($lic->addons)) {
			return false;
		}

		if(!is_array($addons)) {
			$addons = [$addons];
		}

		foreach ($addons as $i) {

			foreach($lic->addons as $a) {
				// echo json_encode($a); exit;
				if($i == $a->id && $a->access) {

					// check access

					return $this->accessValid($a->access);
				}
			}
		}

		return false;

	}

	public function getUpgradeUrl()
	{
		if(!empty($this->app_sponsor) && !empty($this->app_sponsor['link'])) {
			return $this->app_sponsor['link'];
		}
		return self::$plugin_app_host.'/client/app/'.self::$plugin_app_cl.'/upgrade';
	}


	public function isTrial() {

		$lic = $this->getOptionAsObject('lic');

		return (!empty($lic) && !empty($lic->trial));
	}

	public function isExpTrl() {

		if(!$this->isTrial()) {
			return false;
		}

		// check if sponsored trial, else normal trial
		$sponsor = $this->getSponsor();

		if(!empty($sponsor)) {
			$rem = $this->sponsoredTrialLeft($sponsor);
			return ($rem < 1);
		}

		$lic = $this->getOptionAsObject('lic');

		return (empty($lic->expire) || ($lic->expire < current_time('U')));
	}

	public function sponsoredTrialLeft($sponsor=null)
	{
		if(empty($sponsor)) {
			$sponsor = $this->getSponsor();
		}

		if(empty($sponsor)) {
			return false;
		}

		return (($sponsor['created'] + $sponsor['trace']) - current_time('U'));

	}

	private function accessValid($access)
	{
		if($this->isExpTrl()) {
			return false;
		}

		if(empty($access) ||
			(empty($access->valid) &&
				empty($access->expire_ts) &&
				empty($access->start_ts)
		)) {
			return false;
		}

		if(!empty($access->expire_ts) && $access->expire_ts < current_time('U')) {
			return false;
		}

		if(!empty($access->start_ts) && $access->start_ts > current_time('U')) {
			return false;
		}

		return true;
	}


	public function displayLicense()
	{
		$lic = $this->getOptionAsObject('lic');

		if(!empty($lic)) {

			$valid = $this->validateClient();


				if($this->isExpTrl()) {
					$valid = 'expired';
				}
			?>

			<div class="grid-x grid-padding-x">
				<div class="cell">
					<div class="callout <?php
					if($valid == 'valid') { echo 'success'; }
					if($valid == 'expired') { echo 'alert'; }
					if($valid == 'invalid') { echo 'alert'; }

					?>" style="width: 300px;">

						<?php
						if(!empty($lic->name)) {
							echo 'License Name:<h5 style="padding-top:0">'.$lic->name.'</h5>';
						}

						if(!empty($lic->meta)) {
							echo 'License Holder: <h5>';
								if(!empty($lic->meta->first_name)) {
									echo $lic->meta->first_name;
								}

								if(!empty($lic->meta->last_name)) {
									echo ' '.$lic->meta->last_name;
								}

								echo '</h5>';

							}


							echo 'License Status:';

							if($valid == 'expired') {
								echo '<h5 style="color:red">Expired</h5>';
							} elseif($valid == 'valid') {
								echo '<h5>'.strtoupper($valid).'</h5>';
							}
							else {
								echo '<h5>'.strtoupper($valid).'</h5>';
							}

						if(!empty($lic->addons)) {
							echo 'Addons: <br>';
							foreach($lic->addons as $addon) {
								echo '<div class="label success" style="margin-right: 3px;">'.$addon->name.'</div>';
							}
						}

						if($this->isTrial()) {
							echo '<a href="'.$this->route('admin/upgrade').'" target="_blank" class="button expanded success">Upgrade Your License Now</a>';
						}

						elseif(!empty($lic->upgrade_url)) {
							echo '<a href="'.$lic->upgrade_url.'" target="_blank" class="button expanded success">Upgrade Your License Now</a>';

						}
						?>
					</div>
				</div>
			</div>

			<?php

		}
	}

	public function displayLicenseExpires()
	{
		$lic = $this->getOptionAsObject('lic');

		if(empty($lic->expires)) { // && $lic->expire
			echo '<p>- non expiring -</p>';
		}
	}

	public function validateClient()
	{
		$lic = $this->getOptionAsObject('lic');

		// wp_send_json($lic); exit;

		if(empty($lic) || empty($lic->product) || empty($lic->product->access)) {
			return 'invalid';
		}

		if(!empty($lic->product->access->expire_ts) && $lic->product->access->expire_ts <  current_time('U')) {
			return 'expired';
		}

		if(!empty($lic->product->access->start_ts) && $lic->product->access->start_ts >  current_time('U')) {
			return 'pending';
		}

		return 'valid';

	}

	// not in use
	public function validateClientLic()
	{
		$lic = $this->getOptionAsObject('lic');

		if(empty($lic)) {
			return false;
		}

		if(!empty($lic->expires) && $lic->expires < current_time('U')) {
			return false;
		}

		return true;
	}

	public function updateClientAccessKey($key)
	{
		$this->updateOption('client_access_key', current_time('U').'|'.$key);
	}

	public function getHostGetTokenLink() {
		return self::$plugin_app_host.'/client/get-token';
	}

	/**
	 * post to host license for activation
	 * @param  [type] $email    [description]
	 * @param  [type] $password [description]
	 * @return [type]           [description]
	 */
	public function postLic($email, $password=null)
	{
		if(is_array($email)) {
			$password = $email['password'];
			$email = $email['email'];
		}

		$this->email = $email;
		// append site url
		// info about the package
		$data = [
			'site_url' => get_site_url(),
			'app_id' => self::$plugin_app_id,
			'email' => $email,
			'password' => $password
		];

		$url = self::$plugin_app_host.'/api/client/lic';

		$response = $this->notify($url, $data, true);


		// $this->password = $password;
		// $this->success = json_encode([$response, $url]);

		// wp_send_json($response); exit;

	}

	public function notify($url, $data, $returnResponse=false)
	{

		$response = $this->post($url, $data);

		//wp_send_json(compact('url', 'data', 'response')); exit;

		if(!empty($response->stop_message)) {
			echo $response->stop_message; exit;
		}

		if(!empty($response->success)) {

			if(!empty($response->data)) {

				if(!empty($data['client_access_key'])) {
					$this->updateClientAccessKey($data['client_access_key']);
				}

				// update
				if(!empty($response->data->update)) {
					foreach ($response->data->update as $key => $value) {
						$this->updateOption($key, $value);
					}
				}


				if(!empty($response->data->update_if_new)) {
					foreach ($response->data->update_if_new as $key => $value) {
						$option = $this->getOption($key);
						if(empty($option)) {
							$this->updateOption($key, $value);
						}
					}
				}

				// delete
				if(!empty($response->data->delete)) {
					foreach ($response->data->delete as $i) {
						$this->deleteOption($i);
					}
				}

				if(!empty($response->data->redirect_to)) {
					$this->redirectTo($response->data->redirect_to);
					exit;
				}

				if(!empty($response->data->success)) {
					$this->success = $response->data->success;
				}
			}

		}


		if(!empty($response->error)) {
			$this->error = $response->error;
		}

		if($returnResponse) {
			return $response;
		}
	}

	private function getSiteData() {
		return [
			'site_url' => get_site_url(),
			'app_id' => self::$plugin_app_id
		];
	}

	public function getNoticeIfExpired($expire=null) {

		$lic = $this->getOptionAsObject('lic');

		if(!$expire) {
			$expire = $lic->expires;
		}
		if(empty($expire) || $expire > current_time('U')) {
			// not expired
			return '';
		}
		return $this->getExipredNotice();
	}

	public function getExipredNotice() {
		$url = $this->getExipredNoticeUrl();
		$data = $this->getSiteData();
		$response = $this->get($url, $data);

		if(!empty($response->notice)) {
			return $response->notice;
		}
	}

	public function getExipredNoticeUrl() {
		return self::$plugin_app_host.'/client/lic/expired-notice';
	}










	// Sponsor


	protected $sponsor_cache = [];

	public function trialRemaining()
	{
		if($this->hasSponsor()) {

      $sponsor = $this->getSponsor();

			// echo current_time('U').'<br>';
			wp_send_json($sponsor['trace'] / 86400); exit;

		}

	}

  // if sponsor, returns sponsor, else host upgrade
  public function getPurchaseUrl()
  {

    if($this->hasSponsor()) {

      $sponsor = $this->getSponsor();

      if(!empty($sponsor['id']) && strstr($sponsor['id'],'://') == true) {
        return $sponsor['id'];
      }
      elseif(!empty($sponsor['link']) && strstr($sponsor['link'],'://') == true) {
        return $sponsor['link'];
      }

    }

    // no sponsor
    return self::$plugin_app_host.'/client/app/'.self::$plugin_app_cl.'/upgrade';

  }

  public function displaySponsor($prefixText='',$postfixText='')
  {
    if($this->hasSponsor()) {
      $sponsor = $this->getSponsor();

      if(!empty($sponsor['name'])) {
      echo $prefixText.' '.$sponsor['name'].$postfixText;
      }
    }
  }

  public function hasSponsor() {
    if(!empty($this->app_sponsor) || !empty($this->sponsor_cache)) {
      return true;
    }

    $this->sponsor_cache = $this->getOption('app_sponsor');

     return !empty($this->sponsor_cache);
  }

  public function getSponsor($checkCache=true) {

    if($checkCache && !empty($this->sponsor_cache)) {
      return $this->sponsor_cache;
    }

    $this->sponsor_cache = $this->getOption('app_sponsor');

    return $this->sponsor_cache;
  }



	public function activateSponsor()
	{
		if(empty($this->app_sponsor)) {
			return;
		}

		$exists = $this->getOption('app_sponsor');

		if(empty($exists)) {
			$this->app_sponsor['created'] = current_time('U');
			$this->updateOption('app_sponsor', $this->app_sponsor);
		}

	}

}
