<?php

if(trait_exists('AffiliatePagesPro_DBAlerts')) {
    return;
}

trait AffiliatePagesPro_DBAlerts
{
	public function createSuccess($msg) {
		$this->createAlert($msg, 'success');
	}

	public function getSuccess($del=true) {
		return $this->getAlert();
	}

	public function isSuccess() {
		return $this->alertExists();
	}

	public function createError($msg) {
		$this->createAlert($msg, 'error');
	}

	public function getError($del=true) {
		return $this->getAlert('error');
	}

	public function isError() {
		return $this->alertExists('error');
	}

	public function alertExists($type='success') {

		if(!empty($this->alerts_catch[$type])) {
			return true;
		}

		$key = $this->getAlertKey($type);

		$msg = get_option($key, true);

		$this->alerts_catch[$type] = $msg;
    
	}

	public function createAlert($msg, $type='success') {

		$key = $this->getAlertKey($type);

		$this->alerts_catch[$type] = $msg;

		update_option($key, $msg);

	}

	public function getAlert($type='success', $del=true) {

		if(!empty($this->alerts_catch) && isset($this->alerts_catch[$type]) == true) {
			return $this->alerts_catch[$type];
		}

		$key = $this->getAlertKey($type);

		$msg = get_option($key, true);

		if(!empty($del)) {
			delete_option($key);
		}
		else {
			$this->alerts_catch[$type] = $msg;
		}

		return $msg;

	}

	public function getAlertKey($type='success') {
		return self::$plugin_app_id.'_alert_'.$type;
	}



}
