<?php

if(trait_exists('AffiliatePagesPro_Datetime')) {
    return;
}

trait AffiliatePagesPro_Datetime
{

  public function getSecsToDisplay($secs)
  {
    if($secs > 86400) {
      $val = 86400;
      $text = 'Day';
    }
    elseif($secs > 3600) {
      $val = 3600;
      $text = 'Hour';
    }
    elseif($secs > 60) {
      $val = 60;
      $text = 'Minute';
    }
    else {
      $val = 1;
      $text = 'Second';
    }

    $val = round($secs/$val);
    if($val > 1) {
      $text .= 's';
    }

    return $val.' '.$text;
  }

	public function getStartsIn($datetime, $gmt=0) {
		return (strtotime($datetime) - (($gmt*60)*60)-date('U'));
	}

	/**
	 * Returns datetime
	 * @return [type] [description]
	 */
	public function getDatetime($appendSeconds=0)
	{
		return date("Y-m-d H:i:s", current_time("U")+$appendSeconds);
	}

	public function getFutureDate($expire = null)
	{
		if(strstr($expire,' ') == true) {
			$part = explode(' ', strtolower($expire));
			$num = $part[0];
			$unit = $part[1];
			if($unit == 'minute' || $unit == 'minutes' || $unit == 'mins') {
				$num = $num * 60;
			}
			elseif($unit == 'hour' || $unit == 'hours') {
				$num = $num * 3600;
			}
			elseif($unit == 'day' || $unit == 'days') {
				$num = $num * 86400;
			}
			elseif($unit == 'week' || $unit == 'weeks') {
				$num = $num * 604800;
			}
			elseif($unit == 'month' || $unit == 'months') {
				$num = $num * 2628000;
			}
			elseif($unit == 'year' || $unit == 'years') {
				$num = $num * 31536000; // seconds in 1 year
			}
			return date("Y-m-d H:i:s", current_time("U")+$num);
		}

		elseif(is_numeric($expire) == true) {
			return date("Y-m-d H:i:s", current_time("U")+$expire);
		}

		else {
			return $expire;
		}
	}

	public function dateExpired($exp) {
		if(empty($exp)) {
			return true;
		}
		$now = new DateTime("now");
		$exp = new DateTime($exp);
		return ($now > $exp);

	}

}
