<?php

if(trait_exists('AffiliatePagesPro_Dropbox')) {
    return;
}

/**
 *
 * protected $dropbox_download_links_cache = 'dropbox_file', protected $dropbox_download_links_expire = mins
 */
trait AffiliatePagesPro_Dropbox
{
	// https://api.dropboxapi.com/2/files/delete_v2
	// 
	

	public function dropboxGetDownload($path)
	{
		if(empty($this->dropbox_download_links_cache)) {
			return $this->dropboxGetTemporaryLink($path, false);
		}

		$id = $this->dropboxGetPathKey($path);

		$cached = $this->getOptionValue($this->dropbox_download_links_cache, $id);

		if(!empty($cached) && !$this->dropboxDownloadLinkExpired($cached['ts'])) {
			return $cached['link'];
		}

		$link = $this->dropboxGetTemporaryLink($path, false);

		$entry = [
			'link' => $link,
			'ts' => date('U')
		];

		$this->updateOptionValue($this->dropbox_download_links_cache, $id, $entry);

		return $link;
		exit;
	}

	public function dropboxGetPathKey($path='') {
		return 'path_'.str_replace('-', '_', sanitize_title($path));
	}

	public function dropboxGetDownloadLinkExpire() {
		return (isset($this->dropbox_download_links_expire) ? ($this->dropbox_download_links_expire*60) : 3600*3);
	}

	public function dropboxDownloadLinkExpired($ts) {
		return ($ts < (date('U') - $this->dropboxGetDownloadLinkExpire()));
	}
	
	public function dropboxDelete($path, $arr=true) 
	{
		$url = 'https://api.dropboxapi.com/2/files/delete_v2';

		$access_token = $this->dropboxGetAccessToken();

		$headers['Authorization'] = 'Bearer '.$access_token;
		$headers['Content-Type'] = 'application/json';
		$body = '{"path":"'.$path.'"}';

		$response = (new WP_Http)->request($url, array( 'method' => 'POST', 'headers' => $headers, 'body' => $body));

    	return json_decode($response['body'], $arr);

	}

	public function dropboxCreateFolder($path, $autorename = true, $arr=true) 
	{
		$url = 'https://api.dropboxapi.com/2/files/create_folder_v2';

		$access_token = $this->dropboxGetAccessToken();

		$headers['Authorization'] = 'Bearer '.$access_token;
		$headers['Content-Type'] = 'application/json';
		if($autorename) {
			$body = '{"path":"'.$path.'", "autorename":true}';
		} else {
			$body = '{"path":"'.$path.'", }';
		}

		$response = (new WP_Http)->request($url, array( 'method' => 'POST', 'headers' => $headers, 'body' => $body));

    	return json_decode($response['body'], $arr);

	}


	public function dropboxGetAccessToken() {

		if(empty($this->dropbox) || empty($this->dropbox['access_token'])) {
    		$this->dropbox['access_token'] = $this->getOptionValue('dropbox', 'access_token');
    	}

    	return $this->dropbox['access_token'];
	}

	public function dropboxIsFilePath($path) {
		return (strpos(strtolower($this->master_class['video']),'dropbox:') === 0);
	}

	// dropbox:FILEPATH
	public function dropboxGetTemporaryLinkFromPath($path, $prefix='', $obj=false) {

		if(!empty($prefix)) {
			$i = explode($prefix, $path);
			array_shift($i);
			$path = trim(implode($prefix, $i));

		}

		return $this->dropboxGetTemporaryLink($path, $obj);


	}

	public function dropboxGetTemporaryLink($path='', $obj=true, $arr=true) {
		
		$url = 'https://api.dropboxapi.com/2/files/get_temporary_link';

		$access_token = $this->dropboxGetAccessToken();

		$headers['Authorization'] = 'Bearer '.$access_token;
		$headers['Content-Type'] = 'application/json';
		$body = '{"path":"'.$path.'"}';

		$response = (new WP_Http)->request($url, array( 'method' => 'POST', 'headers' => $headers, 'body' => $body));

		if(empty($obj)) {
			$data = json_decode($response['body']);
			return $data->link;
		}
    	return json_decode($response['body'], $arr);

	}

	 public function dropboxGetFiles($path='', $arr=true) {

    	if(empty($this->dropbox) || empty($this->dropbox['access_token'])) {
    		$this->dropbox['access_token'] = $this->getOptionValue('dropbox', 'access_token');
    	}

    	$url = 'https://api.dropboxapi.com/2/files/list_folder';

    	$headers = [
    		'Authorization' => 'Bearer '.$this->dropbox['access_token'],
    		'Content-Type' => 'application/json'
    	];

    	if(!empty($_GET['dropbox_path'])) {
    		$path = $_GET['dropbox_path'];
    	}

    	$body = '{"path":"'.$path.'"}';

    	$response = (new WP_Http)->request($url, array( 'method' => 'POST', 'headers' => $headers, 'body' => $body));

    	return json_decode($response['body'], $arr);

	// 	$url = 'https://api.dropboxapi.com/2/files/get_temporary_link';

	// 	// $url = 'https://api.dropboxapi.com/2/files/list_folder';
	// 	// $path = '/courses';
	// 	// $path = '/courses/online business in 7 days program';
	// 	// $path = '/courses/online business in 7 days program/videos';
		
	// 	$headers['Authorization'] = 'Bearer '.$this->dropbox['dropbox_access_token'];
	// 	$headers['Content-Type'] = 'application/json';
	// 	$body = '{"path":"'.$path.'"}';

	// 	$request = new WP_Http;
	// $response = $request->request($url, array( 'method' => 'POST', 'headers' => $headers, 'body' => $body));

	// 	// $response = $this->post($url, $body, $headers);
	// 	wp_send_json(json_decode($response['body'])); exit;
	// 	var_dump($response); exit;
    }

}