<?php

if(trait_exists('AffiliatePagesPro_EnqueSimple')) {
    return;
}

trait AffiliatePagesPro_EnqueSimple
{
	/**
	 * Put into construct
	 * @param  [type] $styles  [description]
	 * @param  [type] $scripts [description]
	 * @return [type]          [description]
	 */
	public function enqueSimple($styles=null, $scripts=null)
	{
		if(!$styles) {
			$styles = $this->styles;
		}

		if(!$scripts) {
			$scripts = $this->scripts;
		}	

		if(!empty($styles)) {
			$this->enqueSimpleStyles($styles);
		}

		if(!empty($scripts)) {
			$this->enqueSimpleScripts($scripts);
		}

		if(!empty($this->js_libs)) {
			foreach($this->js_libs as $script) {
				
				wp_enqueue_script(
					$script['handle'], 
					affiliate_pages_pro_js($script['src']), 
					(!empty($script['deps'])?$script['deps'] :''),
					(!empty($script['ver'])?$script['ver']:false),
					(!empty($script['in_footer'])?true:false)
				);

			
			}
		}
		
	}

	public function enqueSimpleStyles($styles=null)
	{
		if(empty($styles) && !empty($this->styles)) {
			$styles = $this->styles;
		}

		if(empty($styles)) {
			return;
		}

		if(!is_array($styles)) {
			$styles = [$styles];
		}

		foreach($styles as $style) {
			$handle = self::$plugin_app_id.'-'.$style;
			$href = affiliate_pages_pro_css($style);
			wp_enqueue_style($handle, $href);
		}
	}

	public function enqueSimpleScripts($scripts=null)
	{
		
		if(empty($scripts) && !empty($this->scripts)) {
			$scripts = $this->scripts;
		}

		if(empty($scripts)) {
			return;
		}

		if(!is_array($scripts)) {
			$scripts = [$scripts];
		}

		foreach($scripts as $script) {

			if(is_array($script)) {
				
				$deps = [];
				$ver = false;
				$in_footer = false;
				$handle = self::$plugin_app_id.'-'.$script['src'];

				if(!empty($script['handle'])) {
					$handle = $script['handle'];
				}
				if(!empty($script['in_footer'])) {
					$in_footer = true;
				}
				if(!empty($script['ver'])) {
					$ver = $script['ver'];
				}

				$src = affiliate_pages_pro_js($script['src']);
				
				wp_enqueue_script($handle, $src, $deps, $ver, $in_footer);

			} else {
				$handle = self::$plugin_app_id.'-'.$script;
				$src = affiliate_pages_pro_js($script);
				wp_enqueue_script($handle, $src);
			}
			
		}
		
	}
}