<?php

if(trait_exists('AffiliatePagesPro_Files')) {
    return;
}

trait AffiliatePagesPro_Files
{

	public function fileIsMedia($file) {
		$i = explode('.', $file);
		$ext = array_pop($i);
		return (in_array(strtolower($ext), ['png','gif','jpg','jpeg','psd','exif','tiff','bmp','ppm','pgm','pbm','webp','svg','mp4','mov','webm','ogv']));
	}

	public function getFiles($src, $includeDirs=false) {
	    
	    $rii = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($src));

		$files = []; 
		$dirs = [];

		foreach ($rii as $file) {

			$path = $file->getPathname(); 

		    if(substr($path,-1) === '.'){
		    	// hidden file
		    	continue;
		    }
		    elseif ($file->isDir()){ 
		    	echo $path; exit;
		    	$dirs[] = $path;
		        continue;
		    }

		    if($this->isHiddenFile($path)) {
		    	
		    	continue;
		    }

		    $files[] = $path;
		}

		if(!empty($includeDirs)) {
			return [
				'files' => $files,
				'dirs' => $dirs
			];
		}

		return $files;

	}

	public function changePathFileName($path, $file) {
		$i = explode('/', $path);
		array_pop($i);
		return implode('/',$i).'/'.$file;
	}

	public function isHiddenFile($path) {
		$path = $this->getFileFromPath($path);
		return (strpos($path,'.') === 0);
	}

	public function getFileFromPath($path) {
		$p = explode('/', $path);
		return array_pop($p);
	}

}