<?php

if(trait_exists('AffiliatePagesPro_Form')) {
    return;
}

trait AffiliatePagesPro_Form
{
	public function wpMedia($wrapper='') {
		if(!empty($wrapper)) {
			$wrapper .= ' ';
		}
			echo '<script>(function($) { function openMedia(target) { var wMedia = wp.media(); wMedia.on(\'select\', function(){ var selection = wMedia.state().get(\'selection\').first().toJSON(); if(selection.url) { $("#"+target).val(selection.url); } }); wMedia.open(); } $( "'.$wrapper.'.ml-media" ).click(function(e) { e.preventDefault(); openMedia($(this).attr(\'data-target\')); }); })( jQuery ); </script>';
	}

	public function wpMediaInput($name, $label='', $placeholder='', $icon='image', $iconRight='', $buttonText='Select Media', $buttonImage='') {

		$id = $this->formGetId($name);
		$name = $this->formGetName($name);

		// echo "id: {$id}, name: {$name}";

		if(!empty($label)) {
			echo '<label class="label">'.$label.'</label>';
		}

		echo '<div class="field has-addons">
		  <p class="control is-expanded has-icons-left">
		    <input id="'.$id.'" name="'.$name.'" value="'.$this->formGetValue($name).'" class="input" type="text" placeholder="'. $placeholder.'">';

		    if(!empty($icon)) {
				   	echo '<span class="icon is-small is-left">
				      <i class="fas fa-'.$icon.'"></i>
				    </span>';
				   }

		 echo '</p>
		  <p class="control">
		    <a class="button ml-media" data-target="'.$id.'">
		     '.$buttonText.'
		    </a>
		  </p>
		</div>';

	}



	public function fSelect($name, $label='', $options=[], $icon='', $emptyOption='-')
	{
		$id = $this->formGetId($name);
		$name = $this->formGetName($name);

		// echo '<div class="field">';
		if(!empty($label)) {
			echo '<label>'.$label.'</label>';
		}

		echo '<div class="field">
			  <div class="control';
			  if(!empty($icon)) {
			  	echo ' has-icons-left';
			  }
			  echo '">
			    <div class="select is-fullwidth">
			      <select id="'.$id.'" name="'.$name.'" value="'.$this->formGetValue($name).'">';



					if(!empty($emptyOption)) {
						echo '<option value="">'.$emptyOption.'</option>';
					}

			      if(is_object($options)) {
			      	echo '<!-- OBJECT fSELECT NOT DONE -->';
			      	// key value
			      	foreach($options as $key => $value) {
			      		if(is_array($value)) {
			      			echo 'value array'; exit;
			      		} else {
			      			echo '<option value="'.$key.'">'.$value.'</option>';
			      		}

			      	}
			      } elseif(is_array($options[0])) {

			      	// key value
			      	foreach($options as $key => $value) {
			      		if(is_array($value)) {
			      			echo 'value array'; exit;
			      		} else {
			      			echo '<option value="'.$key.'">'.$value.'</option>';
			      		}

			      	}
			      } else {

			      	// simple array options
			      	foreach($options as $option) {

			      		$text = '';
			      		$value = '';

			      		if(is_object($option)) {

			      			// OBJECT
			      			if(!empty($option->name)) {
			      				$text = $option->name;
			      			}
			      			if(!empty($option->term_id)) {
			      				$value = $option->term_id;
			      			}

			      		} else {
			      			$text = ucfirst($option);
			      			$value = $option;
			      		}

			      		echo '<option value="'.$value.'"';
			      		echo '>'.$text.'</option>';

			      	}
			      }

			      echo '</select>
			    </div>';

			  if(!empty($icon)) {
			    echo '<div class="icon is-small is-left">
			      <i class="fas fa-'.$icon.'"></i>
			    </div>';
			    }
			 echo '</div>
		</div>';

	}

	public function fInput($name, $label='', $placeholder='', $icon='', $iconRight='', $inputType='text') {

		$id = $this->formGetId($name);
		$name = $this->formGetName($name);

		echo '<div class="field">';
		if(!empty($label)) {
			echo '<label class="label">'.$label.'</label>';
		}
		echo '<div class="control has-icons-left">
		    <input id="'.$id.'" name="'.$name.'" value="'.$this->formGetValue($name).'" class="input"  type="'.$inputType.'" placeholder="'.$placeholder.'">';
		   if(!empty($icon)) {
		   	echo '<span class="icon is-small is-left">
		      <i class="fas fa-'.$icon.'"></i>
		    </span>';
		   }

		  echo '</div>
		</div>';
	}

	public function formDelete($id=null)
	{
		$id = $this->formGetId('delete');

		echo '<div style="float:right">';
		$this->formStart();

		echo '<input type="hidden" name="'.$id.'" value="delete">';
		$this->formSubmit('Delete', 'alert');
		$this->formEnd();
		echo '</div>';
	}


	public function formHiddenValue($name, $value='')
	{
		echo '<input type="hidden" id="'.$this->formGetId($name).'"';
		echo ' name="'.$this->formGetName($name).'" value="'.$value.'" />';
	}

	public function formHidden($name)
	{

		$this->formInput($name, '', '', false, null, 'hidden');
	}

	public function formHasValue($name)
	{
		$isValid = $this->formGetValue($name);
		return !empty($isValid);
	}

  public function formInputSmartHide($name, $label='', $placeholder='', $required=false, $id=null, $type='password') {
    $this->formInput($name, $label, $placeholder, $required, $id, $type, 'ml-form-input-reveal-on-click');
  }

	public function formInput($name, $label='', $placeholder='', $required=false, $id=null, $type='text', $cl='')
	{

		echo (!empty($label) ? '<label>'.$label : '');
		echo '<input type="'.$type.'" id="'.$this->formGetId($name, $id).'"';
		echo (!empty($cl)) ? ' class="'.$cl.'"' : '';
		echo ' name="'.$this->formGetName($name, $id).'" value="'.$this->formGetValue($name, $id).'" placeholder="'.$placeholder.'"';

		if(!empty($required)) {
			echo ' required';
		}
		echo '  autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false" />';
		echo (!empty($label) ? '</label>' : '');
	}

	public function formParseTextarea($str) {
		return str_replace("\\'", '', stripcslashes($str));
	}

	public function formEditor($name, $label='', $open='<div class="grid-x"><div class="cell">', $close='</div></div>', $editorWrapStyle='margin-right:20px;', $id=null)
	{

		echo $close;

		$this->viewCloseWrap();

		// editor wrap
		echo '<div style="'.$editorWrapStyle.'">';

		$editor_id = $this->formGetId($name, $id);

		$args = ['textarea_rows' => 5, 'editor_height' => 200, 'teeny' => false];

		$value = $this->formParseTextarea($this->formGetValue($name, $id));

		wp_editor($value, $editor_id, $args);

		// close editor wrap
		echo '</div>';

		// close
		echo $open;

		$this->viewOpenWrap();


	}


	public function formStart($url='', $id=null, $method='post', $target='self') {
		if(empty($url)) {

			// first option customised
			if(!empty($this->form_url)) {
				$url = $this->form_url;
			}

			// default url should be set by all pages
			elseif(!empty($this->current_url)) {
				$url = $this->current_url;
			}

		}
		echo '<form id="'.$this->formGetId('form', $id).'" action="'.$url.'" method="'.$method.'" target="_'.$target.'">';

	}

	public function formEnd($name=null, $action=null) {

		if(!empty($action)) {

		}
		echo '</form>';
	}

	public function formSubmit($text='Save', $class='', $id = null) {
		echo '<button id="'.$this->formGetId('submit', $id).'" type="submit" class="button '.$class.'" type="submit">'.$text.'</button>';
	}

	public function formOptionsUrl() {
		$this->formUrl('options-general.php');
	}

	public function formUrl($page='admin.php', $args=null) {

		if(empty($args)) {
			$args = ['page' => $_GET['page']];
		}

		$url = get_admin_url().$page;

		$url .= '?';

		foreach ($args as $key => $value) {
			$url .= $key.'='.urlencode($value);
		}

		echo $url;
	}

	public function formSelectWithEmpty($name, $label, $options, $value='value', $text='text', $multiple=false, $id=null)
	{
		$this->formSelect($name, $label, $options, $value, $text, true,  $multiple, $id);
	}
	/**
	 * build select options and populate value automatically from $this->id
	 * @param  String $name    field name
	 * @param  String $label   form field label
	 * @param  Array, Object $options list of options
	 * @param  string $value   the option key if options is array or object
	 * @param  string $text    the option display text if options array or object
	 * @param  String $id      the name of the field group
	 * @return [type]          prints out the list, designed for views
	 */

	public function formSelectRequired($name, $label, $options, $value='value', $text='text', $empty=false, $multiple=false, $id=null)
	{
		$this->formSelect($name, $label, $options, $value, $text, $empty, true, $multiple, $id);
	}

	public function formSelectSetOptions($options, $v='value', $t='text') {

		$items = [];

		foreach($options as $key => $value) {
			$entry[$t] = $key;
			$entry[$v] = $value;
			array_push($items, $entry);
		}

		return $items;
	}

	public function formSelectSimpleOptions($name, $label, $options, $value='value', $text='text', $empty=false, $required=false, $multiple=false, $id=null) {

		$options = $this->formSelectSetOptions($options, $value, $text);

		$this->formSelect($name, $label, $options, $value, $text, $empty, $required, $multiple, $id);
	}

	public function formMultiSelect($name, $label, $options, $value='value', $text='text', $empty=false, $required=false, $id=null) {
		$this->formSelect($name, $label, $options, $value, $text, $empty=false, $required, true, $id);
	}

	public function formSelect($name, $label, $options, $value='value', $text='text', $empty=false, $required=false, $multiple=false, $id=null)
	{

		if(empty($text)) {
			$text = $value;
		}

		if($multiple) {
			// multiple wrap
			echo '<div style="position:relative">';
		}

		echo '<label>'.$label.'<select id="'.$this->formGetId($name, $id).'" name="'.$this->formGetName($name, $id);
		if($multiple) {
			echo '[]" multiple';
		} else {
			echo '"';
		}

		if(!empty($required)) {
			echo ' required';
		}
		echo '>';

		if(!empty($empty)) {
			echo  '<option value="">-</option>';
		}

		foreach($options as $option) {

			if(is_object($option)) {

				echo '<option value="'.$option->{$value}.'"';
				$this->formSelectOptionSelected($name, $option->{$value}, $id);
				echo '>'.$option->{$text}.'</option>';
			}
			elseif(is_array($option)) {
				echo '<option value="'.$option[$value].'"';
				$this->formSelectOptionSelected($name, $option[$value], $id);
				echo '>'.$option[$text].'</option>';
			} else {
				echo '<option value="'.$option.'"';
				$this->formSelectOptionSelected($name, $option, $id);
				echo '>'.$option.'</option>';
			}
		}

		echo '</select></label>';

		if($multiple) {
			echo '
      <button class="button secondary hollow" style="position:absolute;bottom:10px;right:25px;background:rgba(255,255,255,0.9);color:#333" type="button"  onclick="document.getElementById(\''.$this->formGetId($name, $id).'\').value = \'\'">deselect all</button>';

      		echo '</div>';
		}

	}

	// prints selected
	public function formSelectOptionSelected($name, $value='', $id=null) {

		if(empty($id)) {
	 		$id = $this->id;
	 	}

	 	if(!empty($this->{$id}) && !empty($this->{$id}[$name])) {

	 		if(is_array($this->{$id}[$name])) {

	 			if(in_array($value, $this->{$id}[$name])) {
	 				echo ' selected';
	 			}

	 		} elseif($this->{$id}[$name] == $value) {
		 		echo ' selected';
		 	}
	 	}

	}

	public function formInputWithClass($name, $label='', $placeholder='', $required=false, $cl, $id=null, $type='text') {

		return $this->formInput($name, $label, $placeholder, $required=false, $id, $type, $cl);
	}


	public function formTextarea($name, $label='', $placeholder='', $required=false, $rows=3, $id=null)
	{
		echo '<label>'.$label.'<textarea id="'.$this->formGetId($name, $id).'" name="'.$this->formGetName($name, $id).'"placeholder="'.$placeholder.'" rows="'.$rows.'"';

		if(!empty($required)) {
			echo ' required';
		}

		echo '>'.$this->formParseTextarea(($this->formGetValue($name, $id))).'</textarea></label>';
	}

	public function formCheckbox($name, $label='', $value='1', $id=null)
	{
		echo '<label><input type="checkbox" id="'.$this->formGetId($name, $id).'" name="'.$this->formGetName($name, $id).'" value="'.$value.'"';

		if($this->formCheckboxChecked($name, $id)) {
			echo ' checked';
		}
		echo ' />'.$label.'</label>';
	}

	public function formCheckboxChecked($name, $id=null) {

		if(empty($id)) {
	 		$id = $this->id;
	 	}

	 	if(!empty($this->{$id}) && !empty($this->{$id}[$name])) {
	 		return true;
	 	}
	 	return false;

	}

	private function formGetValue($name, $id=null)
	 {
	 	if(empty($id)) {
	 		$id = $this->id;
	 	}

	 	if(!empty($this->{$id}) && is_object($this->{$id})) {
	 		if(!empty($this->{$id}->{$name})) {
	 			return $this->{$id}->{$name};
	 		}
	 		return ''; // empty object
	 	}

	 	if(!empty($this->{$id}) && !empty($this->{$id}[$name])) {
	 		return $this->{$id}[$name];
	 	}
	 	return '';
	 }

	private function formGetName($name, $id=null)
	 {
	 	if(empty($id)) {
	 		$id = $this->id;
	 	}
	 	return self::$plugin_app_id.'_'.$id.'['.$name.']';
	 }

	private function formGetId($name, $id=null)
	 {

	 	if(empty($id)) {
	 		$id = $this->id;
	 	}
	 	return self::$plugin_app_id.'_'.$id.'_'.$name;
	 }

	public function formMetaHeader($key=null) {

		if(empty($key)) {
			$key = $this->meta_key;
		}


		$this->{$key} = $this->getPostMeta($key);
		echo 'get meta data and set key: '.$key;

		exit;
	}

	/**
	 * updates posts, and sets values for forms
	 * @param  [type] $key  [description]
	 * @param  string $type [description]
	 * @return [type]       [description]
	 */
	public function formHeader($key=null, $type='option') {

		if(empty($key)) {
			$key = $this->id;
		}

		$this->formPostIfExists($key);

		if($type == 'option') {
			$this->{$key} = $this->getOption($key);
		}

	}

	public function formPostIfExists($key, $type='option', $success='Updated!', $appPrefix=true)
	{
		if($appPrefix) {
			$postKey = self::$plugin_app_id.'_';
		}
		else { $postKey = ''; }

		$postKey .= $key;

		if(empty($_POST) || empty($_POST[$postKey])) {
			return;
		}

		if($type == 'option') {
			$this->updateOption($key, $_POST[$postKey]);
			$this->success = $success;
		}
		// elseif($type == 'user') {

		// }
		// elseif($type == 'contact') {

		// }

	}

	public function formDateTime($field, $value) {

	}

	public function formTogglerJs($id, $show) {

		?>
		<script>
			jQuery(document).ready(function( $ ) {

			var id = '<?php echo $id; ?>', show = <?php echo isset($show); ?>;

			if(show) {
				$("#"+id+'_editor').css('display', 'block');
			}


			});

		</script>

		<?php
	}

	public function formText($name, $field, $value='')
	{
		echo '<input type="'.(isset($field['type'])?$field['type']:'text').'" name="'.$name.'['.$field['name'].']" value="'.$value.'" placeholder="'.(isset($field['placeholder'])?$field['placeholder']:'').'">';
	}

	public function formTimezone($name, $field, $value='') {
		// $tzlist = DateTimeZone::listIdentifiers(DateTimeZone::ALL);
		// echo var_dump($tzlist); exit;
	}

	public function form($key, $full=false, $fields=null, $buttonText='Save', $action='', $method='post', $target='_self', $appPrefix=true)
	{

		// set data
		//
		if(!$fields) {
			$fields = $key.'_fields';
		}

		if(!is_array($fields)) {
			$fields = $this->{$fields};
		}

		if($appPrefix) {
			$prefix = self::$plugin_app_id.'_';
		}
		else { $prefix = ''; }

		// use full form

		echo (!empty($full)?'<form action="'.$action.'" method="'.$method.'" target="'.$target.'">':'');

		echo '<div class="grid-x">';

		foreach($fields as $field) {

			$value = '';

			// value
			if(!empty($this->{$key})) {
				if(!empty($this->{$key}[$field['name']])) {
					$value = $this->{$key}[$field['name']];
				}
			}


			if(!empty($field['type']) && $field['type'] == 'timezone') {
				$this->formTimezone($prefix.$key, $field, $value);
			}

			// Editor needs to escpe my style
			elseif(!empty($field['type']) && $field['type'] == 'editor') {
				$this->formEditor($prefix.$key, $field, $value);
			}

			// All non editor fields
			else {

				echo '<div class="cell';

				echo (isset($field['small']) ? ' small-'.$field['small'] : '');
				echo (isset($field['medium']) ? ' medium-'.$field['medium'] : '');
				echo (isset($field['large']) ? ' large-'.$field['large'] : '');

				echo '">';

				echo '<label>'.(isset($field['label'])?$field['label']:'');

				// editor

				// date time
				if(!empty($field['type']) && $field['type'] == 'datetime') {
					$this->formDateTime($prefix.$key, $field, $value);
				}

				// text, email, url
				else {
					$this->formText($prefix.$key, $field, $value);
				}

				echo '</label>';

				echo '</div>';

			}
		}

		echo (!empty($full)?'<div class="row"><div class="cell"><button class="button" type="submit">'.$buttonText.'</button></div></div>':'');

		echo '</div>';

		echo (!empty($full)?'</form>':'');


	}

	// hidden value that always sets update timestamp
	public function formUpdated()
	{
		echo '<input type="hidden" name="'.$this->formGetName('updated').'" value="'.current_time('timestamp').'" />';
	}

}
