<?php

if(trait_exists('AffiliatePagesPro_Helper_GetResponse')) {
    return;
}

/**
 *
 * REQUIRES:
 * 'Core/Uploads',
 * OPTION SET:
 * protected $plugin_build_path (root to where the build will go, default is set below)
 * create $this->pluginbuild_error on error
 */
// protected $pluginbuild_required_fields =

trait AffiliatePagesPro_Helper_GetResponse
{

  public $getresponse_api_version = 'v3';

  public function getGetResponseLists($listFormat=true)
  {

    $lists = $this->getOption('getresponse_lists'); // mailchimp list cache

    if(!empty($lists)) {
      if(!empty($listFormat)) {
        $lists = $this->getRepsonseListFormat($lists);
      }
      return $lists;
    }


    // get list
    $data = $this->getResponseGet('campaigns');

    if(!empty($data)) {
      $this->updateOption('getresponse_lists', $data);
      if(!empty($listFormat)) {
        $data = $this->getRepsonseListFormat($data);
      }
      return $data;
    }

    return [];
  }

  public function getRepsonseListFormat($data)
  {

    $lists = [];


    foreach($data as $campaign) {
      if(is_object($campaign)) {
        array_push($lists, ['id' => $campaign->campaignId, 'name' => $campaign->name]);
      } else {
        array_push($lists, ['id' => $campaign['campaignId'], 'name' => $campaign['name']]);
      }
    }

    return $lists;
  }



  // public function getresponseSubscribe($list, $email, $status='subscribed', $fname='', $lname='', $mergeFields=[], $other=[], $returnArray=false)
  // {
  //   $endpoint = 'lists/'.$list.'/members';
  //
  //   $data = ['email_address' => $email, 'status' => $status, 'merge_fields' => []];
  //
  //   if(!empty($fname)) {
  //     $data['merge_fields']['FNAME'] = $fname;
  //   }
  //   if(!empty($lname)) {
  //     $data['merge_fields']['LNAME'] = $lname;
  //   }
  //
  //   // usually merge fields
  //   if(!empty($mergeFields)) {
  //     foreach($mergeFields as $key => $value) {
  //       $data['merge_fields'][$key] = $value;
  //     }
  //   }
  //
  //   // and parse name
  //   if(!empty($other)) {
  //     foreach($other as $key => $value) {
  //       $data[$key] = $value;
  //     }
  //   }
  //
  //   // unset empty merge fields
  //   if(empty($data['merge_fields'])) {
  //     unset($data['merge_fields']);
  //   }
  //
  //   return $this->getResponsePost($endpoint, $data, $returnArray);
  //
  // }


  public function getResponsePost($endpoint='lists/members', $data=null, $returnArray=false, $returnFullResponse=false) {

    if(empty($this->getresponse_apikey)) {
      $this->getresponse_apikey = $this->getOptionValue('settings', 'getresponse_apikey');
    }

    if(empty($this->getresponse_apikey)) {
      $this->error = 'Missing GetResponse Api Key';
      return;
    }

    $body = [];

    if(!empty($data)) {
      // $body = json_decode(json_encode($body));
      foreach($data as $key => $value) {
          $body[$key]= $value;
      }
    }

    $args = [
              'body' => json_encode($body),
              'timeout'	=> 60,
              'headers' => $this->getresponseGetAuth()
              ];
    $args['headers']['Content-Type'] = 'application/json';
    $args['headers']['Accept'] = 'application/json';

    // echo $this->getresponseGetUrl($endpoint); exit;
    // wp_send_json($args); exit;

    $response = wp_remote_post($this->getresponseGetUrl($endpoint), $args);

    if(!empty($returnFullResponse)) {
      return $response;
    }

    // wp_send_json($response['response']['code']); exit;
    return json_decode($response['body'], $returnArray);

  }




  public function getResponseGet($endpoint='campaigns', $returnArray=false) {

    if(empty($this->getresponse_apikey)) {
      $this->getresponse_apikey = $this->getOptionValue('settings', 'getresponse_apikey');
    }

    if(empty($this->getresponse_apikey)) {
      $this->error = 'Missing GetResponse Api Key';
      return;
    }

    // wp_send_json($this->getresponseGetArgs()); exit;
    //echo $this->getresponseGetUrl($endpoint); exit;
    $response = wp_remote_get($this->getresponseGetUrl($endpoint), $this->getresponseGetArgs());
    //wp_send_json(json_decode($response['body'])); exit;

    return json_decode($response['body'], $returnArray);

  }

  public function getresponseGetArgs($body=null) {
    return ['body' => $body, 'timeout'	=> 60, 'headers' => $this->getresponseGetAuth()];
  }

  public function getresponseGetAuth() {
    return ['X-Auth-Token' => 'api-key '.$this->getresponse_apikey];
    // return 'Basic '.base64_encode('apiuser:'.$this->getresponse_apikey);
  }

  public function getresponseGetUrl($endpoint='') {
    return 'https://api.getresponse.com/'.$this->getresponse_api_version.'/'.$endpoint;
  }








}
