<?php

/**
 *
 * Using plural for helpers
 *
 * Reserved:
 * protected $meta_boxes;
 * 
 */
if(trait_exists('AffiliatePagesPro_MetaBoxes')) {
    return;
}

trait AffiliatePagesPro_MetaBoxes
{
	// add to action
	
	// 	add_action('save_post', [$this, 'metaBoxesOnUpdate']);

	// 	add_action( 'add_meta_boxes', [$this, 'metaBoxes'], 10, 2 );

	public function getMetaBoxKey($full=true)
	{
		if(!empty($this->metabox_key)) {
			$id = $this->metabox_key;
		} else {
			$id = $this->id;
		}

		if(!empty($full)) {
			$id = self::$plugin_app_id.'_'.$id;
		}

		return $id;
	}

	public function getMetaBoxesValues()
	{
		global $post;

		$id = $this->getMetaBoxKey(false);

		$fullId = $this->getMetaBoxKey();

		$values = get_post_meta($post->ID, $fullId, true);

		if(empty($values)) {
			return;
		}

		if(empty($this->{$id})) {
			$this->{$id} = [];
		}

		foreach($values as $key => $value) {
			$this->{$id}[$key] = $value;
		}
	}

	public function metaBoxesOnUpdate()
	{

		global $post;

		$id = $this->getMetaBoxKey();		
		
		if(empty($_POST) || isset($_POST[$id]) == false) {
			return;
		}

		update_post_meta($post->ID, $id, $_POST[$id]);
		
	}

	public function getMetaBoxesKeys() 
	{
		$keys = [];

		if(!empty($this->meta_boxes)) {
			foreach($this->meta_boxes as $key => $value) {

				if(!is_array($value)) {
					array_push($keys, $key);
					// $this->addMetaBox($key, $value);
				}
				else {
					array_push($keys, $value['id']);
				}
			}
		}

		return $keys;

	}

	public function metaBoxes()
	{
		$screen = get_current_screen();
		if(!empty($screen->action) && $screen->action == 'add') {
			return;
		}
		// wp_send_json(get_current_screen()); exit;
		if(!empty($this->meta_boxes)) {
			foreach($this->meta_boxes as $key => $value) {

				if(!is_array($value)) {
					$this->addMetaBox($key, $value);
				}
				else {
					$this->addMetaBox($value['id'], $value['title'], $value);
				}
			}
		}

		if(!empty($this->side_metabox)) {
			$this->addMetaBox('side', $this->side_metabox, ['context' => 'side']);
		}
	}

	public function addMetaBox($id, $title='', $args=[]) 
	{
		if(empty($args['callback'])) { $args['callback'] = $id.'MetaBox'; }
		if(empty($args['context'])) { $args['context'] = 'normal'; } // side, advanced
		if(empty($args['priority'])) { $args['priority'] = 'default'; }
		if(empty($args['callback_args'])) { $args['callback_args'] = 'callback_args'; }

		if(empty($args['screen'])) { $args['screen'] = $this->getMetaBoxId(); }

		$cb = $args['callback'];
		add_meta_box($this->getMetaBoxId($id), $title, [$this, $cb], $args['screen'], $args['context'], $args['priority'], $args['callback_args']);
	}

	private function getMetaBoxId($append='') {
		return self::$plugin_app_id.$this->id.$append;
	}
}