<?php

if(trait_exists('AffiliatePagesPro_Options')) {
    return;
}

trait AffiliatePagesPro_Options
{
	protected $options_cache = [];

	public function getOptionWithDefaults($option, $defaults)
	{
		$values = $this->getOption($option);

		if(empty($values)) {
			$values = [];
		}

		if(!is_array($defaults)) {
			$defaults = $this->{$defaults};
		}

		foreach($defaults as $key => $value) {
			if(empty($values[$key])) {
				$values[$key] = $value;
			}
		}
		return $values;
	}

	public function updateOptionPost($id=null)
	{
		if(empty($id)) {
			$id = $this->id;
		}

		$key = $this->getOptionKey($id);

		if(isset($_POST[$key])) {
			return update_option($key, $_POST[$key]);
		}
	}

	/**
	 * @param  array,
	 * @param  string, array
	 * @return [type]
	 */
	public function appendOptionValues($options, $append)
	{
		foreach($append as $key => $values) {
			if(is_array($values)) {
				foreach ($values as $value) {
					$options[$value] = $this->getOptionValue($key, $value);
				}
			} else {
				$options[$values] = $this->getOptionValue($key, $values);
			}
		}
		return $options;

	}

	public function getOptionsMany($options, $merge =[]) {

		$response = [];

		foreach ($options as $key => $value) {


			if(is_array($key)) {
				echo 'arrayu'; exit;
			}
			else {
				$response[$key] = $this->getOption($key);
			}
		}

		wp_send_json($response);
		exit;
	}

	public function getOption($key, $cache=true)
	{
		if($cache && !empty($this->options_cache[$key])) {
			return $this->options_cache[$key];
		}

		elseif(!$cache) {
			return get_option($this->getOptionKey($key));
		}

		$this->options_cache[$key] = get_option($this->getOptionKey($key));
		return $this->options_cache[$key];

	}

	public function option($key, $cache=true)
	{
		if($cache && !empty($this->options_cache[$key])) {
			return $this->options_cache[$key];
		}

		$this->options_cache[$key] = get_option($this->getOptionKey($key));
		return $this->options_cache[$key];

	}

	public function getOptionValue($key, $value, $default=null) {
		$option = $this->getOption($key);
		if(!empty($option[$value])) {
			return $option[$value];
		}
		return $default;
	}

	public function getOptionAsObject($name, $asObject=true) {

		$item = $this->getOption($name);

		if(empty($item)) {
			if(!empty($asObject)) {
				return new stdClass();
			}
			return [];
		}

		if(!empty($asObject) && !is_object($item)) {
			return json_decode(json_encode($item));
		}
		elseif(empty($asObject) && is_object($item)) {
			return json_decode(json_encode($item), true);
		}

		return $item;

	}

	public function updateOption($key, $value)
	{
		if(!empty($value) && is_object($value)) {
			$value = json_decode(json_encode($value), true);
		}
    // wp_send_json($value[0]->name);
    // echo 'update'; exit;
		return update_option($this->getOptionKey($key), $value);

		// return update_option($this->getOptionKey($key), $value);
	}

  public function updateOptionValues($key, $data)
	{
		$option = $this->getOption($key);

		if(empty($option)) {
			$option = [];
		}

    foreach($data as $key => $value)
    {
      $option[$key] = $value;
    }
    return $this->updateOption($key, $option);
	}


	/**
	 * @param  string
	 * @param  string
	 * @param  any
	 * @param  boolean
	 * @return true if updated
	 */
	public function updateOptionValue($key, $field, $value, $onlyIfEmpty=false)
	{
		$option = $this->getOption($key);

		if(empty($option)) {
			$option = [];
		}

		if(!$onlyIfEmpty || empty($option[$field])) {
			$option[$field] = $value;
			return $this->updateOption($key, $option);
		}
	}

	// public function update($key, $value)
	// {
	// 	return update_option($this->getOptionKey($key), $value);
	// }

	public function deleteOption($key)
	{
		// $this->{$key} = $value; // cache
		return delete_option($this->getOptionKey($key));
	}

	// public function delete($key, $value)
	// {
	// 	// $this->{$key} = $value; // cache
	// 	return delete_option($this->getOptionKey($key));
	// }


	private function getOptionKey($key) {
		return self::$plugin_app_id.'_'.$key;
	}
}
