<?php

if(trait_exists('AffiliatePagesPro_PostMeta')) {
    return;
}

/**
 * set protected $post_meta_key
 */

trait AffiliatePagesPro_PostMeta
{
	protected $post_meta_cache = [];

	/**
	 * Gets value from POST if none passed
	 * @param  [type]  $id    [description]
	 * @param  [type]  $key   [description]
	 * @param  [type]  $value [description]
	 * @param  boolean $cache [description]
	 * @return [type]         [description]
	 */
	public function updatePostMeta($id=null, $key=null, $value=null, $cache=true)
	{
		if(!$id) {
			global $post;
			$id = $post->ID;
		}

		if(!$key) {
			$key = $this->post_meta_key;
		}

		$key = $this->getPostMetaKey($key);

		if(!$value && !empty($_POST[$key])) {	
			$value = $_POST[$key];
		}

		if(!empty($value)) {
			return update_post_meta($id, $key, $value);
		}
		else {
			return delete_post_meta($id, $key);
		}
	}

	public function deletePostMeta($id=null, $key=null) 
	{
		if(!$id) {
			global $post;
			$id = $post->ID;
		}

		if(!$key) {
			$key = $this->post_meta_key;
		}

		$key = $this->getPostMetaKey($key);

		return delete_post_meta($id, $key);
	}

	public function getPostMetaValueNoCache($value, $id=null, $key=null, $single=true)
	{
		$meta = $this->getPostMeta($id, $key, $single, false);
		if(isset($meta[$value])) {
			return $meta[$value];
		}
		return null;
	}

	public function getPostMetaValue($value, $id=null, $key=null, $single=true, $cache=true)
	{
		$meta = $this->getPostMeta($id, $key, $single, $cache);
		
		if(isset($meta[$value])) {
			return $meta[$value];
		}
		return null;
	}

	public function getPostMetaNoCache($id=null, $key=null, $single=true)
	{
		return $this->getPostMeta($id, $key, $single, false);
	}

	public function getPostMeta($id=null, $key=null, $single=true, $cache=true)
	{
		if(!$id) {
			global $post;
			$id = $post->ID;
		}

		// check cache

		if(!$cache) {
			$key = $this->getPostMetaKey($key);
			return get_post_meta($id, $key, $single);
		}

		if(!$key) {
			$key = $this->post_meta_key;
		}

		$cache = $id.$key;

		if(isset($this->post_meta_cache[$cache])) {
			return $this->post_meta_cache[$cache];
		}

		// go to db
		$key = $this->getPostMetaKey($key);
		
		$this->post_meta_cache[$cache] = get_post_meta($id, $key, $single);

		return $this->post_meta_cache[$cache];

	}


	private function getPostMetaKey($key=null) {

		if(!$key) {
			$key = $this->post_meta_key;
		}

		return self::$plugin_app_id.'_'.$key;
	}
}