<?php

if(trait_exists('AffiliatePagesPro_Postman')) {
    return;
}

trait AffiliatePagesPro_Postman
{

	public function get($url, $body=[], $headers=null, $args=[], $returnJsonBody=true)
	{
		$data = [];

		if(!empty($body)) {
			$data['body'] = $body;
		}


		if(!empty($headers)) {
			$data['headers'] = $headers;
		}

		if(!empty($args)) {
			foreach($args as $key => $value) {
				$data[$key] = $value;
			}
		}

		$response = wp_remote_get( $url, $data );

		if($returnJsonBody) {
			return json_decode($response['body']);
		}
		return $response;
	}

	// returns body
	public function postBody($url, $body=[], $headers=null, $args=[]) {
		return $this->post($url, $body, $headers, $args, false, true);
	}

  // returns body in array
  public function postA($url, $body=[], $headers=null, $args=[])
  {
    return $this->post($url, $body, $headers, $args, false, false, true);
  }

	public function post($url, $body=[], $headers=null, $args=[], $returnJsonBody=true, $returnBody = false, $returnArray=false)
	{
		$data = [];

		if(!empty($body)) {
			$data['body'] = $body;
		}


		if(!empty($headers)) {
			$data['headers'] = $headers;
		}

		if(!empty($args)) {
			foreach($args as $key => $value) {
				$data[$key] = $value;
			}
		}

		$response = wp_remote_post( $url, $data );

		if(empty($response)
		   || !is_array($response)) {
			return '';
		}

		if($returnJsonBody) {
			return json_decode($response['body'], $returnArray);
		}

		if($returnBody) {
			return $response['body'];
		}

		return $response;
	}

}
