<?php

if(trait_exists('AffiliatePagesPro_Routes')) {
    return;
}

trait AffiliatePagesPro_Routes
{

  public function rootRoute($route='', $args=[]) {

    $url = get_site_url().'/'.ltrim($route, '/');

    if(empty($args)) {
      return $url;
    }
    $url .= '?';
    foreach ($args as $key => $value) {
      $url .= $key.'='.urlencode($value).'&';
    }
    return rtrim($url, '&');
  }

  public function prefixRoute($route='') {

    $prefix = '';

    if(!empty(self::$options['prefix'])) {
      $prefix = self::$options['prefix'];
    }

    $url = get_site_url().'/'.$prefix.'/'.ltrim($route, '/');

		if(empty($args)) {
			return $url;
		}
		$url .= '?';
		foreach ($args as $key => $value) {
			$url .= $key.'='.urlencode($value).'&';
		}
		return rtrim($url, '&');
  }

	public function route($route='', $args=[]) {

		$url = get_site_url().'/'.self::$plugin_app_cl.'/'.ltrim($route, '/');

		if(empty($args)) {
			return $url;
		}
		$url .= '?';
		foreach ($args as $key => $value) {
			$url .= $key.'='.urlencode($value).'&';
		}
		return rtrim($url, '&');
	}

	public function adminRedirect($page=null, $args=[]) {
		$url = $this->adminUrl($page, $args);
		wp_redirect($url); exit;
	}

	public function optionsPageUrl($page='') {
		$url = get_admin_url();
		$page = self::$plugin_app_id.$page;
		$url .= 'options-general.php?page='.$page;
		return $url;
	}

	public function getOptionsPageUrl() {
		return $this->getAdminPageUrl('options-general.php');
	}

	// adds app key for you
	public function getAdminUrl($page, $arrOrKey=null, $val=null) {

		$url = get_admin_url().'admin.php?page='.self::$plugin_app_cl.'-'.$page;

		if(!empty($val)) {
			return "{$url}&{$arrOrKey}=".urlencode($val);
		}
		if(!empty($arrOrKey)) {
			foreach($arrOrKey as $key => $value) {
				$url .= "&{$key}=".urlencode($value);
			}
		}

		return $url;
	}

	public function getAdminPageUrl($page='admin.php',$args=null, $noArgs=false) {
		if(empty($args) && !$noArgs) {
			$args = $_GET;
		}

		return $this->adminUrl($page, $args);
	}

	public function adminUrl($page=null, $args=[]) {

		//
		if(empty($page)) {
			$page = 'admin.php';
			$app_cl = self::$plugin_app_cl;
			$args = ['page' => $app_cl];
		}

		$url = get_admin_url().$page;

		if(!empty($args)) {
			$url .= '?';
			foreach ($args as $key => $value) {
				$url .= $key.'='.urlencode($value).'&';
			}
			$url = substr($url, 0, -1);
		}

		return $url;
	}



	public function getDomain($url=null)
	{
		if(empty($url)) {
			$url = get_site_url();
		}
		$pieces = parse_url($url);
		  $domain = isset($pieces['host']) ? $pieces['host'] : $pieces['path'];
		  if (preg_match('/(?P<domain>[a-z0-9][a-z0-9\-]{1,63}\.[a-z\.]{2,6})$/i', $domain, $regs)) {
		    return $regs['domain'];
 			}
  			return false;
	}
}
