<?php

if(trait_exists('AffiliatePagesPro_SendEmail')) {
    return;
}

trait AffiliatePagesPro_SendEmail
{
	// optional pre config

	protected $send_email_to;

	protected $send_email_subject;

	protected $send_email_body;

	protected $send_email_from_email;

	protected $send_email_from_name;

	protected $send_email_custom_fields;

	protected $send_email_subject_custom_fields;

	protected $send_email_headers;

	protected $send_email_from_attachements;

	protected $send_email_format;

	protected $send_email_options = [
									'to', 
									'subject', 
									'body', 
									'from_email', 
									'from_name', 
									'custom_fields', 
									'subject_custom_fields', // defaults to custom
									'headers', 
									'attachements',
									'format'
								];

	public function sendEmailConfig($argsOrOption, $value='')
	{
		if(!is_array($argsOrOption)) {
			$key = 'send_email_'.$argsOrOption;
			$this->{$key} = $value;
		}
		else {

			foreach($argsOrOption as $key => $value) {
				$key = 'send_email_'.$key;
				$this->{$key} = $value;
			}

		}
		
	}

	/**
	 * send email. You can set recepient email by to as string or option, alternatively it will find it from your custom fields if set. 
	 * @param  string, array $to     can be email or config settings
	 * @param  string $subject       [description]
	 * @param  string $body          [description]
	 * @param  string $from_email    [description]
	 * @param  string $from_name     [description]
	 * @param  array  $custom_fields [description]
	 * @param  [type] $headers       [description]
	 * @param  string $format        [description]
	 * @return [type]                [description]
	 */
	public function sendEmail($toOrArgs, $subject='', $body='', $from_email = '', $from_name = '', $custom_fields = [], $subject_custom_fields = null, $headers=null, $attachements = null, $format='auto') {


		if(is_array($toOrArgs)) {

			$this->sendEmailConfig($toOrArgs);
			
			if(!empty($toOrArgs['to'])) {
				$to = $toOrArgs['to'];
			} elseif(!empty($this->send_email_custom_fields) && !empty($this->send_email_custom_fields['email'])) {
				$to = $this->send_email_custom_fields['email'];
			} else {
				return; // no one to send email to
			}

		} else {
			
			$to = $toOrArgs;
		
		}

		foreach($this->send_email_options as $option) {
			$key = 'send_email_'.$option;
			if(empty($$option) && !empty($this->{$key})) {
				$$option = $this->{$key};
			}
		}


		if(is_array($body)) {
			// send seperate html and text
		}

		if(empty($from_email)) {
			$from_email = get_bloginfo('admin_email');
		}		

		if(empty($from_name)) {
			$from_name = get_bloginfo('name');
		}			
		
		$subject = stripcslashes($subject);
		$body = stripcslashes($body);

		if(!empty($custom_fields)) {

			$body = $this->sendEmailCustomise($body, $custom_fields);
			if(!empty($subject_custom_fields)) {
				$subject = $this->sendEmailCustomise($subject, $subject_custom_fields);
			} else {
				$subject = $this->sendEmailCustomise($subject, $custom_fields);
			}
		}

		if(empty($headers)) {

			$headers = '';

			if($format == 'auto') {
				if(strstr($body, '</') == false) {
					$body = $this->sendEmailFormatLinks($body);
					
				}
			}

			// if($format == 'html') {	
			$headers .= "MIME-Version: 1.0" . "\r\n";	
			$headers .= "Content-type: text/html; charset=".get_bloginfo('charset')."" . "\r\n";
			// }

			$headers .= "From: ".$from_name." <".$from_email.">" . "\r\n";
		}

		// echo $headers; exit;

		// wp_send_json([$subject, $body]); exit;

		// wp_send_json(['to' => $to, 'custom_fields' => $custom_fields, 'headers' => $headers, 'from_email' => $from_email, 'from_name' => $from_name]); exit;

		// echo 'email ready to send: '.$headers; exit;

		return wp_mail($to, $subject, $body, $headers);

	}

	public function sendEmailFormatLinks($body) {

		$rows = explode(PHP_EOL, $body);
		
		$body = '';
		
		foreach($rows as $row) {

			// autolink
			if(strstr($row,'://') == true) {
				$words = explode(' ',$row);

				$row = '';
				
				foreach($words as $word) {

					if(strstr($word,'://') == true) {
						$prepend = '';
						$append = '';
						$link = trim($word);

						// prepend
						foreach(['"', "'", '(', ')', '[', ']', '{', '}'] as $start) {
							if(substr($link, 0, 1) == $start) {
								$link = ltrim($link, $start);
								$prepend .= $start;
							}
						}

						// append
						foreach(['.', ',', '"', '"', '(', ')', '[', ']', '{', '}'] as $end) {
							if(substr($link, -1) == $end) {
								$link = rtrim($link, $end);
								$append .= $end;
							}
						}
						

						$word = $prepend.'<a href="'.$link.'">'.$link.'</a>'.$append;
					}
					$row .= $word.' ';
				}
			}
			$body .= $row.'<br>';
		}
		
		return $body;
	}

	public function sendEmailCustomise($str, $args)
	{
		if(empty($args)) {
			return $str;
		}

		//wp_send_json([$str, $args]);// exit;

		foreach($args as $key => $value) {
			
			$str = str_replace('{'.$key.'}', $value, $str);
		}

		return $str;
	}
}