<?php

if(trait_exists('AffiliatePagesPro_Sessions')) {
    return;
}

/**
 * getSession(), setSession(), removeSession(), clear(), key(), keys() or length()
 */

trait AffiliatePagesPro_Sessions
{
	protected $session_started = false;

	public function sessionStart()
	{		
		if(!session_id()) {
			session_start();
		}
		$this->session_started = true;
	}

	public function sessionEnd()
	{
		if(!$this->session_started) {
			$this->sessionStart();
		}
		session_destroy();
		$this->session_started = false;
	}

	public function setSession($key, $value=1, $returnValue=true)
	{
		$key = $this->getSessionKey($key);

		$_SESSION[$key] = $value;

		if($returnValue) {
			return $value;
		}
	}

	public function getSessionRemove($key, $default=null) {
		$value = $this->getSession($key, $default);
		$this->removeSession($key);
		return $value;
	}
	
	public function getSession($key, $default=null)
	{
		$key = $this->getSessionKey($key);

		if(isset($_SESSION[$key])) {
			return $_SESSION[$key];
		}

		return $default;
	}

	public function removeSession($key) 
	{
		$key = $this->getSessionKey($key);
		if(isset($_SESSION[$key])) {
			unset($_SESSION[$key]);
		}
	}


	public function sessionExists($key)
	{
		$key = $this->getSessionKey($key);

		return isset($_SESSION[$key]);
	}

	private function getSessionKey($key)
	{	
		// always gets called so best place to check
		if(!$this->session_started) {
			$this->sessionStart();
		}

		return self::$plugin_app_id.'_'.$key;
	}

	public function sessionGetAlerts() {

		 if($this->sessionExists('error')) {
		 	$this->sessionAlert('error');
		}

		 if($this->sessionExists('success')) {
		 	$this->sessionAlert('success');
		}

		 if($this->sessionExists('info')) {
		 	$this->sessionAlert('info');
		}

	}

	public function sessionAlert($type='info') {

		echo '<article class="message is-'.$type.'">
			  <div class="message-body">
			   '.$this->getSessionRemove($type).'
			  </div>
			</article>';
	}

}