<?php

if(trait_exists('AffiliatePagesPro_StrGen')) {
    return;
}

trait AffiliatePagesPro_StrGen
{

	public function strGen($length = 6, $lower=false)
    {
        $str = "";
		$characters = array_merge(range('A','Z'), range('a','z'), range('0','9'));
		$max = count($characters) - 1;
		for ($i = 0; $i < $length; $i++) {
			$rand = mt_rand(0, $max);
			$str .= $characters[$rand];
		}
		if($lower) {
			$str = strtolower($str);
		}
		return $str;
    }
    
    /**
     * @param  integer, minimum 14
     * @return unique str
     */
    public function strGenUnique($length = 255)
    {

    	$str = uniqid(true);

        if($length >= strlen($str)) {
    		$str .= $this->strGen(($length - strlen($str)), true);
    	} elseif($length < strlen($str)) {
            return substr($str, (strlen($str)-$length)); 
        }
    	return $str;
    }

    public function strGenPass($length = 9, $add_dashes = false, $available_sets = 'luds')
    {
        $sets = [];
        if(strpos($available_sets, 'l') !== false)
            $sets[] = 'abcdefghjkmnpqrstuvwxyz';
        if(strpos($available_sets, 'u') !== false)
            $sets[] = 'ABCDEFGHJKMNPQRSTUVWXYZ';
        if(strpos($available_sets, 'd') !== false)
            $sets[] = '23456789';
        if(strpos($available_sets, 's') !== false)
            $sets[] = '!@#$%&*?';
        $all = '';
        $password = '';
        foreach($sets as $set)
        {
            $password .= $set[array_rand(str_split($set))];
            $all .= $set;
        }
        $all = str_split($all);
        for($i = 0; $i < $length - count($sets); $i++)
            $password .= $all[array_rand($all)];
        $password = str_shuffle($password);
        if(!$add_dashes)
            return $password;
        $dash_len = floor(sqrt($length));
        $dash_str = '';
        while(strlen($password) > $dash_len)
        {
            $dash_str .= substr($password, 0, $dash_len) . '-';
            $password = substr($password, $dash_len);
        }
        $dash_str .= $password;
        return $dash_str;
    }

}