<?php

if(trait_exists('AffiliatePagesPro_Tables')) {
    return;
}

trait AffiliatePagesPro_Tables
{
	public function tableOptions($args=[]) 
	{	
		if(empty($args)) {
			return;
		}

		if(!isset($this->table_options)) {
			$this->table_options = [];
		}

		foreach($args as $key => $value) {
			$this->table_options[$key] = $value;
		}
	}
	
	public function table($items=null, $fields=null) 
	{
		if(empty($items)) {
			$items = $this->items;
		}

		if(empty($items)) {
			return;			
		}

		if(empty($fields)) {
			$fields = $this->table_fields;
		}

		echo '<table><thead><tr>';

		foreach($fields as $field) {
			echo '<th>';
			$this->tableHeader($field);
			echo '</th>';
		}
		
		echo '</tr></thead><tbody>';
		foreach($items as $item) {
			echo '<tr>';
			foreach($fields as $field) {
				echo '<td>';
			
				$this->tableCol($item, $field);
				
				echo '</td>';
			}
			echo '</tr>';
		}
		echo '</table>';
	}

	public function tableHeader($col='') {
		echo ucfirst($col);
	}

	public function tableCol($item, $field) {

		if($this->tableOptionContains('link_cols', $field)) {

			$id = $this->tableGetItemId($item);

			echo '<a href="'.$this->UrlAppend($this->current_url, ['id' => $id]).'">';
		}

		if(in_array($field, ['updated'])) {

			if(is_object($item)) {
				echo (!empty($item->{$field}) ? human_time_diff(strtotime($item->{$field})) : '');
			} else {
				echo (!empty($item[$field]) ? human_time_diff(strtotime($item[$field])) : '');
			}

		}
		else {

			if(is_object($item)) {
				echo (!empty($item->{$field}) ? $item->{$field} : '');
			} else {
				echo (!empty($item[$field]) ? $item[$field] : '');
			}

		}
	
		if($this->tableOptionContains('link_cols', $field)) {
			echo '</a>';
		}

	}

	public function tableGetItemId($item)
	{
		if(is_object($item)) {
			return (!empty($item->id) ? $item->id : '');
		} else {
			return (!empty($item['id']) ? $item['id'] : '');
		}
	}

	public function tableOptionContains($option, $value) {
		return ($this->tableOptionSet($option) && in_array($value, $this->table_options[$option]));
	}

	public function tableOptionSet($option) {
		return (isset($this->table_options) == true && isset($this->table_options[$option]) == true);
	}	
}