<?php

if(trait_exists('AffiliatePagesPro_UserAlerts')) {
    return;
}

trait AffiliatePagesPro_UserAlerts
{
	public function createSuccess($msg) {
		$this->createAlert($msg, 'success');
	}

	public function getSuccess($del=true) {
		return $this->getAlert();
	}

	public function isSuccess($del=true) {
		return $this->alertExists('success', $del);
	}

	public function createError($msg) {
		$this->createAlert($msg, 'error');
	}

	public function getError() {
		// echo 'get error'; exit;
		return $this->getAlert('error');
	}

	public function isError($del=true) {
		// echo 'isError error '.$this->alertExists('error'); exit;
		return $this->alertExists('error', $del);
	}

	public function alertExists($type='success', $del=true) {

		if(isset($this->alerts_catch[$type])) {
			return $this->alerts_catch[$type];
		}

		$key = $this->getAlertKey($type);

		$msg = get_user_meta(get_current_user_id(), $key, true);

		$this->alerts_catch[$type] = $msg;

		if(!empty($del)) {
			delete_user_meta(get_current_user_id(), $key);
		}
		

		return !empty($msg);
	}

	public function createAlert($msg, $type='success') {

		$key = $this->getAlertKey($type);

		$this->alerts_catch[$type] = $msg;

		update_user_meta(get_current_user_id(), $key, $msg);

	}

	public function getAlert($type='success', $del=true) {

		if(!empty($this->alerts_catch) && isset($this->alerts_catch[$type]) == true) {
			return $this->alerts_catch[$type];
		}

		$key = $this->getAlertKey($type);

		$msg = get_user_meta(get_current_user_id(), $key, true);

		if(!empty($del)) {
			delete_user_meta(get_current_user_id(), $key);
			echo 'deleted '.$key; exit;
		}
		else {
			$this->alerts_catch[$type] = $msg;
		}

		return $msg;

	}

	public function getAlertKey($type='success') {
		return self::$plugin_app_id.'_alert_'.$type;
	}



}