<?php

affiliate_pages_pro_use([
	'Core/Model',
	'Models/Stat'
	// 'Core/Time',
	// 'Models/Click',
	// 'Models/Tag'
]);


class AffiliatePagesPro_Block extends AffiliatePagesPro_Model
{

	protected $table = 'blocks';

	protected $use_app_id = true;

	protected $use_no_sort = true;

	protected $filleble = [

		// 'id',
		'identifier',
		'user_id',
		'page_id',

		'block_type',
		'type_id',
		'video_id',

		'title',
		'des',
		'content',

		'clicks',

		'sort',

		'video',
		'is_video',
		'start',
		'end',
		'autoplay',
		'hide_controls', // 0: no, 1: yes, 2: muted
		'poster',// (0: autohide, 1: always, 2: never )
		'poster_pause',
		'poster_end',
		'duration',
		'trim_active',
		'product_placement',
		'muted',
		'product_img',
		'auto_redirect',
		'disable_fullscreen',
		'disable_mask',

		'url',
		'target',
		'is_dark',
		'color',
		'style',
		'item_style',
		'size',
		'item_link',

		'margin',
		'margin_x',
		'margin_y',
		'padding',
		'use_margin',
		'use_padding',
		'text_color',
		'shadow',
		'item_shadow',
		'bg_color',
		'bg_image',
		'source',

		'flex_xs',
		'flex_sm',
		'flex_md',
		'flex_lg',
		'align',

		'item_height',
		'item_width',
		'item_contain',
		'aspect_ratio',
		'custom_size',

		'is_split',
		'split_id',
		'split_index',

		// v1.0.4
		'schedule_timezone',
		'schedule_start',
    'schedule_startdate',
    'schedule_starttime',
    'schedule_startu',
    'schedule_end',
    'schedule_enddate',
    'schedule_endtime',
    'schedule_endu',

		'item_timezone',
		'item_start',
		'item_startdate',
		'item_starttime',
		'item_startu',

		'border_radius',
		'title_color',
		'color2',
		'spacing_x',
		'spacing_y',

		'item_end',
		'item_enddate',
		'item_endtime',
		'item_endu',
		'hide_ended',
		'item_borderradius',
		'expanded',
		'show_more',
		'left_icon',
		'left_iconcolor',
		'right_icon',
		'right_iconcolor',
		'item_block'
	];

	public function onCreate() {
		$this->identifier = 'blo'.uniqid(true);
	}

	public function addCount($name, $save=false) {

		if(!is_array($name)) {
			$name = [$name];
		}

		foreach($name as $na) {
			$key = $na.'_count';
			if(empty($this->{$key})) {
				$this->{$key} = 1;
			} else {
				$this->{$key}++;
			}
		}

		if($save) {
			$this->save();
		}
	}

	// real video current time
	public function getProgress($currentTime=0, $returnPercent=true)
	{
		// $prog = $currentTime;

		if(!empty($this->trim_active) && !empty($this->start)) {
			$currentTime = $currentTime - $this->start;
		}

		$dur = $this->getDuration();

		$prog = ($currentTime / $dur);

		if($returnPercent) {
			return ceil($prog * 100);
		}

		return $prog;

	}


	public function getDuration()
	{
		if(empty($this->duration)) {
			return 0;
		}

		$dur = $this->duration;

		if(!empty($this->trim_active) && !empty($this->start)) {
			$dur = $dur - $this->start;
		}

		if(!empty($this->trim_active) && !empty($this->end)) {
			$dur = $dur - ($this->duration - $this->end);
		}

		return $dur;
}


	public function getEmbedId($createdLimit=null, $clientIp=null)
	{
		if(empty($clientIp)) {
			$clientIp = affiliate_pages_pro_get_client_ip();
		}

		$stat = AffiliatePagesPro_Stat::where('client_ip', $clientIp)
					->andWhere('video_id', $this->id);

		if($createdLimit) {
			$createdLimit = current_time('U') - $createdLimit;
			$stat->andWhere('created_ts', '>', $createdLimit);
		}

		$stat->first(['identifier']);

		if(empty($stat->identifier)) {
			$stat->client_ip = $clientIp;
			$stat->video_id = $this->id;
			$stat->save();
		}

		return $stat->identifier;
	}




}
