<?php

affiliate_pages_pro_use([
	'Core/Model',
	'Models/Block',
	'Models/Visit',
	'Models/Click',
  'Models/Stat',
]);


class AffiliatePagesPro_Page extends AffiliatePagesPro_Model
{

	protected $table = 'pages';

	protected $use_app_id = true;

	protected $filleble = [

		// 'id',
		'identifier',
		'user_id',
		'page_type',
		'title',
		'des',
		'image',
		'favicon',
		'theme_base',
		'affiliate_link',
		'affiliate_dash',
		'theme_color',
		'text_color',
		'is_dark',
		'bg_color',
		'bg_image',
		'bg_imagefx',
		'bg_imageblur',

		'spacing_x',
		'spacing_y',

		'og_title',
		'og_des',
		'og_keywords',
		'og_img',
		'og_imgw',
		'og_imgh',
		'slug',

		'visits',
		'visits_unique',
		'clicks',
		'clicks_unique',

		'tracking_active',
		'tracking_header',
		'tracking_footer',
		'tracking_analytics',
		'tracking_fbpixel',

		// video fields
		'is_active',
		// 'status',
		// 'countdown'

		'padding_x',
		'padding_y',
		'margin',
		'margin_x',
		'margin_y',

		'padding',
		'shadow',
		// 'item_shadow',

		'content_bg',

		'footer_active',
		'footer_color',
		'footer_menu',
		'footer_facebook',
		'footer_twitter',
		'footer_linkedin',
		'footer_instagram',
		'footer_youtube',
		'footer_content',
		'cookies_notice',

		'topbar_active',
		'topbar_color',
		'topbar_textcolor',
		'topbar_title',
		'topbar_logo',
		'topbar_name',
		'topbar_avatar',
		'topbar_shadow',
		'topbar_namelink',
		'topbar_avatarlink',
		'topbar_social',

		'topbar_linktitle',
		'topbar_logolink',
		'topbar_flat',
		'max_width',
		'use_width',

		// advanced
		'epc',

		// v1.0.4
		'border_radius',

		// v1.0.10
		'no_index',

		// v.1.0.11
		'bg_video',
		'bg_mask'
	];

	public function onCreate() {
		$this->identifier = 'pag'.uniqid(true);
	}

	public function blocks()
	{

		return $this->hasMany('Block', null, 'sort');
	}

	public function addClick($visit, $expire = 86400)
	{
		$client_ip = affiliate_pages_pro_get_client_ip();

		// $query = AffiliatePagesPro_Click::where('page_id', $this->id);

		$visit = AffiliatePagesPro_Visit::where('identifier', $visit)->first(['id']);

		if($visit) {
			$visit->clicked = 1;
			$visit->save();
		}
		else {
			return;
		}

		$u = current_time('U');

		$query = AffiliatePagesPro_Click::where('page_id', $this->id)
																			->andWhere('client_ip', $client_ip)
																			->andWhere('is_unique', 1)
																			->andWhere('created_ts', '>', ($u - $expire));

		// if($expire) {
		// 	$u = current_time('U');
		// 	$query->andWhere('created_ts', '>', ($u - $expire));
		// }

		$exists = $query->first(['id']);

		$click = new AffiliatePagesPro_Click;
		$click->page_id = $this->id;
		$click->created_ts = $u;
		$click->visit_id = $visit->id;
		$click->client_ip = $client_ip;
		$click->is_unique = empty($exists);

		// page visit
		if(empty($this->clicks)) {
			$this->clicks = 1;
		} else {
			$this->clicks++;
		}

		// unique
		if(!empty($click->is_unique)) {
			if(empty($this->clicks_unique)) {
				$this->clicks_unique = 1;
			} else {
				$this->clicks_unique++;
			}
		}

		$this->save();

		return $click->save();
	}

	public function addVisit()
	{

		$client_ip = affiliate_pages_pro_get_client_ip();

		// in the last 24 hours
		$u = current_time('U');

		$query = AffiliatePagesPro_Visit::where('page_id', $this->id)
																			->andWhere('client_ip', $client_ip)
																			->andWhere('is_unique', 1)
																			->andWhere('created_ts', '>', ($u - 86400));

		$exists = $query->first(['id']);

		$visit = new AffiliatePagesPro_Visit;
		$visit->page_id = $this->id;
		$visit->created_ts = $u;
		$visit->client_ip = $client_ip;
		$visit->is_unique = empty($exists);

		// page visit
		if(empty($this->visits)) {
			$this->visits = 1;
		} else {
			$this->visits++;
		}
		// unique
		if(!empty($visit->is_unique)) {
			if(empty($this->visits_unique)) {
				$this->visits_unique = 1;
			} else {
				$this->visits_unique++;
			}
		}

		$this->save();

		$visit->save();

		return $visit;
	}

}
