<?php

/**
 * use gen, val, clear($user)
 * Append User to end of token
 * @var [type]
 */
affiliate_pages_pro_use([
	'Core/Model',
  'Helpers/StrGen'
]);

class AffiliatePagesPro_Auth extends AffiliatePagesPro_Model
{
  use AffiliatePagesPro_StrGen;

  protected $table = 'auth';

	protected $use_app_id = true;

	protected $use_datetime = false;

	protected $filleble = [

		'token',
    'user_id',
    'created'
	];


	// get if exists, else create
	public static function userGet($user_id=null)
	{
		if(empty($user_id)) {
      $user_id = get_current_user_ID();
    }

		$token = self::where('user_id', $user_id)->first();

		if(!empty($token)) {
			return $token->token.'-'.$user_id;
			wp_send_json($token); exit;
		}

		return self::userGen($user_id, false);

	}

  // generate

  public static function userGen($user_id=null, $clearOldUsers=true)
  {
    if(empty($user_id)) {
      $user_id = get_current_user_ID();
    }

    return self::gen($user_id, $clearOldUsers).'-'.$user_id;
  }

  public static function gen($user_id=null, $clearOldUsers=true)
  {
    if(!empty($user_id) && !empty($clearOldUsers)) {
      self::clear($user_id);
    }
    return (new static)->generate($user_id);
  }


  // validate returns age by mins

  public static function userVal($token, $user_id=null, $delete=false, $returnAge=false) {

    if(empty($user_id) && !empty($_GET['user_id'])) {
      $user_id = $_GET['user_id'];
    }
    elseif(empty($user_id)) {
      $user_id = get_current_user_ID();
    }

    if(empty($user_id)) {
      return false;
    }

    return self::val($token, $user_id, $delete, $returnAge);

   }

  public static function val($token, $user_id=null, $delete=false, $returnAge=false)
  {
    $auth = self::where('token', $token);
    if(!empty($user_id)) {
      $auth->andWhere('user_id', $user_id);
    }

    $match = $auth->first();

    if(empty($match)) {
      return false;
    }

    // validate expired
    if($returnAge) {
      return (floor((current_time('U') - $match->created) / 60));
    }

    return true;
  }

  // clear user tokens
  public static function clear($user_id)
  {
    self::where('user_id', $user_id)->deleteAll();
  }

  public function onCreate()
  {
    $this->created = current_time('U');
    $this->token = $this->strGenUnique(64);
  }

  private function generate($user_id)
  {
    if(!empty($user_id)) {
      $this->user_id = $user_id;
    }
    $this->save();

    return $this->token;
  }
}
