<?php
affiliate_pages_pro_use([
  'Core/Shortcode',
  'Helpers/Routes'
]);


class AffiliatePagesPro_VideoShortcode extends AffiliatePagesPro_Shortcode
{
  use AffiliatePagesPro_Routes;

  protected $id = 'affiliate_pages_pro';

  protected $default_args = [
    'id' => '',
    'shadow' => '', // 0px 0px 3px 1px rgba(0,0,0,0.1)
    'border' => 'solid 11px red',
    'marginTop' => 0, 'marginBottom' => 20,
    'ratio' => '16/9',
    'footerStyle' => 'padding:8px;color:#9e9e9e;font-size:14px;background:#000000;font-family:Roboto,sans-serif'];

  public function doShortcode($atts)
  {

    $video = AffiliatePagesPro_Video::where('identifier', $atts['id'])->first(['footer', 'footer_active', 'disable_banner', 'banner_color', 'style_pop']);

    if(empty($video)) {
      return;
    }

    $id = $atts['id'];
    $url = $this->route('embed/'.$id);

    $ratio = explode('/',$atts['ratio']);
    $ratio = ($ratio[1] / $ratio[0])*100;

    $bannerHeight = 64;

    if(!empty($video->disable_banner)) {
      $bannerHeight = 0;//'64';
    }

    if(!empty($atts['border'])) {
      $atts['border'] = 'border:'.$atts['border'];
    }

    $shadow = '';



    $ws = 'width: 100%;max-width: 100%;min-width:300px;margin:auto;clear:both;margin-bottom:'.$atts['marginBottom'].'px;margin-top:'.$atts['marginTop'].'px;';

    if(!empty($video->style_pop)) {
      $ws .= '-webkit-box-shadow: 1px 1px 5px 0px rgba(0,0,0,0.5);-moz-box-shadow: 1px 1px 5px 0px rgba(0,0,0,0.5);';

      if($video->style_pop == 1) {
        $ws .= 'border: solid 2px #fff;';
      }
      elseif($video->style_pop == 2) {
        $ws .= 'border: solid 2px #1c1c1c;';
      }
      if($video->style_pop == 3 && !empty($video->banner_color)) {
        $ws .= 'border: solid 2px '.$video->banner_color.';';
      }
    }


    $cs = 'position: relative;padding-bottom: '.$ratio.'%;padding-top:0px;overflow: hidden;border:none;padding-top:'.$bannerHeight.'px';
    $is = 'position: absolute;top: 0;left: 0;width: 100%;height: 100%; padding:0px; margin: 0px';
    $iAt = 'frameborder="0" allowfullscreen="true" webkitallowfullscreen="true" mozallowfullscreen="true" scrolling="no" allow="autoplay; fullscreen"';


    $footer = '';

    if(!empty($video->footer_active)) {
      $footer = '<div id="'.$id.'_f" style="'.$atts['footerStyle'].'">'.$video->footer.'</div>';
    }

    $content =
      '<div id="'.$id.'_w" style="'.$ws.'">'.
        '<div id="'.$id.'_c" style="'.$cs.'">'.
          '<iframe id="'.$id.'_i" src="'.$url.'" style="'.$is.'" '.$iAt.'>'.
          '</iframe>'.
        '</div>'.
        str_replace('\\', '', $footer).

    '</div>';

    // echo htmlspecialchars($content); exit;

    $content .= '<script>'.$this->getScript($id).'</script>';

    return $content;

    wp_send_json($atts['id']);
  }

  private function getScript($id) {

    return "
    (function() {
			document.getElementById('{$id}_i').src = document.getElementById('{$id}_i').src+'#/pageurl='+encodeURIComponent(window.location.href)
    })();";

  }
}
