<?php

// options
AffiliatePagesPro::setOptions(get_option(AffiliatePagesPro::$plugin_app_id . '_settings'));

// Load helpers
require plugin_dir_path(__FILE__) . '../app/helpers.php';

// set info
AffiliatePagesPro::setInfo(affiliate_pages_pro_info());

// Cores
affiliate_pages_pro_use([
    'Core/Model',
    'Core/Router',
    'Core/Request',
]);

affiliate_pages_pro_ini(['Events/Logout', 'Events/PluginsPage', 'Events/PluginEditorPage']);

affiliate_pages_pro_que_actions([
    'admin_menu',
    'wp',
]);

// activation hook
register_activation_hook(AffiliatePagesPro::$plugin_app_file, function () {
    affiliate_pages_pro_ini('Controllers/Activation/ActivationController');
});
register_deactivation_hook(AffiliatePagesPro::$plugin_app_file, function () {
    affiliate_pages_pro_ini('Controllers/Activation/DeactivationController');
});

// router
add_action('parse_request', function () {
    require (plugin_dir_path(__FILE__) . '../routes/web.php');
    require (plugin_dir_path(__FILE__) . '../routes/api.php');
});

// update v2
if (is_admin()) {
    $update_url = AffiliatePagesPro::$plugin_app_host . '/api/client/app/' . AffiliatePagesPro::$plugin_app_cl . '/update/update.json';
    $app_file   = AffiliatePagesPro::$plugin_app_file;
    $app_id     = AffiliatePagesPro::$plugin_app_id;
    affiliate_pages_pro_use('../vendor/update-checker/load-v4p8');
    $myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
        $update_url,
        $app_file,
        $app_id
    );

}
