<?php


class AffiliatePagesPro_DB_Blocks extends AffiliatePagesPro_Migration
{
	protected $table = 'blocks';

	protected $use_group_id = false;

	public function up()
	{
		$this->increments('id')

		->string('identifier', 25)->unique() // becomes plugin id

		->integer('user_id', 13)->unsigned()->nullable() // created by
		->integer('page_id', 13)->unsigned()->nullable()
		->string('block_type', 255)->nullable() // col_3. col_2, col_1
		->integer('type_id', 13)->unsigned()->nullable() // video id

		// types
		->integer('video_id', 13)->unsigned()->nullable()

		->string('title', 255)->nullable()
    ->string('des', 500)->nullable()

		->text('content')->nullable()

		->integer('sort', 13)->nullable()
		->integer('clicks', 13)->nullable()


		->boolean('banner_bottom')->nullable()
		->boolean('button_time')->nullable()
		->boolean('button_time_active')->nullable()
		->boolean('disable_fullscreen')->nullable()
		->boolean('disable_mask')->nullable()

		// VIDEO
		->boolean('is_video')->nullable()
		->string('video', 255)->nullable()
		->integer('start', 13)->nullable()
		->integer('end', 13)->nullable()
		->integer('autoplay', 2)->nullable() // 0: no, 1: yes, 2: muted
		->integer('hide_controls', 2)->nullable() // (0: autohide, 1: always, 2: never )
		->string('poster', 255)->nullable()
		->boolean('poster_pause')->nullable()
		->boolean('poster_end')->nullable()
		->integer('duration', 13)->nullable()
		->boolean('trim_active')->nullable()
		->string('product_placement', 100)->nullable()
		->boolean('muted')->nullable()
		->string('product_img', 255)->nullable()
		->boolean('auto_redirect')->nullable()


		// Additional
		->string('url', 255)->nullable()
		->string('target', 25)->nullable()
		->string('color', 25)->nullable()
		->boolean('is_dark')->nullable()
		->string('style', 255)->nullable() // ??
		->string('item_style', 255)->nullable()
		->string('item_link', 255)->nullable()
		->string('size', 25)->nullable()

		// styling
		->integer('margin', 13)->nullable()
		->integer('padding', 13)->nullable()
		->boolean('use_margin')->nullable()
		->boolean('use_padding')->nullable()
		->integer('margin_x', 13)->nullable()
		->integer('margin_y', 13)->nullable()
		->integer('padding_x', 13)->nullable()
		->integer('padding_y', 13)->nullable()
		->integer('shadow', 13)->nullable()
		->integer('item_shadow', 13)->nullable()

		->string('text_color', 25)->nullable()
		->string('bg_color', 25)->nullable()
		->string('bg_image', 255)->nullable()


		->integer('item_height', 13)->nullable()
		->integer('item_width', 13)->nullable()
		->boolean('item_contain')->nullable()
		->decimal('aspect_ratio', 6, 3)->nullable()
		->boolean('custom_size')->nullable()

		->string('source', 255)->nullable()

		->integer('flex_xs', 1)->nullable()
		->integer('flex_sm', 1)->nullable()
		->integer('flex_md', 1)->nullable()
		->integer('flex_lg', 1)->nullable()
		->string('align', 25)->nullable()

		->boolean('is_split')->nullable()
		->integer('split_id', 13)->unsigned()->nullable()
		->integer('split_index', 13)->nullable()


		->timestamps()

		->create();

	}

	public function addColumns()
	{
		return [
			self::stringUpdate('schedule_timezone', 25),
			self::booleanUpdate('schedule_start'),
			self::stringUpdate('schedule_startdate', 25),
			self::stringUpdate('schedule_starttime', 25),
			self::stringUpdate('schedule_startu', 13),
			self::booleanUpdate('schedule_end'),
			self::stringUpdate('schedule_enddate', 25),
			self::stringUpdate('schedule_endtime', 25),
			self::stringUpdate('schedule_endu', 13),

			self::stringUpdate('item_timezone', 25),
			self::booleanUpdate('item_start'),
			self::stringUpdate('item_startdate', 25),
			self::stringUpdate('item_starttime', 25),
			self::stringUpdate('item_startu', 13),

			self::booleanUpdate('item_end'),
			self::stringUpdate('item_enddate', 25),
			self::stringUpdate('item_endtime', 25),
			self::stringUpdate('item_endu', 13),

			self::stringUpdate('border_radius', 25),
			self::stringUpdate('item_borderradius', 25),
			self::stringUpdate('title_color', 25),
			self::stringUpdate('color2', 25),
			self::integerUpdate('spacing_x', 25),
			self::integerUpdate('spacing_y', 25),
			self::booleanUpdate('hide_ended'),
			self::booleanUpdate('expanded'),
			self::booleanUpdate('show_more'),
			self::stringUpdate('left_icon', 100),
			self::stringUpdate('left_iconcolor', 100),
			self::stringUpdate('right_icon', 100),
			self::stringUpdate('right_iconcolor', 100),
			self::booleanUpdate('item_block'),
		];
	}

	public function down()
	{
		$this->dropIfExists();
	}
}
