<?php


class AffiliatePagesPro_DB_Pages extends AffiliatePagesPro_Migration
{
	protected $table = 'pages';

	protected $use_group_id = false;

	public function up()
	{
		$this->increments('id')

		->string('identifier', 25)->unique() // becomes plugin id

		->integer('user_id', 13)->unsigned()->nullable() // created by
		->string('title', 255)->nullable()
    ->string('des', 255)->nullable()
		->string('page_type', 255)->nullable()
		->string('image', 255)->nullable()
		->string('favicon', 255)->nullable()

		->string('affiliate_link', 255)->nullable()
		->string('affiliate_dash', 255)->nullable()
		// ->string('product', 255)->nullable()
		// ->text('product_data')->nullable()
		// ->string('url', 255)->nullable()
		->string('theme_base', 25)->nullable()
		->string('theme_color', 25)->nullable()
		->string('text_color', 25)->nullable()
		->boolean('is_dark')->nullable()
		->string('bg_color', 25)->nullable()
		->string('bg_image', 255)->nullable()
		->string('bg_imagefx', 255)->nullable()
		->string('bg_imageblur', 25)->nullable()


		->integer('spacing_x', 13)->nullable()
		->integer('spacing_y', 13)->nullable()

		->string('og_title', 255)->nullable()
		->string('og_des', 255)->nullable()
		->string('og_keywords', 255)->nullable()
		->string('og_img', 255)->nullable()
		->integer('og_imgw', 13)->nullable()
		->integer('og_imgh', 13)->nullable()
		->string('slug', 200)->nullable()

		->integer('visits', 13)->nullable()
		->integer('visits_unique', 13)->nullable()

		->integer('clicks', 13)->nullable()
		->integer('clicks_unique', 13)->nullable()

		->boolean('tracking_active')->nullable()
		->text('tracking_header')->nullable()
		->text('tracking_footer')->nullable()

		->string('tracking_analytics', 100)->nullable()
		->string('tracking_fbpixel', 100)->nullable()


		->integer('margin', 13)->nullable()
		->integer('padding', 13)->nullable()
		->integer('shadow', 13)->nullable()
		->integer('padding_x', 13)->nullable()
		->integer('padding_y', 13)->nullable()
		->integer('margin_x', 13)->nullable()
		->integer('margin_y', 13)->nullable()

		->string('content_bg', 255)->nullable()

		->boolean('footer_active')->nullable()
		->string('footer_color', 25)->nullable()
		->string('footer_menu', 255)->nullable()
		->boolean('footer_facebook')->nullable()
		->boolean('footer_twitter')->nullable()
		->boolean('footer_linkedin')->nullable()
		->boolean('footer_instagram')->nullable()
		->boolean('footer_youtube')->nullable()
		->text('footer_content')->nullable()
		->boolean('cookies_notice')->nullable()

		->boolean('topbar_active')->nullable()
		->string('topbar_color', 25)->nullable()
		->string('topbar_textcolor', 25)->nullable()
		->string('topbar_title', 255)->nullable()

		->string('topbar_name', 255)->nullable()
		->string('topbar_avatar', 255)->nullable()
		->integer('topbar_shadow', 13)->nullable()
		->string('topbar_avatarlink', 255)->nullable()
		->string('topbar_namelink', 255)->nullable()
		->boolean('topbar_social')->nullable()
		->boolean('topbar_linktitle')->nullable()
		->boolean('topbar_flat')->nullable()

		->string('topbar_logo', 255)->nullable()
		->string('topbar_logolink', 255)->nullable()

		->boolean('is_active')->nullable()

		->decimal('epc', 7, 2)->nullable()
		->integer('max_width', 13)->nullable()
		->boolean('use_width')->nullable()

		->timestamps()

		->create();

	}

	public function addColumns()
	{
		return [
			self::stringUpdate('schedule_timezone', 25),
			self::booleanUpdate('schedule_start'),
			self::stringUpdate('schedule_startdate', 25),
			self::stringUpdate('schedule_starttime', 25),
			self::stringUpdate('schedule_startu', 13),
			self::booleanUpdate('schedule_end'),
			self::stringUpdate('schedule_enddate', 25),
			self::stringUpdate('schedule_endtime', 25),
			self::stringUpdate('schedule_endu', 13),
			self::stringUpdate('redirect_start', 13),
			self::stringUpdate('redirect_end', 13),
			self::stringUpdate('border_radius', 25),
			self::booleanUpdate('no_index'),
			self::stringUpdate('bg_video', 255),
			self::booleanUpdate('bg_mask'),

		];
	}

	public function down()
	{
		$this->dropIfExists();
	}
}
