<?php

if(!empty($page->no_index)) {
  echo '<meta name="robots" content="noindex"><meta name="googlebot" content="noindex">';
}

// open head
echo '<!DOCTYPE html><html lang="en"><head>';

// meta
echo '<meta charset="utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge" /><meta name="viewport" content="width=device-width,initial-scale=1.0" />';

// title
echo '<title>';
echo !empty($page->title) ? $page->title : 'something else...';
echo '</title>';

// favicon
if(!empty($page->favicon)) {
  echo "<link rel=\"icon\" href=\"{$page->favicon}\" />";
}

// open graph
require(plugin_dir_path(__FILE__).'og.php');

$css = '';

// background color
if(!empty($page->bg_color)) {
  $css .= 'body, html { background-color: '.$page->bg_color.'} ';
}
if(!empty($page->bg_imagefx)) {
$css .= '
#ml_bg_image {
  filter:brightness(50%) blur(4px) grayscale(25%);
  -webkit-filter: brightness(50%) blur(4px) grayscale(25%);
}';
}

if(!empty($css))  {
  echo "<style>{$css}</style>";
}

if(!empty($cdn)) {
  if(!empty($cdn['css'])) {
    foreach($cdn['css'] as $i) {
      echo "<link rel=\"stylesheet\" href=\"{$i}\" />";
    }
  }
  if(!empty($cdn['js'])) {
    foreach($cdn['js'] as $i) {
      echo "<script src=\"{$i}\"></script>";
    }
  }
}

// public files
if(empty(self::$debug) || empty($this->dev_path)) {
  affiliate_pages_pro_embed_css(['/live/css/chunk-vendors', '/live/css/app']);
}


if(!empty($page->tracking_fbpixel)) {
  AffiliatePagesPro_Tracking::fbPixel($page->tracking_fbpixel);
}

// google analytics
if(!empty($page->tracking_analytics)) {
  AffiliatePagesPro_Tracking::googleAnalytics($page->tracking_analytics);
}

// custom header tracking
if(!empty($page->tracking_header)) {
  AffiliatePagesPro_Tracking::html($page->tracking_header);
}


echo '</head><body>';

// body content
echo '<div id="app"';
foreach($data as $key => $value) {
  echo " data-{$key}=\"{$value}\"";
  echo "\n";
}
echo '></div>';

// public files
if(empty(self::$debug) || empty($this->dev_path)) {
  affiliate_pages_pro_embed_js(['/live/js/chunk-vendors', '/live/js/app']);
} else {
  affiliate_pages_pro_embed_js($this->dev_path.'/app.js');
}




// custom footer tracking
if(!empty($page->tracking_footer)) {
  AffiliatePagesPro_Tracking::html($page->tracking_footer);
}

// close body
echo '</body></html>';
